/*============================================================================
  File:     TestHarness_Sparse_VARCHAR.sql

  SQL Server Versions: 2008 onwards
------------------------------------------------------------------------------
  Written by Erin Stellato, SQLskills.com
  
  (c) 2016, SQLskills.com. All rights reserved.

  For more scripts and sample code, check out 
    http://www.SQLskills.com

  You may alter this code for your own *non-commercial* purposes. You may
  republish altered code as long as you include this copyright and give due
  credit, but you must obtain prior permission before blogging this code.
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

USE [master];
GO

SET NOCOUNT ON;

/*
	START TEST NonSparseInsertAll
*/
CREATE DATABASE [SparseTest]
 CONTAINMENT = NONE
 ON  PRIMARY 
( NAME = N'SparseTest', FILENAME = N'M:\Data\Sparse\SparseTest.mdf' , SIZE = 102400MB , FILEGROWTH = 524288KB )
 LOG ON 
( NAME = N'SparseTest_log', FILENAME = N'M:\Data\Sparse\SparseTest_log.ldf' , SIZE = 1048576KB , FILEGROWTH = 524288KB )
GO
ALTER DATABASE [SparseTest] SET RECOVERY SIMPLE 
GO

USE [SparseTest];
GO

CREATE TABLE [NonSparseInsertAll] (
	[ID] INT IDENTITY, [Name] VARCHAR (100), [Type] INT,
	[c4] VARCHAR(255) NULL, [c5] VARCHAR(255) NULL, [c6] VARCHAR(255) NULL, [c7] VARCHAR(255) NULL, [c8] VARCHAR(255) NULL, [c9] VARCHAR(255) NULL,	[c10] VARCHAR(255) NULL, [c11] VARCHAR(255) NULL, [c12] VARCHAR(255) NULL, [c13] VARCHAR(255) NULL, [c14] VARCHAR(255) NULL, [c15] VARCHAR(255) NULL, [c16] VARCHAR(255) NULL, [c17] VARCHAR(255) NULL, [c18] VARCHAR(255) NULL, [c19] VARCHAR(255) NULL,	[c20] VARCHAR(255) NULL, [c21] VARCHAR(255) NULL, [c22] VARCHAR(255) NULL, [c23] VARCHAR(255) NULL, [c24] VARCHAR(255) NULL, [c25] VARCHAR(255) NULL, [c26] VARCHAR(255) NULL, [c27] VARCHAR(255) NULL, [c28] VARCHAR(255) NULL, [c29] VARCHAR(255) NULL,	[c30] VARCHAR(255) NULL, [c31] VARCHAR(255) NULL, [c32] VARCHAR(255) NULL, [c33] VARCHAR(255) NULL, [c34] VARCHAR(255) NULL, [c35] VARCHAR(255) NULL, [c36] VARCHAR(255) NULL, [c37] VARCHAR(255) NULL, [c38] VARCHAR(255) NULL, [c39] VARCHAR(255) NULL,	[c40] VARCHAR(255) NULL, [c41] VARCHAR(255) NULL, [c42] VARCHAR(255) NULL, [c43] VARCHAR(255) NULL, [c44] VARCHAR(255) NULL, [c45] VARCHAR(255) NULL, [c46] VARCHAR(255) NULL, [c47] VARCHAR(255) NULL, [c48] VARCHAR(255) NULL, [c49] VARCHAR(255) NULL,	[c50] VARCHAR(255) NULL, [c51] VARCHAR(255) NULL, [c52] VARCHAR(255) NULL, [c53] VARCHAR(255) NULL, [c54] VARCHAR(255) NULL, [c55] VARCHAR(255) NULL, [c56] VARCHAR(255) NULL, [c57] VARCHAR(255) NULL, [c58] VARCHAR(255) NULL, [c59] VARCHAR(255) NULL,	[c60] VARCHAR(255) NULL, [c61] VARCHAR(255) NULL, [c62] VARCHAR(255) NULL, [c63] VARCHAR(255) NULL, [c64] VARCHAR(255) NULL, [c65] VARCHAR(255) NULL, [c66] VARCHAR(255) NULL, [c67] VARCHAR(255) NULL, [c68] VARCHAR(255) NULL, [c69] VARCHAR(255) NULL,	[c70] VARCHAR(255) NULL, [c71] VARCHAR(255) NULL, [c72] VARCHAR(255) NULL, [c73] VARCHAR(255) NULL, [c74] VARCHAR(255) NULL, [c75] VARCHAR(255) NULL, [c76] VARCHAR(255) NULL, [c77] VARCHAR(255) NULL, [c78] VARCHAR(255) NULL, [c79] VARCHAR(255) NULL,	[c80] VARCHAR(255) NULL, [c81] VARCHAR(255) NULL, [c82] VARCHAR(255) NULL, [c83] VARCHAR(255) NULL, [c84] VARCHAR(255) NULL, [c85] VARCHAR(255) NULL, [c86] VARCHAR(255) NULL, [c87] VARCHAR(255) NULL, [c88] VARCHAR(255) NULL, [c89] VARCHAR(255) NULL,	[c90] VARCHAR(255) NULL, [c91] VARCHAR(255) NULL, [c92] VARCHAR(255) NULL, [c93] VARCHAR(255) NULL, [c94] VARCHAR(255) NULL, [c95] VARCHAR(255) NULL, [c96] VARCHAR(255) NULL, [c97] VARCHAR(255) NULL, [c98] VARCHAR(255) NULL, [c99] VARCHAR(255) NULL,
	[c100] VARCHAR(255) NULL, [c101] VARCHAR(255) NULL, [c102] VARCHAR(255) NULL, [c103] VARCHAR(255) NULL, [c104] VARCHAR(255) NULL, [c105] VARCHAR(255) NULL, [c106] VARCHAR(255) NULL, [c107] VARCHAR(255) NULL, [c108] VARCHAR(255) NULL, [c109] VARCHAR(255) NULL,	[c110] VARCHAR(255) NULL, [c111] VARCHAR(255) NULL, [c112] VARCHAR(255) NULL, [c113] VARCHAR(255) NULL, [c114] VARCHAR(255) NULL, [c115] VARCHAR(255) NULL, [c116] VARCHAR(255) NULL, [c117] VARCHAR(255) NULL, [c118] VARCHAR(255) NULL, [c119] VARCHAR(255) NULL,	[c120] VARCHAR(255) NULL, [c121] VARCHAR(255) NULL, [c122] VARCHAR(255) NULL, [c123] VARCHAR(255) NULL, [c124] VARCHAR(255) NULL, [c125] VARCHAR(255) NULL, [c126] VARCHAR(255) NULL, [c127] VARCHAR(255) NULL, [c128] VARCHAR(255) NULL, [c129] VARCHAR(255) NULL,	[c130] VARCHAR(255) NULL, [c131] VARCHAR(255) NULL, [c132] VARCHAR(255) NULL, [c133] VARCHAR(255) NULL, [c134] VARCHAR(255) NULL, [c135] VARCHAR(255) NULL, [c136] VARCHAR(255) NULL, [c137] VARCHAR(255) NULL, [c138] VARCHAR(255) NULL, [c139] VARCHAR(255) NULL,	[c140] VARCHAR(255) NULL, [c141] VARCHAR(255) NULL, [c142] VARCHAR(255) NULL, [c143] VARCHAR(255) NULL, [c144] VARCHAR(255) NULL, [c145] VARCHAR(255) NULL, [c146] VARCHAR(255) NULL, [c147] VARCHAR(255) NULL, [c148] VARCHAR(255) NULL, [c149] VARCHAR(255) NULL,	[c150] VARCHAR(255) NULL, [c151] VARCHAR(255) NULL, [c152] VARCHAR(255) NULL, [c153] VARCHAR(255) NULL, [c154] VARCHAR(255) NULL, [c155] VARCHAR(255) NULL, [c156] VARCHAR(255) NULL, [c157] VARCHAR(255) NULL, [c158] VARCHAR(255) NULL, [c159] VARCHAR(255) NULL,	[c160] VARCHAR(255) NULL, [c161] VARCHAR(255) NULL, [c162] VARCHAR(255) NULL, [c163] VARCHAR(255) NULL, [c164] VARCHAR(255) NULL, [c165] VARCHAR(255) NULL, [c166] VARCHAR(255) NULL, [c167] VARCHAR(255) NULL, [c168] VARCHAR(255) NULL, [c169] VARCHAR(255) NULL,	[c170] VARCHAR(255) NULL, [c171] VARCHAR(255) NULL, [c172] VARCHAR(255) NULL, [c173] VARCHAR(255) NULL, [c174] VARCHAR(255) NULL, [c175] VARCHAR(255) NULL, [c176] VARCHAR(255) NULL, [c177] VARCHAR(255) NULL, [c178] VARCHAR(255) NULL, [c179] VARCHAR(255) NULL,	[c180] VARCHAR(255) NULL, [c181] VARCHAR(255) NULL, [c182] VARCHAR(255) NULL, [c183] VARCHAR(255) NULL, [c184] VARCHAR(255) NULL, [c185] VARCHAR(255) NULL, [c186] VARCHAR(255) NULL, [c187] VARCHAR(255) NULL, [c188] VARCHAR(255) NULL, [c189] VARCHAR(255) NULL,	[c190] VARCHAR(255) NULL, [c191] VARCHAR(255) NULL, [c192] VARCHAR(255) NULL, [c193] VARCHAR(255) NULL, [c194] VARCHAR(255) NULL, [c195] VARCHAR(255) NULL, [c196] VARCHAR(255) NULL, [c197] VARCHAR(255) NULL, [c198] VARCHAR(255) NULL, [c199] VARCHAR(255) NULL,
	[c200] VARCHAR(255) NULL, [c201] VARCHAR(255) NULL, [c202] VARCHAR(255) NULL, [c203] VARCHAR(255) NULL, [c204] VARCHAR(255) NULL, [c205] VARCHAR(255) NULL, [c206] VARCHAR(255) NULL, [c207] VARCHAR(255) NULL, [c208] VARCHAR(255) NULL, [c209] VARCHAR(255) NULL,	[c210] VARCHAR(255) NULL, [c211] VARCHAR(255) NULL, [c212] VARCHAR(255) NULL, [c213] VARCHAR(255) NULL, [c214] VARCHAR(255) NULL, [c215] VARCHAR(255) NULL, [c216] VARCHAR(255) NULL, [c217] VARCHAR(255) NULL, [c218] VARCHAR(255) NULL, [c219] VARCHAR(255) NULL,	[c220] VARCHAR(255) NULL, [c221] VARCHAR(255) NULL, [c222] VARCHAR(255) NULL, [c223] VARCHAR(255) NULL, [c224] VARCHAR(255) NULL, [c225] VARCHAR(255) NULL, [c226] VARCHAR(255) NULL, [c227] VARCHAR(255) NULL, [c228] VARCHAR(255) NULL, [c229] VARCHAR(255) NULL,	[c230] VARCHAR(255) NULL, [c231] VARCHAR(255) NULL, [c232] VARCHAR(255) NULL, [c233] VARCHAR(255) NULL, [c234] VARCHAR(255) NULL, [c235] VARCHAR(255) NULL, [c236] VARCHAR(255) NULL, [c237] VARCHAR(255) NULL, [c238] VARCHAR(255) NULL, [c239] VARCHAR(255) NULL,	[c240] VARCHAR(255) NULL, [c241] VARCHAR(255) NULL, [c242] VARCHAR(255) NULL, [c243] VARCHAR(255) NULL, [c244] VARCHAR(255) NULL, [c245] VARCHAR(255) NULL, [c246] VARCHAR(255) NULL, [c247] VARCHAR(255) NULL, [c248] VARCHAR(255) NULL, [c249] VARCHAR(255) NULL,	[c250] VARCHAR(255) NULL, [c251] VARCHAR(255) NULL, [c252] VARCHAR(255) NULL, [c253] VARCHAR(255) NULL, [c254] VARCHAR(255) NULL, [c255] VARCHAR(255) NULL, [c256] VARCHAR(255) NULL, [c257] VARCHAR(255) NULL, [c258] VARCHAR(255) NULL, [c259] VARCHAR(255) NULL,	[c260] VARCHAR(255) NULL, [c261] VARCHAR(255) NULL, [c262] VARCHAR(255) NULL, [c263] VARCHAR(255) NULL, [c264] VARCHAR(255) NULL, [c265] VARCHAR(255) NULL, [c266] VARCHAR(255) NULL, [c267] VARCHAR(255) NULL, [c268] VARCHAR(255) NULL, [c269] VARCHAR(255) NULL,	[c270] VARCHAR(255) NULL, [c271] VARCHAR(255) NULL, [c272] VARCHAR(255) NULL, [c273] VARCHAR(255) NULL, [c274] VARCHAR(255) NULL, [c275] VARCHAR(255) NULL, [c276] VARCHAR(255) NULL, [c277] VARCHAR(255) NULL, [c278] VARCHAR(255) NULL, [c279] VARCHAR(255) NULL,	[c280] VARCHAR(255) NULL, [c281] VARCHAR(255) NULL, [c282] VARCHAR(255) NULL, [c283] VARCHAR(255) NULL, [c284] VARCHAR(255) NULL, [c285] VARCHAR(255) NULL, [c286] VARCHAR(255) NULL, [c287] VARCHAR(255) NULL, [c288] VARCHAR(255) NULL, [c289] VARCHAR(255) NULL,	[c290] VARCHAR(255) NULL, [c291] VARCHAR(255) NULL, [c292] VARCHAR(255) NULL, [c293] VARCHAR(255) NULL, [c294] VARCHAR(255) NULL, [c295] VARCHAR(255) NULL, [c296] VARCHAR(255) NULL, [c297] VARCHAR(255) NULL, [c298] VARCHAR(255) NULL, [c299] VARCHAR(255) NULL,
	[c300] VARCHAR(255) NULL, [c301] VARCHAR(255) NULL, [c302] VARCHAR(255) NULL, [c303] VARCHAR(255) NULL, [c304] VARCHAR(255) NULL, [c305] VARCHAR(255) NULL, [c306] VARCHAR(255) NULL, [c307] VARCHAR(255) NULL, [c308] VARCHAR(255) NULL, [c309] VARCHAR(255) NULL,	[c310] VARCHAR(255) NULL, [c311] VARCHAR(255) NULL, [c312] VARCHAR(255) NULL, [c313] VARCHAR(255) NULL, [c314] VARCHAR(255) NULL, [c315] VARCHAR(255) NULL, [c316] VARCHAR(255) NULL, [c317] VARCHAR(255) NULL, [c318] VARCHAR(255) NULL, [c319] VARCHAR(255) NULL,	[c320] VARCHAR(255) NULL, [c321] VARCHAR(255) NULL, [c322] VARCHAR(255) NULL, [c323] VARCHAR(255) NULL, [c324] VARCHAR(255) NULL, [c325] VARCHAR(255) NULL, [c326] VARCHAR(255) NULL, [c327] VARCHAR(255) NULL, [c328] VARCHAR(255) NULL, [c329] VARCHAR(255) NULL,	[c330] VARCHAR(255) NULL, [c331] VARCHAR(255) NULL, [c332] VARCHAR(255) NULL, [c333] VARCHAR(255) NULL, [c334] VARCHAR(255) NULL, [c335] VARCHAR(255) NULL, [c336] VARCHAR(255) NULL, [c337] VARCHAR(255) NULL, [c338] VARCHAR(255) NULL, [c339] VARCHAR(255) NULL,	[c340] VARCHAR(255) NULL, [c341] VARCHAR(255) NULL, [c342] VARCHAR(255) NULL, [c343] VARCHAR(255) NULL, [c344] VARCHAR(255) NULL, [c345] VARCHAR(255) NULL, [c346] VARCHAR(255) NULL, [c347] VARCHAR(255) NULL, [c348] VARCHAR(255) NULL, [c349] VARCHAR(255) NULL,	[c350] VARCHAR(255) NULL, [c351] VARCHAR(255) NULL, [c352] VARCHAR(255) NULL, [c353] VARCHAR(255) NULL, [c354] VARCHAR(255) NULL, [c355] VARCHAR(255) NULL, [c356] VARCHAR(255) NULL, [c357] VARCHAR(255) NULL, [c358] VARCHAR(255) NULL, [c359] VARCHAR(255) NULL,	[c360] VARCHAR(255) NULL, [c361] VARCHAR(255) NULL, [c362] VARCHAR(255) NULL, [c363] VARCHAR(255) NULL, [c364] VARCHAR(255) NULL, [c365] VARCHAR(255) NULL, [c366] VARCHAR(255) NULL, [c367] VARCHAR(255) NULL, [c368] VARCHAR(255) NULL, [c369] VARCHAR(255) NULL,	[c370] VARCHAR(255) NULL, [c371] VARCHAR(255) NULL, [c372] VARCHAR(255) NULL, [c373] VARCHAR(255) NULL, [c374] VARCHAR(255) NULL, [c375] VARCHAR(255) NULL, [c376] VARCHAR(255) NULL, [c377] VARCHAR(255) NULL, [c378] VARCHAR(255) NULL, [c379] VARCHAR(255) NULL,	[c380] VARCHAR(255) NULL, [c381] VARCHAR(255) NULL, [c382] VARCHAR(255) NULL, [c383] VARCHAR(255) NULL, [c384] VARCHAR(255) NULL, [c385] VARCHAR(255) NULL, [c386] VARCHAR(255) NULL, [c387] VARCHAR(255) NULL, [c388] VARCHAR(255) NULL, [c389] VARCHAR(255) NULL,	[c390] VARCHAR(255) NULL, [c391] VARCHAR(255) NULL, [c392] VARCHAR(255) NULL, [c393] VARCHAR(255) NULL, [c394] VARCHAR(255) NULL, [c395] VARCHAR(255) NULL, [c396] VARCHAR(255) NULL, [c397] VARCHAR(255) NULL, [c398] VARCHAR(255) NULL, [c399] VARCHAR(255) NULL,
	[c400] VARCHAR(255) NULL, [c401] VARCHAR(255) NULL, [c402] VARCHAR(255) NULL, [c403] VARCHAR(255) NULL, [c404] VARCHAR(255) NULL, [c405] VARCHAR(255) NULL, [c406] VARCHAR(255) NULL, [c407] VARCHAR(255) NULL, [c408] VARCHAR(255) NULL, [c409] VARCHAR(255) NULL,	[c410] VARCHAR(255) NULL, [c411] VARCHAR(255) NULL, [c412] VARCHAR(255) NULL, [c413] VARCHAR(255) NULL, [c414] VARCHAR(255) NULL, [c415] VARCHAR(255) NULL, [c416] VARCHAR(255) NULL, [c417] VARCHAR(255) NULL, [c418] VARCHAR(255) NULL, [c419] VARCHAR(255) NULL,	[c420] VARCHAR(255) NULL, [c421] VARCHAR(255) NULL, [c422] VARCHAR(255) NULL, [c423] VARCHAR(255) NULL, [c424] VARCHAR(255) NULL, [c425] VARCHAR(255) NULL, [c426] VARCHAR(255) NULL, [c427] VARCHAR(255) NULL, [c428] VARCHAR(255) NULL, [c429] VARCHAR(255) NULL,	[c430] VARCHAR(255) NULL, [c431] VARCHAR(255) NULL, [c432] VARCHAR(255) NULL, [c433] VARCHAR(255) NULL, [c434] VARCHAR(255) NULL, [c435] VARCHAR(255) NULL, [c436] VARCHAR(255) NULL, [c437] VARCHAR(255) NULL, [c438] VARCHAR(255) NULL, [c439] VARCHAR(255) NULL,	[c440] VARCHAR(255) NULL, [c441] VARCHAR(255) NULL, [c442] VARCHAR(255) NULL, [c443] VARCHAR(255) NULL, [c444] VARCHAR(255) NULL, [c445] VARCHAR(255) NULL, [c446] VARCHAR(255) NULL, [c447] VARCHAR(255) NULL, [c448] VARCHAR(255) NULL, [c449] VARCHAR(255) NULL,	[c450] VARCHAR(255) NULL, [c451] VARCHAR(255) NULL, [c452] VARCHAR(255) NULL, [c453] VARCHAR(255) NULL, [c454] VARCHAR(255) NULL, [c455] VARCHAR(255) NULL, [c456] VARCHAR(255) NULL, [c457] VARCHAR(255) NULL, [c458] VARCHAR(255) NULL, [c459] VARCHAR(255) NULL,	[c460] VARCHAR(255) NULL, [c461] VARCHAR(255) NULL, [c462] VARCHAR(255) NULL, [c463] VARCHAR(255) NULL, [c464] VARCHAR(255) NULL, [c465] VARCHAR(255) NULL, [c466] VARCHAR(255) NULL, [c467] VARCHAR(255) NULL, [c468] VARCHAR(255) NULL, [c469] VARCHAR(255) NULL,	[c470] VARCHAR(255) NULL, [c471] VARCHAR(255) NULL, [c472] VARCHAR(255) NULL, [c473] VARCHAR(255) NULL, [c474] VARCHAR(255) NULL, [c475] VARCHAR(255) NULL, [c476] VARCHAR(255) NULL, [c477] VARCHAR(255) NULL, [c478] VARCHAR(255) NULL, [c479] VARCHAR(255) NULL,	[c480] VARCHAR(255) NULL, [c481] VARCHAR(255) NULL, [c482] VARCHAR(255) NULL, [c483] VARCHAR(255) NULL, [c484] VARCHAR(255) NULL, [c485] VARCHAR(255) NULL, [c486] VARCHAR(255) NULL, [c487] VARCHAR(255) NULL, [c488] VARCHAR(255) NULL, [c489] VARCHAR(255) NULL,	[c490] VARCHAR(255) NULL, [c491] VARCHAR(255) NULL, [c492] VARCHAR(255) NULL, [c493] VARCHAR(255) NULL, [c494] VARCHAR(255) NULL, [c495] VARCHAR(255) NULL, [c496] VARCHAR(255) NULL, [c497] VARCHAR(255) NULL, [c498] VARCHAR(255) NULL, [c499] VARCHAR(255) NULL,
	[c500] VARCHAR(255) NULL, [c501] VARCHAR(255) NULL, [c502] VARCHAR(255) NULL, [c503] VARCHAR(255) NULL, [c504] VARCHAR(255) NULL, [c505] VARCHAR(255) NULL, [c506] VARCHAR(255) NULL, [c507] VARCHAR(255) NULL, [c508] VARCHAR(255) NULL, [c509] VARCHAR(255) NULL,	[c510] VARCHAR(255) NULL, [c511] VARCHAR(255) NULL, [c512] VARCHAR(255) NULL, [c513] VARCHAR(255) NULL, [c514] VARCHAR(255) NULL, [c515] VARCHAR(255) NULL, [c516] VARCHAR(255) NULL, [c517] VARCHAR(255) NULL, [c518] VARCHAR(255) NULL, [c519] VARCHAR(255) NULL,	[c520] VARCHAR(255) NULL, [c521] VARCHAR(255) NULL, [c522] VARCHAR(255) NULL, [c523] VARCHAR(255) NULL, [c524] VARCHAR(255) NULL, [c525] VARCHAR(255) NULL, [c526] VARCHAR(255) NULL, [c527] VARCHAR(255) NULL, [c528] VARCHAR(255) NULL, [c529] VARCHAR(255) NULL,	[c530] VARCHAR(255) NULL, [c531] VARCHAR(255) NULL, [c532] VARCHAR(255) NULL, [c533] VARCHAR(255) NULL, [c534] VARCHAR(255) NULL, [c535] VARCHAR(255) NULL, [c536] VARCHAR(255) NULL, [c537] VARCHAR(255) NULL, [c538] VARCHAR(255) NULL, [c539] VARCHAR(255) NULL,	[c540] VARCHAR(255) NULL, [c541] VARCHAR(255) NULL, [c542] VARCHAR(255) NULL, [c543] VARCHAR(255) NULL, [c544] VARCHAR(255) NULL, [c545] VARCHAR(255) NULL, [c546] VARCHAR(255) NULL, [c547] VARCHAR(255) NULL, [c548] VARCHAR(255) NULL, [c549] VARCHAR(255) NULL,	[c550] VARCHAR(255) NULL, [c551] VARCHAR(255) NULL, [c552] VARCHAR(255) NULL, [c553] VARCHAR(255) NULL, [c554] VARCHAR(255) NULL, [c555] VARCHAR(255) NULL, [c556] VARCHAR(255) NULL, [c557] VARCHAR(255) NULL, [c558] VARCHAR(255) NULL, [c559] VARCHAR(255) NULL,	[c560] VARCHAR(255) NULL, [c561] VARCHAR(255) NULL, [c562] VARCHAR(255) NULL, [c563] VARCHAR(255) NULL, [c564] VARCHAR(255) NULL, [c565] VARCHAR(255) NULL, [c566] VARCHAR(255) NULL, [c567] VARCHAR(255) NULL, [c568] VARCHAR(255) NULL, [c569] VARCHAR(255) NULL,	[c570] VARCHAR(255) NULL, [c571] VARCHAR(255) NULL, [c572] VARCHAR(255) NULL, [c573] VARCHAR(255) NULL, [c574] VARCHAR(255) NULL, [c575] VARCHAR(255) NULL, [c576] VARCHAR(255) NULL, [c577] VARCHAR(255) NULL, [c578] VARCHAR(255) NULL, [c579] VARCHAR(255) NULL,	[c580] VARCHAR(255) NULL, [c581] VARCHAR(255) NULL, [c582] VARCHAR(255) NULL, [c583] VARCHAR(255) NULL, [c584] VARCHAR(255) NULL, [c585] VARCHAR(255) NULL, [c586] VARCHAR(255) NULL, [c587] VARCHAR(255) NULL, [c588] VARCHAR(255) NULL, [c589] VARCHAR(255) NULL,	[c590] VARCHAR(255) NULL, [c591] VARCHAR(255) NULL, [c592] VARCHAR(255) NULL, [c593] VARCHAR(255) NULL, [c594] VARCHAR(255) NULL, [c595] VARCHAR(255) NULL, [c596] VARCHAR(255) NULL, [c597] VARCHAR(255) NULL, [c598] VARCHAR(255) NULL, [c599] VARCHAR(255) NULL,
	[c600] VARCHAR(255) NULL, [c601] VARCHAR(255) NULL, [c602] VARCHAR(255) NULL, [c603] VARCHAR(255) NULL, [c604] VARCHAR(255) NULL, [c605] VARCHAR(255) NULL, [c606] VARCHAR(255) NULL, [c607] VARCHAR(255) NULL, [c608] VARCHAR(255) NULL, [c609] VARCHAR(255) NULL,	[c610] VARCHAR(255) NULL, [c611] VARCHAR(255) NULL, [c612] VARCHAR(255) NULL, [c613] VARCHAR(255) NULL, [c614] VARCHAR(255) NULL, [c615] VARCHAR(255) NULL, [c616] VARCHAR(255) NULL, [c617] VARCHAR(255) NULL, [c618] VARCHAR(255) NULL, [c619] VARCHAR(255) NULL,	[c620] VARCHAR(255) NULL, [c621] VARCHAR(255) NULL, [c622] VARCHAR(255) NULL, [c623] VARCHAR(255) NULL, [c624] VARCHAR(255) NULL, [c625] VARCHAR(255) NULL, [c626] VARCHAR(255) NULL, [c627] VARCHAR(255) NULL, [c628] VARCHAR(255) NULL, [c629] VARCHAR(255) NULL,	[c630] VARCHAR(255) NULL, [c631] VARCHAR(255) NULL, [c632] VARCHAR(255) NULL, [c633] VARCHAR(255) NULL, [c634] VARCHAR(255) NULL, [c635] VARCHAR(255) NULL, [c636] VARCHAR(255) NULL, [c637] VARCHAR(255) NULL, [c638] VARCHAR(255) NULL, [c639] VARCHAR(255) NULL,	[c640] VARCHAR(255) NULL, [c641] VARCHAR(255) NULL, [c642] VARCHAR(255) NULL, [c643] VARCHAR(255) NULL, [c644] VARCHAR(255) NULL, [c645] VARCHAR(255) NULL, [c646] VARCHAR(255) NULL, [c647] VARCHAR(255) NULL, [c648] VARCHAR(255) NULL, [c649] VARCHAR(255) NULL,	[c650] VARCHAR(255) NULL, [c651] VARCHAR(255) NULL, [c652] VARCHAR(255) NULL, [c653] VARCHAR(255) NULL, [c654] VARCHAR(255) NULL, [c655] VARCHAR(255) NULL, [c656] VARCHAR(255) NULL, [c657] VARCHAR(255) NULL, [c658] VARCHAR(255) NULL, [c659] VARCHAR(255) NULL,	[c660] VARCHAR(255) NULL, [c661] VARCHAR(255) NULL, [c662] VARCHAR(255) NULL, [c663] VARCHAR(255) NULL, [c664] VARCHAR(255) NULL, [c665] VARCHAR(255) NULL, [c666] VARCHAR(255) NULL, [c667] VARCHAR(255) NULL, [c668] VARCHAR(255) NULL, [c669] VARCHAR(255) NULL,	[c670] VARCHAR(255) NULL, [c671] VARCHAR(255) NULL, [c672] VARCHAR(255) NULL, [c673] VARCHAR(255) NULL, [c674] VARCHAR(255) NULL, [c675] VARCHAR(255) NULL, [c676] VARCHAR(255) NULL, [c677] VARCHAR(255) NULL, [c678] VARCHAR(255) NULL, [c679] VARCHAR(255) NULL,	[c680] VARCHAR(255) NULL, [c681] VARCHAR(255) NULL, [c682] VARCHAR(255) NULL, [c683] VARCHAR(255) NULL, [c684] VARCHAR(255) NULL, [c685] VARCHAR(255) NULL, [c686] VARCHAR(255) NULL, [c687] VARCHAR(255) NULL, [c688] VARCHAR(255) NULL, [c689] VARCHAR(255) NULL,	[c690] VARCHAR(255) NULL, [c691] VARCHAR(255) NULL, [c692] VARCHAR(255) NULL, [c693] VARCHAR(255) NULL, [c694] VARCHAR(255) NULL, [c695] VARCHAR(255) NULL, [c696] VARCHAR(255) NULL, [c697] VARCHAR(255) NULL, [c698] VARCHAR(255) NULL, [c699] VARCHAR(255) NULL,
	[c700] VARCHAR(255) NULL, [c701] VARCHAR(255) NULL, [c702] VARCHAR(255) NULL, [c703] VARCHAR(255) NULL, [c704] VARCHAR(255) NULL, [c705] VARCHAR(255) NULL, [c706] VARCHAR(255) NULL, [c707] VARCHAR(255) NULL, [c708] VARCHAR(255) NULL, [c709] VARCHAR(255) NULL,	[c710] VARCHAR(255) NULL, [c711] VARCHAR(255) NULL, [c712] VARCHAR(255) NULL, [c713] VARCHAR(255) NULL, [c714] VARCHAR(255) NULL, [c715] VARCHAR(255) NULL, [c716] VARCHAR(255) NULL, [c717] VARCHAR(255) NULL, [c718] VARCHAR(255) NULL, [c719] VARCHAR(255) NULL,	[c720] VARCHAR(255) NULL, [c721] VARCHAR(255) NULL, [c722] VARCHAR(255) NULL, [c723] VARCHAR(255) NULL, [c724] VARCHAR(255) NULL, [c725] VARCHAR(255) NULL, [c726] VARCHAR(255) NULL, [c727] VARCHAR(255) NULL, [c728] VARCHAR(255) NULL, [c729] VARCHAR(255) NULL,	[c730] VARCHAR(255) NULL, [c731] VARCHAR(255) NULL, [c732] VARCHAR(255) NULL, [c733] VARCHAR(255) NULL, [c734] VARCHAR(255) NULL, [c735] VARCHAR(255) NULL, [c736] VARCHAR(255) NULL, [c737] VARCHAR(255) NULL, [c738] VARCHAR(255) NULL, [c739] VARCHAR(255) NULL,	[c740] VARCHAR(255) NULL, [c741] VARCHAR(255) NULL, [c742] VARCHAR(255) NULL, [c743] VARCHAR(255) NULL, [c744] VARCHAR(255) NULL, [c745] VARCHAR(255) NULL, [c746] VARCHAR(255) NULL, [c747] VARCHAR(255) NULL, [c748] VARCHAR(255) NULL, [c749] VARCHAR(255) NULL,	[c750] VARCHAR(255) NULL, [c751] VARCHAR(255) NULL, [c752] VARCHAR(255) NULL, [c753] VARCHAR(255) NULL, [c754] VARCHAR(255) NULL, [c755] VARCHAR(255) NULL, [c756] VARCHAR(255) NULL, [c757] VARCHAR(255) NULL, [c758] VARCHAR(255) NULL, [c759] VARCHAR(255) NULL,	[c760] VARCHAR(255) NULL, [c761] VARCHAR(255) NULL, [c762] VARCHAR(255) NULL, [c763] VARCHAR(255) NULL, [c764] VARCHAR(255) NULL, [c765] VARCHAR(255) NULL, [c766] VARCHAR(255) NULL, [c767] VARCHAR(255) NULL, [c768] VARCHAR(255) NULL, [c769] VARCHAR(255) NULL,	[c770] VARCHAR(255) NULL, [c771] VARCHAR(255) NULL, [c772] VARCHAR(255) NULL, [c773] VARCHAR(255) NULL, [c774] VARCHAR(255) NULL, [c775] VARCHAR(255) NULL, [c776] VARCHAR(255) NULL, [c777] VARCHAR(255) NULL, [c778] VARCHAR(255) NULL, [c779] VARCHAR(255) NULL,	[c780] VARCHAR(255) NULL, [c781] VARCHAR(255) NULL, [c782] VARCHAR(255) NULL, [c783] VARCHAR(255) NULL, [c784] VARCHAR(255) NULL, [c785] VARCHAR(255) NULL, [c786] VARCHAR(255) NULL, [c787] VARCHAR(255) NULL, [c788] VARCHAR(255) NULL, [c789] VARCHAR(255) NULL,	[c790] VARCHAR(255) NULL, [c791] VARCHAR(255) NULL, [c792] VARCHAR(255) NULL, [c793] VARCHAR(255) NULL, [c794] VARCHAR(255) NULL, [c795] VARCHAR(255) NULL, [c796] VARCHAR(255) NULL, [c797] VARCHAR(255) NULL, [c798] VARCHAR(255) NULL, [c799] VARCHAR(255) NULL,
	[c800] VARCHAR(255) NULL, [c801] VARCHAR(255) NULL, [c802] VARCHAR(255) NULL, [c803] VARCHAR(255) NULL, [c804] VARCHAR(255) NULL, [c805] VARCHAR(255) NULL, [c806] VARCHAR(255) NULL, [c807] VARCHAR(255) NULL, [c808] VARCHAR(255) NULL, [c809] VARCHAR(255) NULL,	[c810] VARCHAR(255) NULL, [c811] VARCHAR(255) NULL, [c812] VARCHAR(255) NULL, [c813] VARCHAR(255) NULL, [c814] VARCHAR(255) NULL, [c815] VARCHAR(255) NULL, [c816] VARCHAR(255) NULL, [c817] VARCHAR(255) NULL, [c818] VARCHAR(255) NULL, [c819] VARCHAR(255) NULL,	[c820] VARCHAR(255) NULL, [c821] VARCHAR(255) NULL, [c822] VARCHAR(255) NULL, [c823] VARCHAR(255) NULL, [c824] VARCHAR(255) NULL, [c825] VARCHAR(255) NULL, [c826] VARCHAR(255) NULL, [c827] VARCHAR(255) NULL, [c828] VARCHAR(255) NULL, [c829] VARCHAR(255) NULL,	[c830] VARCHAR(255) NULL, [c831] VARCHAR(255) NULL, [c832] VARCHAR(255) NULL, [c833] VARCHAR(255) NULL, [c834] VARCHAR(255) NULL, [c835] VARCHAR(255) NULL, [c836] VARCHAR(255) NULL, [c837] VARCHAR(255) NULL, [c838] VARCHAR(255) NULL, [c839] VARCHAR(255) NULL,	[c840] VARCHAR(255) NULL, [c841] VARCHAR(255) NULL, [c842] VARCHAR(255) NULL, [c843] VARCHAR(255) NULL, [c844] VARCHAR(255) NULL, [c845] VARCHAR(255) NULL, [c846] VARCHAR(255) NULL, [c847] VARCHAR(255) NULL, [c848] VARCHAR(255) NULL, [c849] VARCHAR(255) NULL,	[c850] VARCHAR(255) NULL, [c851] VARCHAR(255) NULL, [c852] VARCHAR(255) NULL, [c853] VARCHAR(255) NULL, [c854] VARCHAR(255) NULL, [c855] VARCHAR(255) NULL, [c856] VARCHAR(255) NULL, [c857] VARCHAR(255) NULL, [c858] VARCHAR(255) NULL, [c859] VARCHAR(255) NULL,	[c860] VARCHAR(255) NULL, [c861] VARCHAR(255) NULL, [c862] VARCHAR(255) NULL, [c863] VARCHAR(255) NULL, [c864] VARCHAR(255) NULL, [c865] VARCHAR(255) NULL, [c866] VARCHAR(255) NULL, [c867] VARCHAR(255) NULL, [c868] VARCHAR(255) NULL, [c869] VARCHAR(255) NULL,	[c870] VARCHAR(255) NULL, [c871] VARCHAR(255) NULL, [c872] VARCHAR(255) NULL, [c873] VARCHAR(255) NULL, [c874] VARCHAR(255) NULL, [c875] VARCHAR(255) NULL, [c876] VARCHAR(255) NULL, [c877] VARCHAR(255) NULL, [c878] VARCHAR(255) NULL, [c879] VARCHAR(255) NULL,	[c880] VARCHAR(255) NULL, [c881] VARCHAR(255) NULL, [c882] VARCHAR(255) NULL, [c883] VARCHAR(255) NULL, [c884] VARCHAR(255) NULL, [c885] VARCHAR(255) NULL, [c886] VARCHAR(255) NULL, [c887] VARCHAR(255) NULL, [c888] VARCHAR(255) NULL, [c889] VARCHAR(255) NULL,	[c890] VARCHAR(255) NULL, [c891] VARCHAR(255) NULL, [c892] VARCHAR(255) NULL, [c893] VARCHAR(255) NULL, [c894] VARCHAR(255) NULL, [c895] VARCHAR(255) NULL, [c896] VARCHAR(255) NULL, [c897] VARCHAR(255) NULL, [c898] VARCHAR(255) NULL, [c899] VARCHAR(255) NULL,
	[c900] VARCHAR(255) NULL, [c901] VARCHAR(255) NULL, [c902] VARCHAR(255) NULL, [c903] VARCHAR(255) NULL, [c904] VARCHAR(255) NULL, [c905] VARCHAR(255) NULL, [c906] VARCHAR(255) NULL, [c907] VARCHAR(255) NULL, [c908] VARCHAR(255) NULL, [c909] VARCHAR(255) NULL,	[c910] VARCHAR(255) NULL, [c911] VARCHAR(255) NULL, [c912] VARCHAR(255) NULL, [c913] VARCHAR(255) NULL, [c914] VARCHAR(255) NULL, [c915] VARCHAR(255) NULL, [c916] VARCHAR(255) NULL, [c917] VARCHAR(255) NULL, [c918] VARCHAR(255) NULL, [c919] VARCHAR(255) NULL, 	[c920] VARCHAR(255) NULL, [c921] VARCHAR(255) NULL, [c922] VARCHAR(255) NULL, [c923] VARCHAR(255) NULL, [c924] VARCHAR(255) NULL, [c925] VARCHAR(255) NULL, [c926] VARCHAR(255) NULL, [c927] VARCHAR(255) NULL, [c928] VARCHAR(255) NULL, [c929] VARCHAR(255) NULL,	[c930] VARCHAR(255) NULL, [c931] VARCHAR(255) NULL, [c932] VARCHAR(255) NULL, [c933] VARCHAR(255) NULL, [c934] VARCHAR(255) NULL, [c935] VARCHAR(255) NULL, [c936] VARCHAR(255) NULL, [c937] VARCHAR(255) NULL, [c938] VARCHAR(255) NULL, [c939] VARCHAR(255) NULL,	[c940] VARCHAR(255) NULL, [c941] VARCHAR(255) NULL, [c942] VARCHAR(255) NULL, [c943] VARCHAR(255) NULL, [c944] VARCHAR(255) NULL, [c945] VARCHAR(255) NULL, [c946] VARCHAR(255) NULL, [c947] VARCHAR(255) NULL, [c948] VARCHAR(255) NULL, [c949] VARCHAR(255) NULL,	[c950] VARCHAR(255) NULL, [c951] VARCHAR(255) NULL, [c952] VARCHAR(255) NULL, [c953] VARCHAR(255) NULL, [c954] VARCHAR(255) NULL, [c955] VARCHAR(255) NULL, [c956] VARCHAR(255) NULL, [c957] VARCHAR(255) NULL, [c958] VARCHAR(255) NULL, [c959] VARCHAR(255) NULL,	[c960] VARCHAR(255) NULL, [c961] VARCHAR(255) NULL, [c962] VARCHAR(255) NULL, [c963] VARCHAR(255) NULL, [c964] VARCHAR(255) NULL, [c965] VARCHAR(255) NULL, [c966] VARCHAR(255) NULL, [c967] VARCHAR(255) NULL, [c968] VARCHAR(255) NULL, [c969] VARCHAR(255) NULL,	[c970] VARCHAR(255) NULL, [c971] VARCHAR(255) NULL, [c972] VARCHAR(255) NULL, [c973] VARCHAR(255) NULL, [c974] VARCHAR(255) NULL, [c975] VARCHAR(255) NULL, [c976] VARCHAR(255) NULL, [c977] VARCHAR(255) NULL, [c978] VARCHAR(255) NULL, [c979] VARCHAR(255) NULL,  	[c980] VARCHAR(255) NULL, [c981] VARCHAR(255) NULL, [c982] VARCHAR(255) NULL, [c983] VARCHAR(255) NULL, [c984] VARCHAR(255) NULL, [c985] VARCHAR(255) NULL, [c986] VARCHAR(255) NULL, [c987] VARCHAR(255) NULL, [c988] VARCHAR(255) NULL, [c989] VARCHAR(255) NULL,	[c990] VARCHAR(255) NULL, [c991] VARCHAR(255) NULL, [c992] VARCHAR(255) NULL, [c993] VARCHAR(255) NULL, [c994] VARCHAR(255) NULL, [c995] VARCHAR(255) NULL, [c996] VARCHAR(255) NULL, [c997] VARCHAR(255) NULL, [c998] VARCHAR(255) NULL, [c999] VARCHAR(255) NULL,
	[c1000] VARCHAR(255) NULL);
GO

CREATE CLUSTERED INDEX [NonSparseInsertAll_CL]
	ON [NonSparseInsertAll] ([ID]);
GO

DECLARE @TestID INT;
DECLARE @DBID INT;

DECLARE @RandomValue INT;
DECLARE @Type INT;
DECLARE @NameLength INT;
DECLARE @ColumnStart INT;

DECLARE @RowLoop INT = 1;
DECLARE @ColumnLoop INT;

DECLARE @ExecString VARCHAR (8000);
DECLARE @ExecString2 VARCHAR (8000);

/* Setup test into */

INSERT INTO [SparseTracking].[dbo].[TrackTests] ([TestName]) VALUES ('NonSparseInsertAll');
SELECT @TestID = MAX(TestID) FROM [SparseTracking].[dbo].[TrackTests];
SELECT @DBID = DB_ID();

/* Capture file stats */

IF EXISTS (SELECT * FROM [tempdb].[sys].[objects] WHERE [name] = N'##SQLskillsFileStats1')
  DROP TABLE [##SQLskillsFileStats1];
 
IF EXISTS (SELECT * FROM [tempdb].[sys].[objects] WHERE [name] = N'##SQLskillsFileStats2')
  DROP TABLE [##SQLskillsFileStats2];

SELECT [database_id], [file_id], [sample_ms], [num_of_reads], [num_of_bytes_read], [io_stall_read_ms],
[num_of_writes], [num_of_bytes_written], [io_stall_write_ms], [io_stall]
INTO ##SQLskillsFileStats1
FROM sys.dm_io_virtual_file_stats(@DBID, NULL)


/* Capture wait stats */

IF EXISTS (SELECT * FROM [tempdb].[sys].[objects] WHERE [name] = N'##SQLskillsWaitStats1')
  DROP TABLE [##SQLskillsWaitStats1];
 
IF EXISTS (SELECT * FROM [tempdb].[sys].[objects] WHERE [name] = N'##SQLskillsWaitStats2')
  DROP TABLE [##SQLskillsWaitStats2];

SELECT [wait_type], [waiting_tasks_count], [wait_time_ms],
  [max_wait_time_ms], [signal_wait_time_ms]
INTO ##SQLskillsWaitStats1
FROM sys.dm_os_wait_stats;

/* set start time */
UPDATE [SparseTracking].[dbo].[TrackTests] SET [TestStartTime] = SYSDATETIME() WHERE [TestID] = @TestID;


-- insert all values for [NonSparseInsertAll] table
WHILE (@RowLoop < 10000001) 
BEGIN
	-- Calculate doc name length
	SET @NameLength = CONVERT (INT, RAND () * 100) + 1;
	SET @Type = CONVERT (INT, RAND () * 49) + 1;
	SET @ColumnStart = @Type * 20;

	-- Add the columns we're inserting into
	SELECT @ColumnLoop = @ColumnStart;
	SELECT @ExecString = ' ([Name], [Type], [c' +
		CAST (@ColumnLoop AS VARCHAR);
	SELECT @ColumnLoop = @ColumnLoop + 1;
	WHILE (@ColumnLoop < (@ColumnStart + 20))
	BEGIN
		SELECT @ExecString = @ExecString + '], [c' +
			CAST(@ColumnLoop AS VARCHAR);
		SELECT @ColumnLoop = @ColumnLoop + 1;
	END;
	SELECT @ExecString = @ExecString + ']) VALUES (''';

	-- Add the random document name
	SELECT @ColumnLoop = 0;
	WHILE (@ColumnLoop < @NameLength)
	BEGIN
		SELECT @ExecString = @ExecString + CHAR (97 +
			CONVERT (INT, RAND () * 26));
		SELECT @ColumnLoop = @ColumnLoop + 1;
	END;
		
	-- Add the random column values
	SELECT @ExecString = @ExecString + ''', ' +
		CAST (@Type AS VARCHAR) + ', ' +
			CAST (CONVERT (INT, RAND () * 100000) AS VARCHAR);
		
	SELECT @ColumnLoop = 1;
	WHILE (@ColumnLoop < 20)
	BEGIN
		SELECT @ExecString = @ExecString + ', ' +
			CAST (CONVERT (INT, RAND () * 100000) AS VARCHAR);
		SELECT @ColumnLoop = @ColumnLoop + 1;
	END;
	SELECT @ExecString = @ExecString + ')';

	SELECT @ExecString2 =
		'INSERT INTO [NonSparseInsertAll] ' + @ExecString;
	EXEC (@ExecString2);

	SELECT @RowLoop = @RowLoop + 1;
END;

/* set the stop time */
UPDATE [SparseTracking].[dbo].[TrackTests] SET [TestEndTime] = SYSDATETIME() WHERE [TestID] = @TestID;

/* capture wait stats again */
SELECT [wait_type], [waiting_tasks_count], [wait_time_ms],
  [max_wait_time_ms], [signal_wait_time_ms]
INTO ##SQLskillsWaitStats2
FROM sys.dm_os_wait_stats;

/* capture file stats again */
SELECT [database_id], [file_id], [sample_ms], [num_of_reads], [num_of_bytes_read], [io_stall_read_ms],
[num_of_writes], [num_of_bytes_written], [io_stall_write_ms], [io_stall]
INTO ##SQLskillsFileStats2
FROM sys.dm_io_virtual_file_stats(@DBID, NULL)

/* capture index stats */
INSERT INTO [SparseTracking].[dbo].[IndexStats]
           ([TestID]
           ,[database_id]
           ,[object_id]
           ,[index_id]
           ,[partition_number]
           ,[index_type_desc]
           ,[alloc_unit_type_desc]
           ,[index_depth]
           ,[index_level]
           ,[avg_fragmentation_in_percent]
           ,[fragment_count]
           ,[avg_fragment_size_in_pages]
           ,[page_count]
           ,[avg_page_space_used_in_percent]
           ,[record_count]
           ,[ghost_record_count]
           ,[version_ghost_record_count]
           ,[min_record_size_in_bytes]
           ,[max_record_size_in_bytes]
           ,[avg_record_size_in_bytes]
           ,[forwarded_record_count]
           ,[compressed_page_count])
SELECT @TestID, [database_id],[object_id],[index_id],[partition_number],[index_type_desc],
[alloc_unit_type_desc],[index_depth],[index_level],[avg_fragmentation_in_percent],
[fragment_count],[avg_fragment_size_in_pages],[page_count],[avg_page_space_used_in_percent],
[record_count],[ghost_record_count],[version_ghost_record_count],[min_record_size_in_bytes],
[max_record_size_in_bytes],[avg_record_size_in_bytes],[forwarded_record_count],[compressed_page_count]
from sys.dm_db_index_physical_stats(@DBID, OBJECT_ID(N'NonSparseInsertAll'),NULL, NULL, 'Detailed');



/* store wait stats */
WITH [DiffWaits] AS
(
  SELECT   -- Waits that weren't in the first snapshot
      [ts2].[wait_type],
      [ts2].[wait_time_ms],
      [ts2].[signal_wait_time_ms],
      [ts2].[waiting_tasks_count]
    FROM [##SQLskillsWaitStats2] AS [ts2]
    LEFT OUTER JOIN [##SQLskillsWaitStats1] AS [ts1]
    ON [ts2].[wait_type] = [ts1].[wait_type]
    WHERE [ts1].[wait_type] IS NULL
    AND [ts2].[wait_time_ms] > 0
  UNION
  SELECT   -- Diff of waits in both snapshots
      [ts2].[wait_type],
      [ts2].[wait_time_ms] - [ts1].[wait_time_ms] AS [wait_time_ms],
      [ts2].[signal_wait_time_ms] - [ts1].[signal_wait_time_ms] AS [signal_wait_time_ms],
      [ts2].[waiting_tasks_count] - [ts1].[waiting_tasks_count] AS [waiting_tasks_count]
    FROM [##SQLskillsWaitStats2] AS [ts2]
    LEFT OUTER JOIN [##SQLskillsWaitStats1] AS [ts1]
    ON [ts2].[wait_type] = [ts1].[wait_type]
    WHERE [ts1].[wait_type] IS NOT NULL
    AND [ts2].[waiting_tasks_count] - [ts1].[waiting_tasks_count] > 0
    AND [ts2].[wait_time_ms] - [ts1].[wait_time_ms] > 0
),
[Waits] AS
(
  SELECT
    [wait_type],
    [wait_time_ms] / 1000.0 AS [WaitS],
    ([wait_time_ms] - [signal_wait_time_ms]) / 1000.0 AS [ResourceS],
    [signal_wait_time_ms] / 1000.0 AS [SignalS],
    [waiting_tasks_count] AS [WaitCount],
    100.0 * [wait_time_ms] / SUM ([wait_time_ms]) OVER() AS [Percentage],
    ROW_NUMBER() OVER(ORDER BY [wait_time_ms] DESC) AS [RowNum]
  FROM [DiffWaits]
  WHERE [wait_type] NOT IN (SELECT WaitType FROM SparseTracking.dbo.WaitsToIgnore)
)


INSERT INTO [SparseTracking].[dbo].[WaitStats]
(
	[TestID],
  [WaitType] ,
  [Wait_S] ,
  [Resource_S] ,
  [Signal_S] ,
  [WaitCount] ,
  [Percentage] ,
  [AvgWait_S] ,
  [AvgRes_S] ,
  [AvgSig_S]
)
SELECT
	@TestID,
  [W1].[wait_type],
  CAST ([W1].[WaitS] AS DECIMAL (16, 2)) ,
  CAST ([W1].[ResourceS] AS DECIMAL (16, 2)) ,
  CAST ([W1].[SignalS] AS DECIMAL (16, 2)) ,
  [W1].[WaitCount] ,
  CAST ([W1].[Percentage] AS DECIMAL (5, 2)) ,
  CAST (([W1].[WaitS] / [W1].[WaitCount]) AS DECIMAL (16, 4)) ,
  CAST (([W1].[ResourceS] / [W1].[WaitCount]) AS DECIMAL (16, 4)) ,
  CAST (([W1].[SignalS] / [W1].[WaitCount]) AS DECIMAL (16, 4))
FROM [Waits] AS [W1]
INNER JOIN [Waits] AS [W2]
ON [W2].[RowNum] <= [W1].[RowNum]
GROUP BY [W1].[RowNum], [W1].[wait_type], [W1].[WaitS], [W1].[ResourceS], 
  [W1].[SignalS], [W1].[WaitCount], [W1].[Percentage]
HAVING SUM ([W2].[Percentage]) - [W1].[Percentage] < 95; -- percentage threshold


/* store file stats */

INSERT INTO [SparseTracking].[dbo].[FileStats]
           ([TestID]
           ,[database_id]
           ,[file_id]
           ,[sample_ms]
           ,[num_of_reads]
           ,[num_of_bytes_read]
           ,[io_stall_read_ms]
           ,[num_of_writes]
           ,[num_of_bytes_written]
           ,[io_stall_write_ms]
           ,[io_stall])
SELECT
@TestID,
f.database_id, f.file_id, 
(f.sample_ms - i.sample_ms) AS sample_ms, 
(f.num_of_reads - i.num_of_reads) AS num_of_reads,
(f.num_of_bytes_read - i.num_of_bytes_read ) AS num_of_bytes_read,
(f.io_stall_read_ms - i.io_stall_read_ms ) AS io_stall_read_ms,
(f.num_of_writes - i.num_of_writes ) AS num_of_writes,
(f.num_of_bytes_written - i.num_of_bytes_written ) AS num_of_bytes_written,
(f.io_stall_write_ms - i.io_stall_write_ms ) AS io_stall_write_ms,
(f.io_stall - i.io_stall ) AS io_stall
FROM ##SQLskillsFileStats1 i
JOIN ##SQLskillsFileStats2 f on i.database_id = f.database_id and i.file_id = f.file_id


USE [master];
GO

DROP DATABASE [SparseTest];
GO


/*
	START TEST SparseInsertAll
*/
CREATE DATABASE [SparseTest]
 CONTAINMENT = NONE
 ON  PRIMARY 
( NAME = N'SparseTest', FILENAME = N'M:\Data\Sparse\SparseTest.mdf' , SIZE = 102400MB , FILEGROWTH = 524288KB )
 LOG ON 
( NAME = N'SparseTest_log', FILENAME = N'M:\Data\Sparse\SparseTest_log.ldf' , SIZE = 1048576KB , FILEGROWTH = 524288KB )
GO
ALTER DATABASE [SparseTest] SET RECOVERY SIMPLE 
GO

USE [SparseTest];
GO

CREATE TABLE [SparseInsertAll] (
	[ID] INT IDENTITY, [Name] VARCHAR (100), [Type] INT,
	[c4] VARCHAR(255) SPARSE NULL, [c5] VARCHAR(255) SPARSE NULL, [c6] VARCHAR(255) SPARSE NULL, [c7] VARCHAR(255) SPARSE NULL, [c8] VARCHAR(255) SPARSE NULL, [c9] VARCHAR(255) SPARSE NULL,	[c10] VARCHAR(255) SPARSE NULL, [c11] VARCHAR(255) SPARSE NULL, [c12] VARCHAR(255) SPARSE NULL, [c13] VARCHAR(255) SPARSE NULL, [c14] VARCHAR(255) SPARSE NULL, [c15] VARCHAR(255) SPARSE NULL, [c16] VARCHAR(255) SPARSE NULL, [c17] VARCHAR(255) SPARSE NULL, [c18] VARCHAR(255) SPARSE NULL, [c19] VARCHAR(255) SPARSE NULL,	[c20] VARCHAR(255) SPARSE NULL, [c21] VARCHAR(255) SPARSE NULL, [c22] VARCHAR(255) SPARSE NULL, [c23] VARCHAR(255) SPARSE NULL, [c24] VARCHAR(255) SPARSE NULL, [c25] VARCHAR(255) SPARSE NULL, [c26] VARCHAR(255) SPARSE NULL, [c27] VARCHAR(255) SPARSE NULL, [c28] VARCHAR(255) SPARSE NULL, [c29] VARCHAR(255) SPARSE NULL,	[c30] VARCHAR(255) SPARSE NULL, [c31] VARCHAR(255) SPARSE NULL, [c32] VARCHAR(255) SPARSE NULL, [c33] VARCHAR(255) SPARSE NULL, [c34] VARCHAR(255) SPARSE NULL, [c35] VARCHAR(255) SPARSE NULL, [c36] VARCHAR(255) SPARSE NULL, [c37] VARCHAR(255) SPARSE NULL, [c38] VARCHAR(255) SPARSE NULL, [c39] VARCHAR(255) SPARSE NULL,	[c40] VARCHAR(255) SPARSE NULL, [c41] VARCHAR(255) SPARSE NULL, [c42] VARCHAR(255) SPARSE NULL, [c43] VARCHAR(255) SPARSE NULL, [c44] VARCHAR(255) SPARSE NULL, [c45] VARCHAR(255) SPARSE NULL, [c46] VARCHAR(255) SPARSE NULL, [c47] VARCHAR(255) SPARSE NULL, [c48] VARCHAR(255) SPARSE NULL, [c49] VARCHAR(255) SPARSE NULL,	[c50] VARCHAR(255) SPARSE NULL, [c51] VARCHAR(255) SPARSE NULL, [c52] VARCHAR(255) SPARSE NULL, [c53] VARCHAR(255) SPARSE NULL, [c54] VARCHAR(255) SPARSE NULL, [c55] VARCHAR(255) SPARSE NULL, [c56] VARCHAR(255) SPARSE NULL, [c57] VARCHAR(255) SPARSE NULL, [c58] VARCHAR(255) SPARSE NULL, [c59] VARCHAR(255) SPARSE NULL,	[c60] VARCHAR(255) SPARSE NULL, [c61] VARCHAR(255) SPARSE NULL, [c62] VARCHAR(255) SPARSE NULL, [c63] VARCHAR(255) SPARSE NULL, [c64] VARCHAR(255) SPARSE NULL, [c65] VARCHAR(255) SPARSE NULL, [c66] VARCHAR(255) SPARSE NULL, [c67] VARCHAR(255) SPARSE NULL, [c68] VARCHAR(255) SPARSE NULL, [c69] VARCHAR(255) SPARSE NULL,	[c70] VARCHAR(255) SPARSE NULL, [c71] VARCHAR(255) SPARSE NULL, [c72] VARCHAR(255) SPARSE NULL, [c73] VARCHAR(255) SPARSE NULL, [c74] VARCHAR(255) SPARSE NULL, [c75] VARCHAR(255) SPARSE NULL, [c76] VARCHAR(255) SPARSE NULL, [c77] VARCHAR(255) SPARSE NULL, [c78] VARCHAR(255) SPARSE NULL, [c79] VARCHAR(255) SPARSE NULL,	[c80] VARCHAR(255) SPARSE NULL, [c81] VARCHAR(255) SPARSE NULL, [c82] VARCHAR(255) SPARSE NULL, [c83] VARCHAR(255) SPARSE NULL, [c84] VARCHAR(255) SPARSE NULL, [c85] VARCHAR(255) SPARSE NULL, [c86] VARCHAR(255) SPARSE NULL, [c87] VARCHAR(255) SPARSE NULL, [c88] VARCHAR(255) SPARSE NULL, [c89] VARCHAR(255) SPARSE NULL,	[c90] VARCHAR(255) SPARSE NULL, [c91] VARCHAR(255) SPARSE NULL, [c92] VARCHAR(255) SPARSE NULL, [c93] VARCHAR(255) SPARSE NULL, [c94] VARCHAR(255) SPARSE NULL, [c95] VARCHAR(255) SPARSE NULL, [c96] VARCHAR(255) SPARSE NULL, [c97] VARCHAR(255) SPARSE NULL, [c98] VARCHAR(255) SPARSE NULL, [c99] VARCHAR(255) SPARSE NULL,
	[c100] VARCHAR(255) SPARSE NULL, [c101] VARCHAR(255) SPARSE NULL, [c102] VARCHAR(255) SPARSE NULL, [c103] VARCHAR(255) SPARSE NULL, [c104] VARCHAR(255) SPARSE NULL, [c105] VARCHAR(255) SPARSE NULL, [c106] VARCHAR(255) SPARSE NULL, [c107] VARCHAR(255) SPARSE NULL, [c108] VARCHAR(255) SPARSE NULL, [c109] VARCHAR(255) SPARSE NULL,	[c110] VARCHAR(255) SPARSE NULL, [c111] VARCHAR(255) SPARSE NULL, [c112] VARCHAR(255) SPARSE NULL, [c113] VARCHAR(255) SPARSE NULL, [c114] VARCHAR(255) SPARSE NULL, [c115] VARCHAR(255) SPARSE NULL, [c116] VARCHAR(255) SPARSE NULL, [c117] VARCHAR(255) SPARSE NULL, [c118] VARCHAR(255) SPARSE NULL, [c119] VARCHAR(255) SPARSE NULL,	[c120] VARCHAR(255) SPARSE NULL, [c121] VARCHAR(255) SPARSE NULL, [c122] VARCHAR(255) SPARSE NULL, [c123] VARCHAR(255) SPARSE NULL, [c124] VARCHAR(255) SPARSE NULL, [c125] VARCHAR(255) SPARSE NULL, [c126] VARCHAR(255) SPARSE NULL, [c127] VARCHAR(255) SPARSE NULL, [c128] VARCHAR(255) SPARSE NULL, [c129] VARCHAR(255) SPARSE NULL,	[c130] VARCHAR(255) SPARSE NULL, [c131] VARCHAR(255) SPARSE NULL, [c132] VARCHAR(255) SPARSE NULL, [c133] VARCHAR(255) SPARSE NULL, [c134] VARCHAR(255) SPARSE NULL, [c135] VARCHAR(255) SPARSE NULL, [c136] VARCHAR(255) SPARSE NULL, [c137] VARCHAR(255) SPARSE NULL, [c138] VARCHAR(255) SPARSE NULL, [c139] VARCHAR(255) SPARSE NULL,	[c140] VARCHAR(255) SPARSE NULL, [c141] VARCHAR(255) SPARSE NULL, [c142] VARCHAR(255) SPARSE NULL, [c143] VARCHAR(255) SPARSE NULL, [c144] VARCHAR(255) SPARSE NULL, [c145] VARCHAR(255) SPARSE NULL, [c146] VARCHAR(255) SPARSE NULL, [c147] VARCHAR(255) SPARSE NULL, [c148] VARCHAR(255) SPARSE NULL, [c149] VARCHAR(255) SPARSE NULL,	[c150] VARCHAR(255) SPARSE NULL, [c151] VARCHAR(255) SPARSE NULL, [c152] VARCHAR(255) SPARSE NULL, [c153] VARCHAR(255) SPARSE NULL, [c154] VARCHAR(255) SPARSE NULL, [c155] VARCHAR(255) SPARSE NULL, [c156] VARCHAR(255) SPARSE NULL, [c157] VARCHAR(255) SPARSE NULL, [c158] VARCHAR(255) SPARSE NULL, [c159] VARCHAR(255) SPARSE NULL,	[c160] VARCHAR(255) SPARSE NULL, [c161] VARCHAR(255) SPARSE NULL, [c162] VARCHAR(255) SPARSE NULL, [c163] VARCHAR(255) SPARSE NULL, [c164] VARCHAR(255) SPARSE NULL, [c165] VARCHAR(255) SPARSE NULL, [c166] VARCHAR(255) SPARSE NULL, [c167] VARCHAR(255) SPARSE NULL, [c168] VARCHAR(255) SPARSE NULL, [c169] VARCHAR(255) SPARSE NULL,	[c170] VARCHAR(255) SPARSE NULL, [c171] VARCHAR(255) SPARSE NULL, [c172] VARCHAR(255) SPARSE NULL, [c173] VARCHAR(255) SPARSE NULL, [c174] VARCHAR(255) SPARSE NULL, [c175] VARCHAR(255) SPARSE NULL, [c176] VARCHAR(255) SPARSE NULL, [c177] VARCHAR(255) SPARSE NULL, [c178] VARCHAR(255) SPARSE NULL, [c179] VARCHAR(255) SPARSE NULL,	[c180] VARCHAR(255) SPARSE NULL, [c181] VARCHAR(255) SPARSE NULL, [c182] VARCHAR(255) SPARSE NULL, [c183] VARCHAR(255) SPARSE NULL, [c184] VARCHAR(255) SPARSE NULL, [c185] VARCHAR(255) SPARSE NULL, [c186] VARCHAR(255) SPARSE NULL, [c187] VARCHAR(255) SPARSE NULL, [c188] VARCHAR(255) SPARSE NULL, [c189] VARCHAR(255) SPARSE NULL,	[c190] VARCHAR(255) SPARSE NULL, [c191] VARCHAR(255) SPARSE NULL, [c192] VARCHAR(255) SPARSE NULL, [c193] VARCHAR(255) SPARSE NULL, [c194] VARCHAR(255) SPARSE NULL, [c195] VARCHAR(255) SPARSE NULL, [c196] VARCHAR(255) SPARSE NULL, [c197] VARCHAR(255) SPARSE NULL, [c198] VARCHAR(255) SPARSE NULL, [c199] VARCHAR(255) SPARSE NULL,
	[c200] VARCHAR(255) SPARSE NULL, [c201] VARCHAR(255) SPARSE NULL, [c202] VARCHAR(255) SPARSE NULL, [c203] VARCHAR(255) SPARSE NULL, [c204] VARCHAR(255) SPARSE NULL, [c205] VARCHAR(255) SPARSE NULL, [c206] VARCHAR(255) SPARSE NULL, [c207] VARCHAR(255) SPARSE NULL, [c208] VARCHAR(255) SPARSE NULL, [c209] VARCHAR(255) SPARSE NULL,	[c210] VARCHAR(255) SPARSE NULL, [c211] VARCHAR(255) SPARSE NULL, [c212] VARCHAR(255) SPARSE NULL, [c213] VARCHAR(255) SPARSE NULL, [c214] VARCHAR(255) SPARSE NULL, [c215] VARCHAR(255) SPARSE NULL, [c216] VARCHAR(255) SPARSE NULL, [c217] VARCHAR(255) SPARSE NULL, [c218] VARCHAR(255) SPARSE NULL, [c219] VARCHAR(255) SPARSE NULL,	[c220] VARCHAR(255) SPARSE NULL, [c221] VARCHAR(255) SPARSE NULL, [c222] VARCHAR(255) SPARSE NULL, [c223] VARCHAR(255) SPARSE NULL, [c224] VARCHAR(255) SPARSE NULL, [c225] VARCHAR(255) SPARSE NULL, [c226] VARCHAR(255) SPARSE NULL, [c227] VARCHAR(255) SPARSE NULL, [c228] VARCHAR(255) SPARSE NULL, [c229] VARCHAR(255) SPARSE NULL,	[c230] VARCHAR(255) SPARSE NULL, [c231] VARCHAR(255) SPARSE NULL, [c232] VARCHAR(255) SPARSE NULL, [c233] VARCHAR(255) SPARSE NULL, [c234] VARCHAR(255) SPARSE NULL, [c235] VARCHAR(255) SPARSE NULL, [c236] VARCHAR(255) SPARSE NULL, [c237] VARCHAR(255) SPARSE NULL, [c238] VARCHAR(255) SPARSE NULL, [c239] VARCHAR(255) SPARSE NULL,	[c240] VARCHAR(255) SPARSE NULL, [c241] VARCHAR(255) SPARSE NULL, [c242] VARCHAR(255) SPARSE NULL, [c243] VARCHAR(255) SPARSE NULL, [c244] VARCHAR(255) SPARSE NULL, [c245] VARCHAR(255) SPARSE NULL, [c246] VARCHAR(255) SPARSE NULL, [c247] VARCHAR(255) SPARSE NULL, [c248] VARCHAR(255) SPARSE NULL, [c249] VARCHAR(255) SPARSE NULL,	[c250] VARCHAR(255) SPARSE NULL, [c251] VARCHAR(255) SPARSE NULL, [c252] VARCHAR(255) SPARSE NULL, [c253] VARCHAR(255) SPARSE NULL, [c254] VARCHAR(255) SPARSE NULL, [c255] VARCHAR(255) SPARSE NULL, [c256] VARCHAR(255) SPARSE NULL, [c257] VARCHAR(255) SPARSE NULL, [c258] VARCHAR(255) SPARSE NULL, [c259] VARCHAR(255) SPARSE NULL,	[c260] VARCHAR(255) SPARSE NULL, [c261] VARCHAR(255) SPARSE NULL, [c262] VARCHAR(255) SPARSE NULL, [c263] VARCHAR(255) SPARSE NULL, [c264] VARCHAR(255) SPARSE NULL, [c265] VARCHAR(255) SPARSE NULL, [c266] VARCHAR(255) SPARSE NULL, [c267] VARCHAR(255) SPARSE NULL, [c268] VARCHAR(255) SPARSE NULL, [c269] VARCHAR(255) SPARSE NULL,	[c270] VARCHAR(255) SPARSE NULL, [c271] VARCHAR(255) SPARSE NULL, [c272] VARCHAR(255) SPARSE NULL, [c273] VARCHAR(255) SPARSE NULL, [c274] VARCHAR(255) SPARSE NULL, [c275] VARCHAR(255) SPARSE NULL, [c276] VARCHAR(255) SPARSE NULL, [c277] VARCHAR(255) SPARSE NULL, [c278] VARCHAR(255) SPARSE NULL, [c279] VARCHAR(255) SPARSE NULL,	[c280] VARCHAR(255) SPARSE NULL, [c281] VARCHAR(255) SPARSE NULL, [c282] VARCHAR(255) SPARSE NULL, [c283] VARCHAR(255) SPARSE NULL, [c284] VARCHAR(255) SPARSE NULL, [c285] VARCHAR(255) SPARSE NULL, [c286] VARCHAR(255) SPARSE NULL, [c287] VARCHAR(255) SPARSE NULL, [c288] VARCHAR(255) SPARSE NULL, [c289] VARCHAR(255) SPARSE NULL,	[c290] VARCHAR(255) SPARSE NULL, [c291] VARCHAR(255) SPARSE NULL, [c292] VARCHAR(255) SPARSE NULL, [c293] VARCHAR(255) SPARSE NULL, [c294] VARCHAR(255) SPARSE NULL, [c295] VARCHAR(255) SPARSE NULL, [c296] VARCHAR(255) SPARSE NULL, [c297] VARCHAR(255) SPARSE NULL, [c298] VARCHAR(255) SPARSE NULL, [c299] VARCHAR(255) SPARSE NULL,
	[c300] VARCHAR(255) SPARSE NULL, [c301] VARCHAR(255) SPARSE NULL, [c302] VARCHAR(255) SPARSE NULL, [c303] VARCHAR(255) SPARSE NULL, [c304] VARCHAR(255) SPARSE NULL, [c305] VARCHAR(255) SPARSE NULL, [c306] VARCHAR(255) SPARSE NULL, [c307] VARCHAR(255) SPARSE NULL, [c308] VARCHAR(255) SPARSE NULL, [c309] VARCHAR(255) SPARSE NULL,	[c310] VARCHAR(255) SPARSE NULL, [c311] VARCHAR(255) SPARSE NULL, [c312] VARCHAR(255) SPARSE NULL, [c313] VARCHAR(255) SPARSE NULL, [c314] VARCHAR(255) SPARSE NULL, [c315] VARCHAR(255) SPARSE NULL, [c316] VARCHAR(255) SPARSE NULL, [c317] VARCHAR(255) SPARSE NULL, [c318] VARCHAR(255) SPARSE NULL, [c319] VARCHAR(255) SPARSE NULL,	[c320] VARCHAR(255) SPARSE NULL, [c321] VARCHAR(255) SPARSE NULL, [c322] VARCHAR(255) SPARSE NULL, [c323] VARCHAR(255) SPARSE NULL, [c324] VARCHAR(255) SPARSE NULL, [c325] VARCHAR(255) SPARSE NULL, [c326] VARCHAR(255) SPARSE NULL, [c327] VARCHAR(255) SPARSE NULL, [c328] VARCHAR(255) SPARSE NULL, [c329] VARCHAR(255) SPARSE NULL,	[c330] VARCHAR(255) SPARSE NULL, [c331] VARCHAR(255) SPARSE NULL, [c332] VARCHAR(255) SPARSE NULL, [c333] VARCHAR(255) SPARSE NULL, [c334] VARCHAR(255) SPARSE NULL, [c335] VARCHAR(255) SPARSE NULL, [c336] VARCHAR(255) SPARSE NULL, [c337] VARCHAR(255) SPARSE NULL, [c338] VARCHAR(255) SPARSE NULL, [c339] VARCHAR(255) SPARSE NULL,	[c340] VARCHAR(255) SPARSE NULL, [c341] VARCHAR(255) SPARSE NULL, [c342] VARCHAR(255) SPARSE NULL, [c343] VARCHAR(255) SPARSE NULL, [c344] VARCHAR(255) SPARSE NULL, [c345] VARCHAR(255) SPARSE NULL, [c346] VARCHAR(255) SPARSE NULL, [c347] VARCHAR(255) SPARSE NULL, [c348] VARCHAR(255) SPARSE NULL, [c349] VARCHAR(255) SPARSE NULL,	[c350] VARCHAR(255) SPARSE NULL, [c351] VARCHAR(255) SPARSE NULL, [c352] VARCHAR(255) SPARSE NULL, [c353] VARCHAR(255) SPARSE NULL, [c354] VARCHAR(255) SPARSE NULL, [c355] VARCHAR(255) SPARSE NULL, [c356] VARCHAR(255) SPARSE NULL, [c357] VARCHAR(255) SPARSE NULL, [c358] VARCHAR(255) SPARSE NULL, [c359] VARCHAR(255) SPARSE NULL,	[c360] VARCHAR(255) SPARSE NULL, [c361] VARCHAR(255) SPARSE NULL, [c362] VARCHAR(255) SPARSE NULL, [c363] VARCHAR(255) SPARSE NULL, [c364] VARCHAR(255) SPARSE NULL, [c365] VARCHAR(255) SPARSE NULL, [c366] VARCHAR(255) SPARSE NULL, [c367] VARCHAR(255) SPARSE NULL, [c368] VARCHAR(255) SPARSE NULL, [c369] VARCHAR(255) SPARSE NULL,	[c370] VARCHAR(255) SPARSE NULL, [c371] VARCHAR(255) SPARSE NULL, [c372] VARCHAR(255) SPARSE NULL, [c373] VARCHAR(255) SPARSE NULL, [c374] VARCHAR(255) SPARSE NULL, [c375] VARCHAR(255) SPARSE NULL, [c376] VARCHAR(255) SPARSE NULL, [c377] VARCHAR(255) SPARSE NULL, [c378] VARCHAR(255) SPARSE NULL, [c379] VARCHAR(255) SPARSE NULL,	[c380] VARCHAR(255) SPARSE NULL, [c381] VARCHAR(255) SPARSE NULL, [c382] VARCHAR(255) SPARSE NULL, [c383] VARCHAR(255) SPARSE NULL, [c384] VARCHAR(255) SPARSE NULL, [c385] VARCHAR(255) SPARSE NULL, [c386] VARCHAR(255) SPARSE NULL, [c387] VARCHAR(255) SPARSE NULL, [c388] VARCHAR(255) SPARSE NULL, [c389] VARCHAR(255) SPARSE NULL,	[c390] VARCHAR(255) SPARSE NULL, [c391] VARCHAR(255) SPARSE NULL, [c392] VARCHAR(255) SPARSE NULL, [c393] VARCHAR(255) SPARSE NULL, [c394] VARCHAR(255) SPARSE NULL, [c395] VARCHAR(255) SPARSE NULL, [c396] VARCHAR(255) SPARSE NULL, [c397] VARCHAR(255) SPARSE NULL, [c398] VARCHAR(255) SPARSE NULL, [c399] VARCHAR(255) SPARSE NULL,
	[c400] VARCHAR(255) SPARSE NULL, [c401] VARCHAR(255) SPARSE NULL, [c402] VARCHAR(255) SPARSE NULL, [c403] VARCHAR(255) SPARSE NULL, [c404] VARCHAR(255) SPARSE NULL, [c405] VARCHAR(255) SPARSE NULL, [c406] VARCHAR(255) SPARSE NULL, [c407] VARCHAR(255) SPARSE NULL, [c408] VARCHAR(255) SPARSE NULL, [c409] VARCHAR(255) SPARSE NULL,	[c410] VARCHAR(255) SPARSE NULL, [c411] VARCHAR(255) SPARSE NULL, [c412] VARCHAR(255) SPARSE NULL, [c413] VARCHAR(255) SPARSE NULL, [c414] VARCHAR(255) SPARSE NULL, [c415] VARCHAR(255) SPARSE NULL, [c416] VARCHAR(255) SPARSE NULL, [c417] VARCHAR(255) SPARSE NULL, [c418] VARCHAR(255) SPARSE NULL, [c419] VARCHAR(255) SPARSE NULL,	[c420] VARCHAR(255) SPARSE NULL, [c421] VARCHAR(255) SPARSE NULL, [c422] VARCHAR(255) SPARSE NULL, [c423] VARCHAR(255) SPARSE NULL, [c424] VARCHAR(255) SPARSE NULL, [c425] VARCHAR(255) SPARSE NULL, [c426] VARCHAR(255) SPARSE NULL, [c427] VARCHAR(255) SPARSE NULL, [c428] VARCHAR(255) SPARSE NULL, [c429] VARCHAR(255) SPARSE NULL,	[c430] VARCHAR(255) SPARSE NULL, [c431] VARCHAR(255) SPARSE NULL, [c432] VARCHAR(255) SPARSE NULL, [c433] VARCHAR(255) SPARSE NULL, [c434] VARCHAR(255) SPARSE NULL, [c435] VARCHAR(255) SPARSE NULL, [c436] VARCHAR(255) SPARSE NULL, [c437] VARCHAR(255) SPARSE NULL, [c438] VARCHAR(255) SPARSE NULL, [c439] VARCHAR(255) SPARSE NULL,	[c440] VARCHAR(255) SPARSE NULL, [c441] VARCHAR(255) SPARSE NULL, [c442] VARCHAR(255) SPARSE NULL, [c443] VARCHAR(255) SPARSE NULL, [c444] VARCHAR(255) SPARSE NULL, [c445] VARCHAR(255) SPARSE NULL, [c446] VARCHAR(255) SPARSE NULL, [c447] VARCHAR(255) SPARSE NULL, [c448] VARCHAR(255) SPARSE NULL, [c449] VARCHAR(255) SPARSE NULL,	[c450] VARCHAR(255) SPARSE NULL, [c451] VARCHAR(255) SPARSE NULL, [c452] VARCHAR(255) SPARSE NULL, [c453] VARCHAR(255) SPARSE NULL, [c454] VARCHAR(255) SPARSE NULL, [c455] VARCHAR(255) SPARSE NULL, [c456] VARCHAR(255) SPARSE NULL, [c457] VARCHAR(255) SPARSE NULL, [c458] VARCHAR(255) SPARSE NULL, [c459] VARCHAR(255) SPARSE NULL,	[c460] VARCHAR(255) SPARSE NULL, [c461] VARCHAR(255) SPARSE NULL, [c462] VARCHAR(255) SPARSE NULL, [c463] VARCHAR(255) SPARSE NULL, [c464] VARCHAR(255) SPARSE NULL, [c465] VARCHAR(255) SPARSE NULL, [c466] VARCHAR(255) SPARSE NULL, [c467] VARCHAR(255) SPARSE NULL, [c468] VARCHAR(255) SPARSE NULL, [c469] VARCHAR(255) SPARSE NULL,	[c470] VARCHAR(255) SPARSE NULL, [c471] VARCHAR(255) SPARSE NULL, [c472] VARCHAR(255) SPARSE NULL, [c473] VARCHAR(255) SPARSE NULL, [c474] VARCHAR(255) SPARSE NULL, [c475] VARCHAR(255) SPARSE NULL, [c476] VARCHAR(255) SPARSE NULL, [c477] VARCHAR(255) SPARSE NULL, [c478] VARCHAR(255) SPARSE NULL, [c479] VARCHAR(255) SPARSE NULL,	[c480] VARCHAR(255) SPARSE NULL, [c481] VARCHAR(255) SPARSE NULL, [c482] VARCHAR(255) SPARSE NULL, [c483] VARCHAR(255) SPARSE NULL, [c484] VARCHAR(255) SPARSE NULL, [c485] VARCHAR(255) SPARSE NULL, [c486] VARCHAR(255) SPARSE NULL, [c487] VARCHAR(255) SPARSE NULL, [c488] VARCHAR(255) SPARSE NULL, [c489] VARCHAR(255) SPARSE NULL,	[c490] VARCHAR(255) SPARSE NULL, [c491] VARCHAR(255) SPARSE NULL, [c492] VARCHAR(255) SPARSE NULL, [c493] VARCHAR(255) SPARSE NULL, [c494] VARCHAR(255) SPARSE NULL, [c495] VARCHAR(255) SPARSE NULL, [c496] VARCHAR(255) SPARSE NULL, [c497] VARCHAR(255) SPARSE NULL, [c498] VARCHAR(255) SPARSE NULL, [c499] VARCHAR(255) SPARSE NULL,
	[c500] VARCHAR(255) SPARSE NULL, [c501] VARCHAR(255) SPARSE NULL, [c502] VARCHAR(255) SPARSE NULL, [c503] VARCHAR(255) SPARSE NULL, [c504] VARCHAR(255) SPARSE NULL, [c505] VARCHAR(255) SPARSE NULL, [c506] VARCHAR(255) SPARSE NULL, [c507] VARCHAR(255) SPARSE NULL, [c508] VARCHAR(255) SPARSE NULL, [c509] VARCHAR(255) SPARSE NULL,	[c510] VARCHAR(255) SPARSE NULL, [c511] VARCHAR(255) SPARSE NULL, [c512] VARCHAR(255) SPARSE NULL, [c513] VARCHAR(255) SPARSE NULL, [c514] VARCHAR(255) SPARSE NULL, [c515] VARCHAR(255) SPARSE NULL, [c516] VARCHAR(255) SPARSE NULL, [c517] VARCHAR(255) SPARSE NULL, [c518] VARCHAR(255) SPARSE NULL, [c519] VARCHAR(255) SPARSE NULL,	[c520] VARCHAR(255) SPARSE NULL, [c521] VARCHAR(255) SPARSE NULL, [c522] VARCHAR(255) SPARSE NULL, [c523] VARCHAR(255) SPARSE NULL, [c524] VARCHAR(255) SPARSE NULL, [c525] VARCHAR(255) SPARSE NULL, [c526] VARCHAR(255) SPARSE NULL, [c527] VARCHAR(255) SPARSE NULL, [c528] VARCHAR(255) SPARSE NULL, [c529] VARCHAR(255) SPARSE NULL,	[c530] VARCHAR(255) SPARSE NULL, [c531] VARCHAR(255) SPARSE NULL, [c532] VARCHAR(255) SPARSE NULL, [c533] VARCHAR(255) SPARSE NULL, [c534] VARCHAR(255) SPARSE NULL, [c535] VARCHAR(255) SPARSE NULL, [c536] VARCHAR(255) SPARSE NULL, [c537] VARCHAR(255) SPARSE NULL, [c538] VARCHAR(255) SPARSE NULL, [c539] VARCHAR(255) SPARSE NULL,	[c540] VARCHAR(255) SPARSE NULL, [c541] VARCHAR(255) SPARSE NULL, [c542] VARCHAR(255) SPARSE NULL, [c543] VARCHAR(255) SPARSE NULL, [c544] VARCHAR(255) SPARSE NULL, [c545] VARCHAR(255) SPARSE NULL, [c546] VARCHAR(255) SPARSE NULL, [c547] VARCHAR(255) SPARSE NULL, [c548] VARCHAR(255) SPARSE NULL, [c549] VARCHAR(255) SPARSE NULL,	[c550] VARCHAR(255) SPARSE NULL, [c551] VARCHAR(255) SPARSE NULL, [c552] VARCHAR(255) SPARSE NULL, [c553] VARCHAR(255) SPARSE NULL, [c554] VARCHAR(255) SPARSE NULL, [c555] VARCHAR(255) SPARSE NULL, [c556] VARCHAR(255) SPARSE NULL, [c557] VARCHAR(255) SPARSE NULL, [c558] VARCHAR(255) SPARSE NULL, [c559] VARCHAR(255) SPARSE NULL,	[c560] VARCHAR(255) SPARSE NULL, [c561] VARCHAR(255) SPARSE NULL, [c562] VARCHAR(255) SPARSE NULL, [c563] VARCHAR(255) SPARSE NULL, [c564] VARCHAR(255) SPARSE NULL, [c565] VARCHAR(255) SPARSE NULL, [c566] VARCHAR(255) SPARSE NULL, [c567] VARCHAR(255) SPARSE NULL, [c568] VARCHAR(255) SPARSE NULL, [c569] VARCHAR(255) SPARSE NULL,	[c570] VARCHAR(255) SPARSE NULL, [c571] VARCHAR(255) SPARSE NULL, [c572] VARCHAR(255) SPARSE NULL, [c573] VARCHAR(255) SPARSE NULL, [c574] VARCHAR(255) SPARSE NULL, [c575] VARCHAR(255) SPARSE NULL, [c576] VARCHAR(255) SPARSE NULL, [c577] VARCHAR(255) SPARSE NULL, [c578] VARCHAR(255) SPARSE NULL, [c579] VARCHAR(255) SPARSE NULL,	[c580] VARCHAR(255) SPARSE NULL, [c581] VARCHAR(255) SPARSE NULL, [c582] VARCHAR(255) SPARSE NULL, [c583] VARCHAR(255) SPARSE NULL, [c584] VARCHAR(255) SPARSE NULL, [c585] VARCHAR(255) SPARSE NULL, [c586] VARCHAR(255) SPARSE NULL, [c587] VARCHAR(255) SPARSE NULL, [c588] VARCHAR(255) SPARSE NULL, [c589] VARCHAR(255) SPARSE NULL,	[c590] VARCHAR(255) SPARSE NULL, [c591] VARCHAR(255) SPARSE NULL, [c592] VARCHAR(255) SPARSE NULL, [c593] VARCHAR(255) SPARSE NULL, [c594] VARCHAR(255) SPARSE NULL, [c595] VARCHAR(255) SPARSE NULL, [c596] VARCHAR(255) SPARSE NULL, [c597] VARCHAR(255) SPARSE NULL, [c598] VARCHAR(255) SPARSE NULL, [c599] VARCHAR(255) SPARSE NULL,
	[c600] VARCHAR(255) SPARSE NULL, [c601] VARCHAR(255) SPARSE NULL, [c602] VARCHAR(255) SPARSE NULL, [c603] VARCHAR(255) SPARSE NULL, [c604] VARCHAR(255) SPARSE NULL, [c605] VARCHAR(255) SPARSE NULL, [c606] VARCHAR(255) SPARSE NULL, [c607] VARCHAR(255) SPARSE NULL, [c608] VARCHAR(255) SPARSE NULL, [c609] VARCHAR(255) SPARSE NULL,	[c610] VARCHAR(255) SPARSE NULL, [c611] VARCHAR(255) SPARSE NULL, [c612] VARCHAR(255) SPARSE NULL, [c613] VARCHAR(255) SPARSE NULL, [c614] VARCHAR(255) SPARSE NULL, [c615] VARCHAR(255) SPARSE NULL, [c616] VARCHAR(255) SPARSE NULL, [c617] VARCHAR(255) SPARSE NULL, [c618] VARCHAR(255) SPARSE NULL, [c619] VARCHAR(255) SPARSE NULL,	[c620] VARCHAR(255) SPARSE NULL, [c621] VARCHAR(255) SPARSE NULL, [c622] VARCHAR(255) SPARSE NULL, [c623] VARCHAR(255) SPARSE NULL, [c624] VARCHAR(255) SPARSE NULL, [c625] VARCHAR(255) SPARSE NULL, [c626] VARCHAR(255) SPARSE NULL, [c627] VARCHAR(255) SPARSE NULL, [c628] VARCHAR(255) SPARSE NULL, [c629] VARCHAR(255) SPARSE NULL,	[c630] VARCHAR(255) SPARSE NULL, [c631] VARCHAR(255) SPARSE NULL, [c632] VARCHAR(255) SPARSE NULL, [c633] VARCHAR(255) SPARSE NULL, [c634] VARCHAR(255) SPARSE NULL, [c635] VARCHAR(255) SPARSE NULL, [c636] VARCHAR(255) SPARSE NULL, [c637] VARCHAR(255) SPARSE NULL, [c638] VARCHAR(255) SPARSE NULL, [c639] VARCHAR(255) SPARSE NULL,	[c640] VARCHAR(255) SPARSE NULL, [c641] VARCHAR(255) SPARSE NULL, [c642] VARCHAR(255) SPARSE NULL, [c643] VARCHAR(255) SPARSE NULL, [c644] VARCHAR(255) SPARSE NULL, [c645] VARCHAR(255) SPARSE NULL, [c646] VARCHAR(255) SPARSE NULL, [c647] VARCHAR(255) SPARSE NULL, [c648] VARCHAR(255) SPARSE NULL, [c649] VARCHAR(255) SPARSE NULL,	[c650] VARCHAR(255) SPARSE NULL, [c651] VARCHAR(255) SPARSE NULL, [c652] VARCHAR(255) SPARSE NULL, [c653] VARCHAR(255) SPARSE NULL, [c654] VARCHAR(255) SPARSE NULL, [c655] VARCHAR(255) SPARSE NULL, [c656] VARCHAR(255) SPARSE NULL, [c657] VARCHAR(255) SPARSE NULL, [c658] VARCHAR(255) SPARSE NULL, [c659] VARCHAR(255) SPARSE NULL,	[c660] VARCHAR(255) SPARSE NULL, [c661] VARCHAR(255) SPARSE NULL, [c662] VARCHAR(255) SPARSE NULL, [c663] VARCHAR(255) SPARSE NULL, [c664] VARCHAR(255) SPARSE NULL, [c665] VARCHAR(255) SPARSE NULL, [c666] VARCHAR(255) SPARSE NULL, [c667] VARCHAR(255) SPARSE NULL, [c668] VARCHAR(255) SPARSE NULL, [c669] VARCHAR(255) SPARSE NULL,	[c670] VARCHAR(255) SPARSE NULL, [c671] VARCHAR(255) SPARSE NULL, [c672] VARCHAR(255) SPARSE NULL, [c673] VARCHAR(255) SPARSE NULL, [c674] VARCHAR(255) SPARSE NULL, [c675] VARCHAR(255) SPARSE NULL, [c676] VARCHAR(255) SPARSE NULL, [c677] VARCHAR(255) SPARSE NULL, [c678] VARCHAR(255) SPARSE NULL, [c679] VARCHAR(255) SPARSE NULL,	[c680] VARCHAR(255) SPARSE NULL, [c681] VARCHAR(255) SPARSE NULL, [c682] VARCHAR(255) SPARSE NULL, [c683] VARCHAR(255) SPARSE NULL, [c684] VARCHAR(255) SPARSE NULL, [c685] VARCHAR(255) SPARSE NULL, [c686] VARCHAR(255) SPARSE NULL, [c687] VARCHAR(255) SPARSE NULL, [c688] VARCHAR(255) SPARSE NULL, [c689] VARCHAR(255) SPARSE NULL,	[c690] VARCHAR(255) SPARSE NULL, [c691] VARCHAR(255) SPARSE NULL, [c692] VARCHAR(255) SPARSE NULL, [c693] VARCHAR(255) SPARSE NULL, [c694] VARCHAR(255) SPARSE NULL, [c695] VARCHAR(255) SPARSE NULL, [c696] VARCHAR(255) SPARSE NULL, [c697] VARCHAR(255) SPARSE NULL, [c698] VARCHAR(255) SPARSE NULL, [c699] VARCHAR(255) SPARSE NULL,
	[c700] VARCHAR(255) SPARSE NULL, [c701] VARCHAR(255) SPARSE NULL, [c702] VARCHAR(255) SPARSE NULL, [c703] VARCHAR(255) SPARSE NULL, [c704] VARCHAR(255) SPARSE NULL, [c705] VARCHAR(255) SPARSE NULL, [c706] VARCHAR(255) SPARSE NULL, [c707] VARCHAR(255) SPARSE NULL, [c708] VARCHAR(255) SPARSE NULL, [c709] VARCHAR(255) SPARSE NULL,	[c710] VARCHAR(255) SPARSE NULL, [c711] VARCHAR(255) SPARSE NULL, [c712] VARCHAR(255) SPARSE NULL, [c713] VARCHAR(255) SPARSE NULL, [c714] VARCHAR(255) SPARSE NULL, [c715] VARCHAR(255) SPARSE NULL, [c716] VARCHAR(255) SPARSE NULL, [c717] VARCHAR(255) SPARSE NULL, [c718] VARCHAR(255) SPARSE NULL, [c719] VARCHAR(255) SPARSE NULL,	[c720] VARCHAR(255) SPARSE NULL, [c721] VARCHAR(255) SPARSE NULL, [c722] VARCHAR(255) SPARSE NULL, [c723] VARCHAR(255) SPARSE NULL, [c724] VARCHAR(255) SPARSE NULL, [c725] VARCHAR(255) SPARSE NULL, [c726] VARCHAR(255) SPARSE NULL, [c727] VARCHAR(255) SPARSE NULL, [c728] VARCHAR(255) SPARSE NULL, [c729] VARCHAR(255) SPARSE NULL,	[c730] VARCHAR(255) SPARSE NULL, [c731] VARCHAR(255) SPARSE NULL, [c732] VARCHAR(255) SPARSE NULL, [c733] VARCHAR(255) SPARSE NULL, [c734] VARCHAR(255) SPARSE NULL, [c735] VARCHAR(255) SPARSE NULL, [c736] VARCHAR(255) SPARSE NULL, [c737] VARCHAR(255) SPARSE NULL, [c738] VARCHAR(255) SPARSE NULL, [c739] VARCHAR(255) SPARSE NULL,	[c740] VARCHAR(255) SPARSE NULL, [c741] VARCHAR(255) SPARSE NULL, [c742] VARCHAR(255) SPARSE NULL, [c743] VARCHAR(255) SPARSE NULL, [c744] VARCHAR(255) SPARSE NULL, [c745] VARCHAR(255) SPARSE NULL, [c746] VARCHAR(255) SPARSE NULL, [c747] VARCHAR(255) SPARSE NULL, [c748] VARCHAR(255) SPARSE NULL, [c749] VARCHAR(255) SPARSE NULL,	[c750] VARCHAR(255) SPARSE NULL, [c751] VARCHAR(255) SPARSE NULL, [c752] VARCHAR(255) SPARSE NULL, [c753] VARCHAR(255) SPARSE NULL, [c754] VARCHAR(255) SPARSE NULL, [c755] VARCHAR(255) SPARSE NULL, [c756] VARCHAR(255) SPARSE NULL, [c757] VARCHAR(255) SPARSE NULL, [c758] VARCHAR(255) SPARSE NULL, [c759] VARCHAR(255) SPARSE NULL,	[c760] VARCHAR(255) SPARSE NULL, [c761] VARCHAR(255) SPARSE NULL, [c762] VARCHAR(255) SPARSE NULL, [c763] VARCHAR(255) SPARSE NULL, [c764] VARCHAR(255) SPARSE NULL, [c765] VARCHAR(255) SPARSE NULL, [c766] VARCHAR(255) SPARSE NULL, [c767] VARCHAR(255) SPARSE NULL, [c768] VARCHAR(255) SPARSE NULL, [c769] VARCHAR(255) SPARSE NULL,	[c770] VARCHAR(255) SPARSE NULL, [c771] VARCHAR(255) SPARSE NULL, [c772] VARCHAR(255) SPARSE NULL, [c773] VARCHAR(255) SPARSE NULL, [c774] VARCHAR(255) SPARSE NULL, [c775] VARCHAR(255) SPARSE NULL, [c776] VARCHAR(255) SPARSE NULL, [c777] VARCHAR(255) SPARSE NULL, [c778] VARCHAR(255) SPARSE NULL, [c779] VARCHAR(255) SPARSE NULL,	[c780] VARCHAR(255) SPARSE NULL, [c781] VARCHAR(255) SPARSE NULL, [c782] VARCHAR(255) SPARSE NULL, [c783] VARCHAR(255) SPARSE NULL, [c784] VARCHAR(255) SPARSE NULL, [c785] VARCHAR(255) SPARSE NULL, [c786] VARCHAR(255) SPARSE NULL, [c787] VARCHAR(255) SPARSE NULL, [c788] VARCHAR(255) SPARSE NULL, [c789] VARCHAR(255) SPARSE NULL,	[c790] VARCHAR(255) SPARSE NULL, [c791] VARCHAR(255) SPARSE NULL, [c792] VARCHAR(255) SPARSE NULL, [c793] VARCHAR(255) SPARSE NULL, [c794] VARCHAR(255) SPARSE NULL, [c795] VARCHAR(255) SPARSE NULL, [c796] VARCHAR(255) SPARSE NULL, [c797] VARCHAR(255) SPARSE NULL, [c798] VARCHAR(255) SPARSE NULL, [c799] VARCHAR(255) SPARSE NULL,
	[c800] VARCHAR(255) SPARSE NULL, [c801] VARCHAR(255) SPARSE NULL, [c802] VARCHAR(255) SPARSE NULL, [c803] VARCHAR(255) SPARSE NULL, [c804] VARCHAR(255) SPARSE NULL, [c805] VARCHAR(255) SPARSE NULL, [c806] VARCHAR(255) SPARSE NULL, [c807] VARCHAR(255) SPARSE NULL, [c808] VARCHAR(255) SPARSE NULL, [c809] VARCHAR(255) SPARSE NULL,	[c810] VARCHAR(255) SPARSE NULL, [c811] VARCHAR(255) SPARSE NULL, [c812] VARCHAR(255) SPARSE NULL, [c813] VARCHAR(255) SPARSE NULL, [c814] VARCHAR(255) SPARSE NULL, [c815] VARCHAR(255) SPARSE NULL, [c816] VARCHAR(255) SPARSE NULL, [c817] VARCHAR(255) SPARSE NULL, [c818] VARCHAR(255) SPARSE NULL, [c819] VARCHAR(255) SPARSE NULL,	[c820] VARCHAR(255) SPARSE NULL, [c821] VARCHAR(255) SPARSE NULL, [c822] VARCHAR(255) SPARSE NULL, [c823] VARCHAR(255) SPARSE NULL, [c824] VARCHAR(255) SPARSE NULL, [c825] VARCHAR(255) SPARSE NULL, [c826] VARCHAR(255) SPARSE NULL, [c827] VARCHAR(255) SPARSE NULL, [c828] VARCHAR(255) SPARSE NULL, [c829] VARCHAR(255) SPARSE NULL,	[c830] VARCHAR(255) SPARSE NULL, [c831] VARCHAR(255) SPARSE NULL, [c832] VARCHAR(255) SPARSE NULL, [c833] VARCHAR(255) SPARSE NULL, [c834] VARCHAR(255) SPARSE NULL, [c835] VARCHAR(255) SPARSE NULL, [c836] VARCHAR(255) SPARSE NULL, [c837] VARCHAR(255) SPARSE NULL, [c838] VARCHAR(255) SPARSE NULL, [c839] VARCHAR(255) SPARSE NULL,	[c840] VARCHAR(255) SPARSE NULL, [c841] VARCHAR(255) SPARSE NULL, [c842] VARCHAR(255) SPARSE NULL, [c843] VARCHAR(255) SPARSE NULL, [c844] VARCHAR(255) SPARSE NULL, [c845] VARCHAR(255) SPARSE NULL, [c846] VARCHAR(255) SPARSE NULL, [c847] VARCHAR(255) SPARSE NULL, [c848] VARCHAR(255) SPARSE NULL, [c849] VARCHAR(255) SPARSE NULL,	[c850] VARCHAR(255) SPARSE NULL, [c851] VARCHAR(255) SPARSE NULL, [c852] VARCHAR(255) SPARSE NULL, [c853] VARCHAR(255) SPARSE NULL, [c854] VARCHAR(255) SPARSE NULL, [c855] VARCHAR(255) SPARSE NULL, [c856] VARCHAR(255) SPARSE NULL, [c857] VARCHAR(255) SPARSE NULL, [c858] VARCHAR(255) SPARSE NULL, [c859] VARCHAR(255) SPARSE NULL,	[c860] VARCHAR(255) SPARSE NULL, [c861] VARCHAR(255) SPARSE NULL, [c862] VARCHAR(255) SPARSE NULL, [c863] VARCHAR(255) SPARSE NULL, [c864] VARCHAR(255) SPARSE NULL, [c865] VARCHAR(255) SPARSE NULL, [c866] VARCHAR(255) SPARSE NULL, [c867] VARCHAR(255) SPARSE NULL, [c868] VARCHAR(255) SPARSE NULL, [c869] VARCHAR(255) SPARSE NULL,	[c870] VARCHAR(255) SPARSE NULL, [c871] VARCHAR(255) SPARSE NULL, [c872] VARCHAR(255) SPARSE NULL, [c873] VARCHAR(255) SPARSE NULL, [c874] VARCHAR(255) SPARSE NULL, [c875] VARCHAR(255) SPARSE NULL, [c876] VARCHAR(255) SPARSE NULL, [c877] VARCHAR(255) SPARSE NULL, [c878] VARCHAR(255) SPARSE NULL, [c879] VARCHAR(255) SPARSE NULL,	[c880] VARCHAR(255) SPARSE NULL, [c881] VARCHAR(255) SPARSE NULL, [c882] VARCHAR(255) SPARSE NULL, [c883] VARCHAR(255) SPARSE NULL, [c884] VARCHAR(255) SPARSE NULL, [c885] VARCHAR(255) SPARSE NULL, [c886] VARCHAR(255) SPARSE NULL, [c887] VARCHAR(255) SPARSE NULL, [c888] VARCHAR(255) SPARSE NULL, [c889] VARCHAR(255) SPARSE NULL,	[c890] VARCHAR(255) SPARSE NULL, [c891] VARCHAR(255) SPARSE NULL, [c892] VARCHAR(255) SPARSE NULL, [c893] VARCHAR(255) SPARSE NULL, [c894] VARCHAR(255) SPARSE NULL, [c895] VARCHAR(255) SPARSE NULL, [c896] VARCHAR(255) SPARSE NULL, [c897] VARCHAR(255) SPARSE NULL, [c898] VARCHAR(255) SPARSE NULL, [c899] VARCHAR(255) SPARSE NULL,
	[c900] VARCHAR(255) SPARSE NULL, [c901] VARCHAR(255) SPARSE NULL, [c902] VARCHAR(255) SPARSE NULL, [c903] VARCHAR(255) SPARSE NULL, [c904] VARCHAR(255) SPARSE NULL, [c905] VARCHAR(255) SPARSE NULL, [c906] VARCHAR(255) SPARSE NULL, [c907] VARCHAR(255) SPARSE NULL, [c908] VARCHAR(255) SPARSE NULL, [c909] VARCHAR(255) SPARSE NULL,	[c910] VARCHAR(255) SPARSE NULL, [c911] VARCHAR(255) SPARSE NULL, [c912] VARCHAR(255) SPARSE NULL, [c913] VARCHAR(255) SPARSE NULL, [c914] VARCHAR(255) SPARSE NULL, [c915] VARCHAR(255) SPARSE NULL, [c916] VARCHAR(255) SPARSE NULL, [c917] VARCHAR(255) SPARSE NULL, [c918] VARCHAR(255) SPARSE NULL, [c919] VARCHAR(255) SPARSE NULL, 	[c920] VARCHAR(255) SPARSE NULL, [c921] VARCHAR(255) SPARSE NULL, [c922] VARCHAR(255) SPARSE NULL, [c923] VARCHAR(255) SPARSE NULL, [c924] VARCHAR(255) SPARSE NULL, [c925] VARCHAR(255) SPARSE NULL, [c926] VARCHAR(255) SPARSE NULL, [c927] VARCHAR(255) SPARSE NULL, [c928] VARCHAR(255) SPARSE NULL, [c929] VARCHAR(255) SPARSE NULL,	[c930] VARCHAR(255) SPARSE NULL, [c931] VARCHAR(255) SPARSE NULL, [c932] VARCHAR(255) SPARSE NULL, [c933] VARCHAR(255) SPARSE NULL, [c934] VARCHAR(255) SPARSE NULL, [c935] VARCHAR(255) SPARSE NULL, [c936] VARCHAR(255) SPARSE NULL, [c937] VARCHAR(255) SPARSE NULL, [c938] VARCHAR(255) SPARSE NULL, [c939] VARCHAR(255) SPARSE NULL,	[c940] VARCHAR(255) SPARSE NULL, [c941] VARCHAR(255) SPARSE NULL, [c942] VARCHAR(255) SPARSE NULL, [c943] VARCHAR(255) SPARSE NULL, [c944] VARCHAR(255) SPARSE NULL, [c945] VARCHAR(255) SPARSE NULL, [c946] VARCHAR(255) SPARSE NULL, [c947] VARCHAR(255) SPARSE NULL, [c948] VARCHAR(255) SPARSE NULL, [c949] VARCHAR(255) SPARSE NULL,	[c950] VARCHAR(255) SPARSE NULL, [c951] VARCHAR(255) SPARSE NULL, [c952] VARCHAR(255) SPARSE NULL, [c953] VARCHAR(255) SPARSE NULL, [c954] VARCHAR(255) SPARSE NULL, [c955] VARCHAR(255) SPARSE NULL, [c956] VARCHAR(255) SPARSE NULL, [c957] VARCHAR(255) SPARSE NULL, [c958] VARCHAR(255) SPARSE NULL, [c959] VARCHAR(255) SPARSE NULL,	[c960] VARCHAR(255) SPARSE NULL, [c961] VARCHAR(255) SPARSE NULL, [c962] VARCHAR(255) SPARSE NULL, [c963] VARCHAR(255) SPARSE NULL, [c964] VARCHAR(255) SPARSE NULL, [c965] VARCHAR(255) SPARSE NULL, [c966] VARCHAR(255) SPARSE NULL, [c967] VARCHAR(255) SPARSE NULL, [c968] VARCHAR(255) SPARSE NULL, [c969] VARCHAR(255) SPARSE NULL,	[c970] VARCHAR(255) SPARSE NULL, [c971] VARCHAR(255) SPARSE NULL, [c972] VARCHAR(255) SPARSE NULL, [c973] VARCHAR(255) SPARSE NULL, [c974] VARCHAR(255) SPARSE NULL, [c975] VARCHAR(255) SPARSE NULL, [c976] VARCHAR(255) SPARSE NULL, [c977] VARCHAR(255) SPARSE NULL, [c978] VARCHAR(255) SPARSE NULL, [c979] VARCHAR(255) SPARSE NULL,  	[c980] VARCHAR(255) SPARSE NULL, [c981] VARCHAR(255) SPARSE NULL, [c982] VARCHAR(255) SPARSE NULL, [c983] VARCHAR(255) SPARSE NULL, [c984] VARCHAR(255) SPARSE NULL, [c985] VARCHAR(255) SPARSE NULL, [c986] VARCHAR(255) SPARSE NULL, [c987] VARCHAR(255) SPARSE NULL, [c988] VARCHAR(255) SPARSE NULL, [c989] VARCHAR(255) SPARSE NULL,	[c990] VARCHAR(255) SPARSE NULL, [c991] VARCHAR(255) SPARSE NULL, [c992] VARCHAR(255) SPARSE NULL, [c993] VARCHAR(255) SPARSE NULL, [c994] VARCHAR(255) SPARSE NULL, [c995] VARCHAR(255) SPARSE NULL, [c996] VARCHAR(255) SPARSE NULL, [c997] VARCHAR(255) SPARSE NULL, [c998] VARCHAR(255) SPARSE NULL, [c999] VARCHAR(255) SPARSE NULL,
	[c1000] VARCHAR(255) SPARSE NULL);
GO

CREATE CLUSTERED INDEX [SparseInsertAll_CL]
	ON [SparseInsertAll] ([ID]);


DECLARE @TestID INT;
DECLARE @DBID INT;

DECLARE @RandomValue INT;
DECLARE @Type INT;
DECLARE @NameLength INT;
DECLARE @ColumnStart INT;

DECLARE @RowLoop INT = 1;
DECLARE @ColumnLoop INT;

DECLARE @ExecString VARCHAR (8000);
DECLARE @ExecString2 VARCHAR (8000);

/* Setup test into */

INSERT INTO [SparseTracking].[dbo].[TrackTests] ([TestName]) VALUES ('SparseInsertAll');
SELECT @TestID = MAX(TestID) FROM [SparseTracking].[dbo].[TrackTests];
SELECT @DBID = DB_ID();

/* Capture file stats */

IF EXISTS (SELECT * FROM [tempdb].[sys].[objects] WHERE [name] = N'##SQLskillsFileStats1')
  DROP TABLE [##SQLskillsFileStats1];
 
IF EXISTS (SELECT * FROM [tempdb].[sys].[objects] WHERE [name] = N'##SQLskillsFileStats2')
  DROP TABLE [##SQLskillsFileStats2];

SELECT [database_id], [file_id], [sample_ms], [num_of_reads], [num_of_bytes_read], [io_stall_read_ms],
[num_of_writes], [num_of_bytes_written], [io_stall_write_ms], [io_stall]
INTO ##SQLskillsFileStats1
FROM sys.dm_io_virtual_file_stats(@DBID, NULL)


/* Capture wait stats */

IF EXISTS (SELECT * FROM [tempdb].[sys].[objects] WHERE [name] = N'##SQLskillsWaitStats1')
  DROP TABLE [##SQLskillsWaitStats1];
 
IF EXISTS (SELECT * FROM [tempdb].[sys].[objects] WHERE [name] = N'##SQLskillsWaitStats2')
  DROP TABLE [##SQLskillsWaitStats2];

SELECT [wait_type], [waiting_tasks_count], [wait_time_ms],
  [max_wait_time_ms], [signal_wait_time_ms]
INTO ##SQLskillsWaitStats1
FROM sys.dm_os_wait_stats;

/* set start time */
UPDATE [SparseTracking].[dbo].[TrackTests] SET [TestStartTime] = SYSDATETIME() WHERE [TestID] = @TestID;


-- insert all values for [SparseInsertAll] table
WHILE (@RowLoop < 10000001) 
BEGIN
	-- Calculate doc name length
	SET @NameLength = CONVERT (INT, RAND () * 100) + 1;
	SET @Type = CONVERT (INT, RAND () * 49) + 1;
	SET @ColumnStart = @Type * 20;

	-- Add the columns we're inserting into
	SELECT @ColumnLoop = @ColumnStart;
	SELECT @ExecString = ' ([Name], [Type], [c' +
		CAST (@ColumnLoop AS VARCHAR);
	SELECT @ColumnLoop = @ColumnLoop + 1;
	WHILE (@ColumnLoop < (@ColumnStart + 20))
	BEGIN
		SELECT @ExecString = @ExecString + '], [c' +
			CAST(@ColumnLoop AS VARCHAR);
		SELECT @ColumnLoop = @ColumnLoop + 1;
	END;
	SELECT @ExecString = @ExecString + ']) VALUES (''';

	-- Add the random document name
	SELECT @ColumnLoop = 0;
	WHILE (@ColumnLoop < @NameLength)
	BEGIN
		SELECT @ExecString = @ExecString + CHAR (97 +
			CONVERT (INT, RAND () * 26));
		SELECT @ColumnLoop = @ColumnLoop + 1;
	END;
		
	-- Add the random column values
	SELECT @ExecString = @ExecString + ''', ' +
		CAST (@Type AS VARCHAR) + ', ' +
			CAST (CONVERT (INT, RAND () * 100000) AS VARCHAR);
		
	SELECT @ColumnLoop = 1;
	WHILE (@ColumnLoop < 20)
	BEGIN
		SELECT @ExecString = @ExecString + ', ' +
			CAST (CONVERT (INT, RAND () * 100000) AS VARCHAR);
		SELECT @ColumnLoop = @ColumnLoop + 1;
	END;
	SELECT @ExecString = @ExecString + ')';

	SELECT @ExecString2 =
		'INSERT INTO [SparseInsertAll] ' + @ExecString;
	EXEC (@ExecString2);

	SELECT @RowLoop = @RowLoop + 1;
END;

/* set the stop time */
UPDATE [SparseTracking].[dbo].[TrackTests] SET [TestEndTime] = SYSDATETIME() WHERE [TestID] = @TestID;

/* capture wait stats again */
SELECT [wait_type], [waiting_tasks_count], [wait_time_ms],
  [max_wait_time_ms], [signal_wait_time_ms]
INTO ##SQLskillsWaitStats2
FROM sys.dm_os_wait_stats;

/* capture file stats again */
SELECT [database_id], [file_id], [sample_ms], [num_of_reads], [num_of_bytes_read], [io_stall_read_ms],
[num_of_writes], [num_of_bytes_written], [io_stall_write_ms], [io_stall]
INTO ##SQLskillsFileStats2
FROM sys.dm_io_virtual_file_stats(@DBID, NULL)

/* capture index stats */
INSERT INTO [SparseTracking].[dbo].[IndexStats]
           ([TestID]
           ,[database_id]
           ,[object_id]
           ,[index_id]
           ,[partition_number]
           ,[index_type_desc]
           ,[alloc_unit_type_desc]
           ,[index_depth]
           ,[index_level]
           ,[avg_fragmentation_in_percent]
           ,[fragment_count]
           ,[avg_fragment_size_in_pages]
           ,[page_count]
           ,[avg_page_space_used_in_percent]
           ,[record_count]
           ,[ghost_record_count]
           ,[version_ghost_record_count]
           ,[min_record_size_in_bytes]
           ,[max_record_size_in_bytes]
           ,[avg_record_size_in_bytes]
           ,[forwarded_record_count]
           ,[compressed_page_count])
SELECT @TestID, [database_id],[object_id],[index_id],[partition_number],[index_type_desc],
[alloc_unit_type_desc],[index_depth],[index_level],[avg_fragmentation_in_percent],
[fragment_count],[avg_fragment_size_in_pages],[page_count],[avg_page_space_used_in_percent],
[record_count],[ghost_record_count],[version_ghost_record_count],[min_record_size_in_bytes],
[max_record_size_in_bytes],[avg_record_size_in_bytes],[forwarded_record_count],[compressed_page_count]
from sys.dm_db_index_physical_stats(@DBID, OBJECT_ID(N'SparseInsertAll'),NULL, NULL, 'Detailed');



/* store wait stats */
WITH [DiffWaits] AS
(
  SELECT   -- Waits that weren't in the first snapshot
      [ts2].[wait_type],
      [ts2].[wait_time_ms],
      [ts2].[signal_wait_time_ms],
      [ts2].[waiting_tasks_count]
    FROM [##SQLskillsWaitStats2] AS [ts2]
    LEFT OUTER JOIN [##SQLskillsWaitStats1] AS [ts1]
    ON [ts2].[wait_type] = [ts1].[wait_type]
    WHERE [ts1].[wait_type] IS NULL
    AND [ts2].[wait_time_ms] > 0
  UNION
  SELECT   -- Diff of waits in both snapshots
      [ts2].[wait_type],
      [ts2].[wait_time_ms] - [ts1].[wait_time_ms] AS [wait_time_ms],
      [ts2].[signal_wait_time_ms] - [ts1].[signal_wait_time_ms] AS [signal_wait_time_ms],
      [ts2].[waiting_tasks_count] - [ts1].[waiting_tasks_count] AS [waiting_tasks_count]
    FROM [##SQLskillsWaitStats2] AS [ts2]
    LEFT OUTER JOIN [##SQLskillsWaitStats1] AS [ts1]
    ON [ts2].[wait_type] = [ts1].[wait_type]
    WHERE [ts1].[wait_type] IS NOT NULL
    AND [ts2].[waiting_tasks_count] - [ts1].[waiting_tasks_count] > 0
    AND [ts2].[wait_time_ms] - [ts1].[wait_time_ms] > 0
),
[Waits] AS
(
  SELECT
    [wait_type],
    [wait_time_ms] / 1000.0 AS [WaitS],
    ([wait_time_ms] - [signal_wait_time_ms]) / 1000.0 AS [ResourceS],
    [signal_wait_time_ms] / 1000.0 AS [SignalS],
    [waiting_tasks_count] AS [WaitCount],
    100.0 * [wait_time_ms] / SUM ([wait_time_ms]) OVER() AS [Percentage],
    ROW_NUMBER() OVER(ORDER BY [wait_time_ms] DESC) AS [RowNum]
  FROM [DiffWaits]
  WHERE [wait_type] NOT IN (SELECT WaitType FROM SparseTracking.dbo.WaitsToIgnore)
)


INSERT INTO [SparseTracking].[dbo].[WaitStats]
(
	[TestID],
  [WaitType] ,
  [Wait_S] ,
  [Resource_S] ,
  [Signal_S] ,
  [WaitCount] ,
  [Percentage] ,
  [AvgWait_S] ,
  [AvgRes_S] ,
  [AvgSig_S]
)
SELECT
	@TestID,
  [W1].[wait_type],
  CAST ([W1].[WaitS] AS DECIMAL (16, 2)) ,
  CAST ([W1].[ResourceS] AS DECIMAL (16, 2)) ,
  CAST ([W1].[SignalS] AS DECIMAL (16, 2)) ,
  [W1].[WaitCount] ,
  CAST ([W1].[Percentage] AS DECIMAL (5, 2)) ,
  CAST (([W1].[WaitS] / [W1].[WaitCount]) AS DECIMAL (16, 4)) ,
  CAST (([W1].[ResourceS] / [W1].[WaitCount]) AS DECIMAL (16, 4)) ,
  CAST (([W1].[SignalS] / [W1].[WaitCount]) AS DECIMAL (16, 4))
FROM [Waits] AS [W1]
INNER JOIN [Waits] AS [W2]
ON [W2].[RowNum] <= [W1].[RowNum]
GROUP BY [W1].[RowNum], [W1].[wait_type], [W1].[WaitS], [W1].[ResourceS], 
  [W1].[SignalS], [W1].[WaitCount], [W1].[Percentage]
HAVING SUM ([W2].[Percentage]) - [W1].[Percentage] < 95; -- percentage threshold


/* store file stats */

INSERT INTO [SparseTracking].[dbo].[FileStats]
           ([TestID]
           ,[database_id]
           ,[file_id]
           ,[sample_ms]
           ,[num_of_reads]
           ,[num_of_bytes_read]
           ,[io_stall_read_ms]
           ,[num_of_writes]
           ,[num_of_bytes_written]
           ,[io_stall_write_ms]
           ,[io_stall])
SELECT
@TestID,
f.database_id, f.file_id, 
(f.sample_ms - i.sample_ms) AS sample_ms, 
(f.num_of_reads - i.num_of_reads) AS num_of_reads,
(f.num_of_bytes_read - i.num_of_bytes_read ) AS num_of_bytes_read,
(f.io_stall_read_ms - i.io_stall_read_ms ) AS io_stall_read_ms,
(f.num_of_writes - i.num_of_writes ) AS num_of_writes,
(f.num_of_bytes_written - i.num_of_bytes_written ) AS num_of_bytes_written,
(f.io_stall_write_ms - i.io_stall_write_ms ) AS io_stall_write_ms,
(f.io_stall - i.io_stall ) AS io_stall
FROM ##SQLskillsFileStats1 i
JOIN ##SQLskillsFileStats2 f on i.database_id = f.database_id and i.file_id = f.file_id


USE [master];
GO

DROP DATABASE [SparseTest];
GO





/*
	START TEST NonSparseInsertOne
*/
CREATE DATABASE [SparseTest]
 CONTAINMENT = NONE
 ON  PRIMARY 
( NAME = N'SparseTest', FILENAME = N'M:\Data\Sparse\SparseTest.mdf' , SIZE = 102400MB , FILEGROWTH = 524288KB )
 LOG ON 
( NAME = N'SparseTest_log', FILENAME = N'M:\Data\Sparse\SparseTest_log.ldf' , SIZE = 1048576KB , FILEGROWTH = 524288KB )
GO
ALTER DATABASE [SparseTest] SET RECOVERY SIMPLE 
GO

USE [SparseTest];
GO

CREATE TABLE [NonSparseInsertOne] (
	[ID] INT IDENTITY, [Name] VARCHAR (100), [Type] INT,
	[c4] VARCHAR(255) NULL, [c5] VARCHAR(255) NULL, [c6] VARCHAR(255) NULL, [c7] VARCHAR(255) NULL, [c8] VARCHAR(255) NULL, [c9] VARCHAR(255) NULL,	[c10] VARCHAR(255) NULL, [c11] VARCHAR(255) NULL, [c12] VARCHAR(255) NULL, [c13] VARCHAR(255) NULL, [c14] VARCHAR(255) NULL, [c15] VARCHAR(255) NULL, [c16] VARCHAR(255) NULL, [c17] VARCHAR(255) NULL, [c18] VARCHAR(255) NULL, [c19] VARCHAR(255) NULL,	[c20] VARCHAR(255) NULL, [c21] VARCHAR(255) NULL, [c22] VARCHAR(255) NULL, [c23] VARCHAR(255) NULL, [c24] VARCHAR(255) NULL, [c25] VARCHAR(255) NULL, [c26] VARCHAR(255) NULL, [c27] VARCHAR(255) NULL, [c28] VARCHAR(255) NULL, [c29] VARCHAR(255) NULL,	[c30] VARCHAR(255) NULL, [c31] VARCHAR(255) NULL, [c32] VARCHAR(255) NULL, [c33] VARCHAR(255) NULL, [c34] VARCHAR(255) NULL, [c35] VARCHAR(255) NULL, [c36] VARCHAR(255) NULL, [c37] VARCHAR(255) NULL, [c38] VARCHAR(255) NULL, [c39] VARCHAR(255) NULL,	[c40] VARCHAR(255) NULL, [c41] VARCHAR(255) NULL, [c42] VARCHAR(255) NULL, [c43] VARCHAR(255) NULL, [c44] VARCHAR(255) NULL, [c45] VARCHAR(255) NULL, [c46] VARCHAR(255) NULL, [c47] VARCHAR(255) NULL, [c48] VARCHAR(255) NULL, [c49] VARCHAR(255) NULL,	[c50] VARCHAR(255) NULL, [c51] VARCHAR(255) NULL, [c52] VARCHAR(255) NULL, [c53] VARCHAR(255) NULL, [c54] VARCHAR(255) NULL, [c55] VARCHAR(255) NULL, [c56] VARCHAR(255) NULL, [c57] VARCHAR(255) NULL, [c58] VARCHAR(255) NULL, [c59] VARCHAR(255) NULL,	[c60] VARCHAR(255) NULL, [c61] VARCHAR(255) NULL, [c62] VARCHAR(255) NULL, [c63] VARCHAR(255) NULL, [c64] VARCHAR(255) NULL, [c65] VARCHAR(255) NULL, [c66] VARCHAR(255) NULL, [c67] VARCHAR(255) NULL, [c68] VARCHAR(255) NULL, [c69] VARCHAR(255) NULL,	[c70] VARCHAR(255) NULL, [c71] VARCHAR(255) NULL, [c72] VARCHAR(255) NULL, [c73] VARCHAR(255) NULL, [c74] VARCHAR(255) NULL, [c75] VARCHAR(255) NULL, [c76] VARCHAR(255) NULL, [c77] VARCHAR(255) NULL, [c78] VARCHAR(255) NULL, [c79] VARCHAR(255) NULL,	[c80] VARCHAR(255) NULL, [c81] VARCHAR(255) NULL, [c82] VARCHAR(255) NULL, [c83] VARCHAR(255) NULL, [c84] VARCHAR(255) NULL, [c85] VARCHAR(255) NULL, [c86] VARCHAR(255) NULL, [c87] VARCHAR(255) NULL, [c88] VARCHAR(255) NULL, [c89] VARCHAR(255) NULL,	[c90] VARCHAR(255) NULL, [c91] VARCHAR(255) NULL, [c92] VARCHAR(255) NULL, [c93] VARCHAR(255) NULL, [c94] VARCHAR(255) NULL, [c95] VARCHAR(255) NULL, [c96] VARCHAR(255) NULL, [c97] VARCHAR(255) NULL, [c98] VARCHAR(255) NULL, [c99] VARCHAR(255) NULL,
	[c100] VARCHAR(255) NULL, [c101] VARCHAR(255) NULL, [c102] VARCHAR(255) NULL, [c103] VARCHAR(255) NULL, [c104] VARCHAR(255) NULL, [c105] VARCHAR(255) NULL, [c106] VARCHAR(255) NULL, [c107] VARCHAR(255) NULL, [c108] VARCHAR(255) NULL, [c109] VARCHAR(255) NULL,	[c110] VARCHAR(255) NULL, [c111] VARCHAR(255) NULL, [c112] VARCHAR(255) NULL, [c113] VARCHAR(255) NULL, [c114] VARCHAR(255) NULL, [c115] VARCHAR(255) NULL, [c116] VARCHAR(255) NULL, [c117] VARCHAR(255) NULL, [c118] VARCHAR(255) NULL, [c119] VARCHAR(255) NULL,	[c120] VARCHAR(255) NULL, [c121] VARCHAR(255) NULL, [c122] VARCHAR(255) NULL, [c123] VARCHAR(255) NULL, [c124] VARCHAR(255) NULL, [c125] VARCHAR(255) NULL, [c126] VARCHAR(255) NULL, [c127] VARCHAR(255) NULL, [c128] VARCHAR(255) NULL, [c129] VARCHAR(255) NULL,	[c130] VARCHAR(255) NULL, [c131] VARCHAR(255) NULL, [c132] VARCHAR(255) NULL, [c133] VARCHAR(255) NULL, [c134] VARCHAR(255) NULL, [c135] VARCHAR(255) NULL, [c136] VARCHAR(255) NULL, [c137] VARCHAR(255) NULL, [c138] VARCHAR(255) NULL, [c139] VARCHAR(255) NULL,	[c140] VARCHAR(255) NULL, [c141] VARCHAR(255) NULL, [c142] VARCHAR(255) NULL, [c143] VARCHAR(255) NULL, [c144] VARCHAR(255) NULL, [c145] VARCHAR(255) NULL, [c146] VARCHAR(255) NULL, [c147] VARCHAR(255) NULL, [c148] VARCHAR(255) NULL, [c149] VARCHAR(255) NULL,	[c150] VARCHAR(255) NULL, [c151] VARCHAR(255) NULL, [c152] VARCHAR(255) NULL, [c153] VARCHAR(255) NULL, [c154] VARCHAR(255) NULL, [c155] VARCHAR(255) NULL, [c156] VARCHAR(255) NULL, [c157] VARCHAR(255) NULL, [c158] VARCHAR(255) NULL, [c159] VARCHAR(255) NULL,	[c160] VARCHAR(255) NULL, [c161] VARCHAR(255) NULL, [c162] VARCHAR(255) NULL, [c163] VARCHAR(255) NULL, [c164] VARCHAR(255) NULL, [c165] VARCHAR(255) NULL, [c166] VARCHAR(255) NULL, [c167] VARCHAR(255) NULL, [c168] VARCHAR(255) NULL, [c169] VARCHAR(255) NULL,	[c170] VARCHAR(255) NULL, [c171] VARCHAR(255) NULL, [c172] VARCHAR(255) NULL, [c173] VARCHAR(255) NULL, [c174] VARCHAR(255) NULL, [c175] VARCHAR(255) NULL, [c176] VARCHAR(255) NULL, [c177] VARCHAR(255) NULL, [c178] VARCHAR(255) NULL, [c179] VARCHAR(255) NULL,	[c180] VARCHAR(255) NULL, [c181] VARCHAR(255) NULL, [c182] VARCHAR(255) NULL, [c183] VARCHAR(255) NULL, [c184] VARCHAR(255) NULL, [c185] VARCHAR(255) NULL, [c186] VARCHAR(255) NULL, [c187] VARCHAR(255) NULL, [c188] VARCHAR(255) NULL, [c189] VARCHAR(255) NULL,	[c190] VARCHAR(255) NULL, [c191] VARCHAR(255) NULL, [c192] VARCHAR(255) NULL, [c193] VARCHAR(255) NULL, [c194] VARCHAR(255) NULL, [c195] VARCHAR(255) NULL, [c196] VARCHAR(255) NULL, [c197] VARCHAR(255) NULL, [c198] VARCHAR(255) NULL, [c199] VARCHAR(255) NULL,
	[c200] VARCHAR(255) NULL, [c201] VARCHAR(255) NULL, [c202] VARCHAR(255) NULL, [c203] VARCHAR(255) NULL, [c204] VARCHAR(255) NULL, [c205] VARCHAR(255) NULL, [c206] VARCHAR(255) NULL, [c207] VARCHAR(255) NULL, [c208] VARCHAR(255) NULL, [c209] VARCHAR(255) NULL,	[c210] VARCHAR(255) NULL, [c211] VARCHAR(255) NULL, [c212] VARCHAR(255) NULL, [c213] VARCHAR(255) NULL, [c214] VARCHAR(255) NULL, [c215] VARCHAR(255) NULL, [c216] VARCHAR(255) NULL, [c217] VARCHAR(255) NULL, [c218] VARCHAR(255) NULL, [c219] VARCHAR(255) NULL,	[c220] VARCHAR(255) NULL, [c221] VARCHAR(255) NULL, [c222] VARCHAR(255) NULL, [c223] VARCHAR(255) NULL, [c224] VARCHAR(255) NULL, [c225] VARCHAR(255) NULL, [c226] VARCHAR(255) NULL, [c227] VARCHAR(255) NULL, [c228] VARCHAR(255) NULL, [c229] VARCHAR(255) NULL,	[c230] VARCHAR(255) NULL, [c231] VARCHAR(255) NULL, [c232] VARCHAR(255) NULL, [c233] VARCHAR(255) NULL, [c234] VARCHAR(255) NULL, [c235] VARCHAR(255) NULL, [c236] VARCHAR(255) NULL, [c237] VARCHAR(255) NULL, [c238] VARCHAR(255) NULL, [c239] VARCHAR(255) NULL,	[c240] VARCHAR(255) NULL, [c241] VARCHAR(255) NULL, [c242] VARCHAR(255) NULL, [c243] VARCHAR(255) NULL, [c244] VARCHAR(255) NULL, [c245] VARCHAR(255) NULL, [c246] VARCHAR(255) NULL, [c247] VARCHAR(255) NULL, [c248] VARCHAR(255) NULL, [c249] VARCHAR(255) NULL,	[c250] VARCHAR(255) NULL, [c251] VARCHAR(255) NULL, [c252] VARCHAR(255) NULL, [c253] VARCHAR(255) NULL, [c254] VARCHAR(255) NULL, [c255] VARCHAR(255) NULL, [c256] VARCHAR(255) NULL, [c257] VARCHAR(255) NULL, [c258] VARCHAR(255) NULL, [c259] VARCHAR(255) NULL,	[c260] VARCHAR(255) NULL, [c261] VARCHAR(255) NULL, [c262] VARCHAR(255) NULL, [c263] VARCHAR(255) NULL, [c264] VARCHAR(255) NULL, [c265] VARCHAR(255) NULL, [c266] VARCHAR(255) NULL, [c267] VARCHAR(255) NULL, [c268] VARCHAR(255) NULL, [c269] VARCHAR(255) NULL,	[c270] VARCHAR(255) NULL, [c271] VARCHAR(255) NULL, [c272] VARCHAR(255) NULL, [c273] VARCHAR(255) NULL, [c274] VARCHAR(255) NULL, [c275] VARCHAR(255) NULL, [c276] VARCHAR(255) NULL, [c277] VARCHAR(255) NULL, [c278] VARCHAR(255) NULL, [c279] VARCHAR(255) NULL,	[c280] VARCHAR(255) NULL, [c281] VARCHAR(255) NULL, [c282] VARCHAR(255) NULL, [c283] VARCHAR(255) NULL, [c284] VARCHAR(255) NULL, [c285] VARCHAR(255) NULL, [c286] VARCHAR(255) NULL, [c287] VARCHAR(255) NULL, [c288] VARCHAR(255) NULL, [c289] VARCHAR(255) NULL,	[c290] VARCHAR(255) NULL, [c291] VARCHAR(255) NULL, [c292] VARCHAR(255) NULL, [c293] VARCHAR(255) NULL, [c294] VARCHAR(255) NULL, [c295] VARCHAR(255) NULL, [c296] VARCHAR(255) NULL, [c297] VARCHAR(255) NULL, [c298] VARCHAR(255) NULL, [c299] VARCHAR(255) NULL,
	[c300] VARCHAR(255) NULL, [c301] VARCHAR(255) NULL, [c302] VARCHAR(255) NULL, [c303] VARCHAR(255) NULL, [c304] VARCHAR(255) NULL, [c305] VARCHAR(255) NULL, [c306] VARCHAR(255) NULL, [c307] VARCHAR(255) NULL, [c308] VARCHAR(255) NULL, [c309] VARCHAR(255) NULL,	[c310] VARCHAR(255) NULL, [c311] VARCHAR(255) NULL, [c312] VARCHAR(255) NULL, [c313] VARCHAR(255) NULL, [c314] VARCHAR(255) NULL, [c315] VARCHAR(255) NULL, [c316] VARCHAR(255) NULL, [c317] VARCHAR(255) NULL, [c318] VARCHAR(255) NULL, [c319] VARCHAR(255) NULL,	[c320] VARCHAR(255) NULL, [c321] VARCHAR(255) NULL, [c322] VARCHAR(255) NULL, [c323] VARCHAR(255) NULL, [c324] VARCHAR(255) NULL, [c325] VARCHAR(255) NULL, [c326] VARCHAR(255) NULL, [c327] VARCHAR(255) NULL, [c328] VARCHAR(255) NULL, [c329] VARCHAR(255) NULL,	[c330] VARCHAR(255) NULL, [c331] VARCHAR(255) NULL, [c332] VARCHAR(255) NULL, [c333] VARCHAR(255) NULL, [c334] VARCHAR(255) NULL, [c335] VARCHAR(255) NULL, [c336] VARCHAR(255) NULL, [c337] VARCHAR(255) NULL, [c338] VARCHAR(255) NULL, [c339] VARCHAR(255) NULL,	[c340] VARCHAR(255) NULL, [c341] VARCHAR(255) NULL, [c342] VARCHAR(255) NULL, [c343] VARCHAR(255) NULL, [c344] VARCHAR(255) NULL, [c345] VARCHAR(255) NULL, [c346] VARCHAR(255) NULL, [c347] VARCHAR(255) NULL, [c348] VARCHAR(255) NULL, [c349] VARCHAR(255) NULL,	[c350] VARCHAR(255) NULL, [c351] VARCHAR(255) NULL, [c352] VARCHAR(255) NULL, [c353] VARCHAR(255) NULL, [c354] VARCHAR(255) NULL, [c355] VARCHAR(255) NULL, [c356] VARCHAR(255) NULL, [c357] VARCHAR(255) NULL, [c358] VARCHAR(255) NULL, [c359] VARCHAR(255) NULL,	[c360] VARCHAR(255) NULL, [c361] VARCHAR(255) NULL, [c362] VARCHAR(255) NULL, [c363] VARCHAR(255) NULL, [c364] VARCHAR(255) NULL, [c365] VARCHAR(255) NULL, [c366] VARCHAR(255) NULL, [c367] VARCHAR(255) NULL, [c368] VARCHAR(255) NULL, [c369] VARCHAR(255) NULL,	[c370] VARCHAR(255) NULL, [c371] VARCHAR(255) NULL, [c372] VARCHAR(255) NULL, [c373] VARCHAR(255) NULL, [c374] VARCHAR(255) NULL, [c375] VARCHAR(255) NULL, [c376] VARCHAR(255) NULL, [c377] VARCHAR(255) NULL, [c378] VARCHAR(255) NULL, [c379] VARCHAR(255) NULL,	[c380] VARCHAR(255) NULL, [c381] VARCHAR(255) NULL, [c382] VARCHAR(255) NULL, [c383] VARCHAR(255) NULL, [c384] VARCHAR(255) NULL, [c385] VARCHAR(255) NULL, [c386] VARCHAR(255) NULL, [c387] VARCHAR(255) NULL, [c388] VARCHAR(255) NULL, [c389] VARCHAR(255) NULL,	[c390] VARCHAR(255) NULL, [c391] VARCHAR(255) NULL, [c392] VARCHAR(255) NULL, [c393] VARCHAR(255) NULL, [c394] VARCHAR(255) NULL, [c395] VARCHAR(255) NULL, [c396] VARCHAR(255) NULL, [c397] VARCHAR(255) NULL, [c398] VARCHAR(255) NULL, [c399] VARCHAR(255) NULL,
	[c400] VARCHAR(255) NULL, [c401] VARCHAR(255) NULL, [c402] VARCHAR(255) NULL, [c403] VARCHAR(255) NULL, [c404] VARCHAR(255) NULL, [c405] VARCHAR(255) NULL, [c406] VARCHAR(255) NULL, [c407] VARCHAR(255) NULL, [c408] VARCHAR(255) NULL, [c409] VARCHAR(255) NULL,	[c410] VARCHAR(255) NULL, [c411] VARCHAR(255) NULL, [c412] VARCHAR(255) NULL, [c413] VARCHAR(255) NULL, [c414] VARCHAR(255) NULL, [c415] VARCHAR(255) NULL, [c416] VARCHAR(255) NULL, [c417] VARCHAR(255) NULL, [c418] VARCHAR(255) NULL, [c419] VARCHAR(255) NULL,	[c420] VARCHAR(255) NULL, [c421] VARCHAR(255) NULL, [c422] VARCHAR(255) NULL, [c423] VARCHAR(255) NULL, [c424] VARCHAR(255) NULL, [c425] VARCHAR(255) NULL, [c426] VARCHAR(255) NULL, [c427] VARCHAR(255) NULL, [c428] VARCHAR(255) NULL, [c429] VARCHAR(255) NULL,	[c430] VARCHAR(255) NULL, [c431] VARCHAR(255) NULL, [c432] VARCHAR(255) NULL, [c433] VARCHAR(255) NULL, [c434] VARCHAR(255) NULL, [c435] VARCHAR(255) NULL, [c436] VARCHAR(255) NULL, [c437] VARCHAR(255) NULL, [c438] VARCHAR(255) NULL, [c439] VARCHAR(255) NULL,	[c440] VARCHAR(255) NULL, [c441] VARCHAR(255) NULL, [c442] VARCHAR(255) NULL, [c443] VARCHAR(255) NULL, [c444] VARCHAR(255) NULL, [c445] VARCHAR(255) NULL, [c446] VARCHAR(255) NULL, [c447] VARCHAR(255) NULL, [c448] VARCHAR(255) NULL, [c449] VARCHAR(255) NULL,	[c450] VARCHAR(255) NULL, [c451] VARCHAR(255) NULL, [c452] VARCHAR(255) NULL, [c453] VARCHAR(255) NULL, [c454] VARCHAR(255) NULL, [c455] VARCHAR(255) NULL, [c456] VARCHAR(255) NULL, [c457] VARCHAR(255) NULL, [c458] VARCHAR(255) NULL, [c459] VARCHAR(255) NULL,	[c460] VARCHAR(255) NULL, [c461] VARCHAR(255) NULL, [c462] VARCHAR(255) NULL, [c463] VARCHAR(255) NULL, [c464] VARCHAR(255) NULL, [c465] VARCHAR(255) NULL, [c466] VARCHAR(255) NULL, [c467] VARCHAR(255) NULL, [c468] VARCHAR(255) NULL, [c469] VARCHAR(255) NULL,	[c470] VARCHAR(255) NULL, [c471] VARCHAR(255) NULL, [c472] VARCHAR(255) NULL, [c473] VARCHAR(255) NULL, [c474] VARCHAR(255) NULL, [c475] VARCHAR(255) NULL, [c476] VARCHAR(255) NULL, [c477] VARCHAR(255) NULL, [c478] VARCHAR(255) NULL, [c479] VARCHAR(255) NULL,	[c480] VARCHAR(255) NULL, [c481] VARCHAR(255) NULL, [c482] VARCHAR(255) NULL, [c483] VARCHAR(255) NULL, [c484] VARCHAR(255) NULL, [c485] VARCHAR(255) NULL, [c486] VARCHAR(255) NULL, [c487] VARCHAR(255) NULL, [c488] VARCHAR(255) NULL, [c489] VARCHAR(255) NULL,	[c490] VARCHAR(255) NULL, [c491] VARCHAR(255) NULL, [c492] VARCHAR(255) NULL, [c493] VARCHAR(255) NULL, [c494] VARCHAR(255) NULL, [c495] VARCHAR(255) NULL, [c496] VARCHAR(255) NULL, [c497] VARCHAR(255) NULL, [c498] VARCHAR(255) NULL, [c499] VARCHAR(255) NULL,
	[c500] VARCHAR(255) NULL, [c501] VARCHAR(255) NULL, [c502] VARCHAR(255) NULL, [c503] VARCHAR(255) NULL, [c504] VARCHAR(255) NULL, [c505] VARCHAR(255) NULL, [c506] VARCHAR(255) NULL, [c507] VARCHAR(255) NULL, [c508] VARCHAR(255) NULL, [c509] VARCHAR(255) NULL,	[c510] VARCHAR(255) NULL, [c511] VARCHAR(255) NULL, [c512] VARCHAR(255) NULL, [c513] VARCHAR(255) NULL, [c514] VARCHAR(255) NULL, [c515] VARCHAR(255) NULL, [c516] VARCHAR(255) NULL, [c517] VARCHAR(255) NULL, [c518] VARCHAR(255) NULL, [c519] VARCHAR(255) NULL,	[c520] VARCHAR(255) NULL, [c521] VARCHAR(255) NULL, [c522] VARCHAR(255) NULL, [c523] VARCHAR(255) NULL, [c524] VARCHAR(255) NULL, [c525] VARCHAR(255) NULL, [c526] VARCHAR(255) NULL, [c527] VARCHAR(255) NULL, [c528] VARCHAR(255) NULL, [c529] VARCHAR(255) NULL,	[c530] VARCHAR(255) NULL, [c531] VARCHAR(255) NULL, [c532] VARCHAR(255) NULL, [c533] VARCHAR(255) NULL, [c534] VARCHAR(255) NULL, [c535] VARCHAR(255) NULL, [c536] VARCHAR(255) NULL, [c537] VARCHAR(255) NULL, [c538] VARCHAR(255) NULL, [c539] VARCHAR(255) NULL,	[c540] VARCHAR(255) NULL, [c541] VARCHAR(255) NULL, [c542] VARCHAR(255) NULL, [c543] VARCHAR(255) NULL, [c544] VARCHAR(255) NULL, [c545] VARCHAR(255) NULL, [c546] VARCHAR(255) NULL, [c547] VARCHAR(255) NULL, [c548] VARCHAR(255) NULL, [c549] VARCHAR(255) NULL,	[c550] VARCHAR(255) NULL, [c551] VARCHAR(255) NULL, [c552] VARCHAR(255) NULL, [c553] VARCHAR(255) NULL, [c554] VARCHAR(255) NULL, [c555] VARCHAR(255) NULL, [c556] VARCHAR(255) NULL, [c557] VARCHAR(255) NULL, [c558] VARCHAR(255) NULL, [c559] VARCHAR(255) NULL,	[c560] VARCHAR(255) NULL, [c561] VARCHAR(255) NULL, [c562] VARCHAR(255) NULL, [c563] VARCHAR(255) NULL, [c564] VARCHAR(255) NULL, [c565] VARCHAR(255) NULL, [c566] VARCHAR(255) NULL, [c567] VARCHAR(255) NULL, [c568] VARCHAR(255) NULL, [c569] VARCHAR(255) NULL,	[c570] VARCHAR(255) NULL, [c571] VARCHAR(255) NULL, [c572] VARCHAR(255) NULL, [c573] VARCHAR(255) NULL, [c574] VARCHAR(255) NULL, [c575] VARCHAR(255) NULL, [c576] VARCHAR(255) NULL, [c577] VARCHAR(255) NULL, [c578] VARCHAR(255) NULL, [c579] VARCHAR(255) NULL,	[c580] VARCHAR(255) NULL, [c581] VARCHAR(255) NULL, [c582] VARCHAR(255) NULL, [c583] VARCHAR(255) NULL, [c584] VARCHAR(255) NULL, [c585] VARCHAR(255) NULL, [c586] VARCHAR(255) NULL, [c587] VARCHAR(255) NULL, [c588] VARCHAR(255) NULL, [c589] VARCHAR(255) NULL,	[c590] VARCHAR(255) NULL, [c591] VARCHAR(255) NULL, [c592] VARCHAR(255) NULL, [c593] VARCHAR(255) NULL, [c594] VARCHAR(255) NULL, [c595] VARCHAR(255) NULL, [c596] VARCHAR(255) NULL, [c597] VARCHAR(255) NULL, [c598] VARCHAR(255) NULL, [c599] VARCHAR(255) NULL,
	[c600] VARCHAR(255) NULL, [c601] VARCHAR(255) NULL, [c602] VARCHAR(255) NULL, [c603] VARCHAR(255) NULL, [c604] VARCHAR(255) NULL, [c605] VARCHAR(255) NULL, [c606] VARCHAR(255) NULL, [c607] VARCHAR(255) NULL, [c608] VARCHAR(255) NULL, [c609] VARCHAR(255) NULL,	[c610] VARCHAR(255) NULL, [c611] VARCHAR(255) NULL, [c612] VARCHAR(255) NULL, [c613] VARCHAR(255) NULL, [c614] VARCHAR(255) NULL, [c615] VARCHAR(255) NULL, [c616] VARCHAR(255) NULL, [c617] VARCHAR(255) NULL, [c618] VARCHAR(255) NULL, [c619] VARCHAR(255) NULL,	[c620] VARCHAR(255) NULL, [c621] VARCHAR(255) NULL, [c622] VARCHAR(255) NULL, [c623] VARCHAR(255) NULL, [c624] VARCHAR(255) NULL, [c625] VARCHAR(255) NULL, [c626] VARCHAR(255) NULL, [c627] VARCHAR(255) NULL, [c628] VARCHAR(255) NULL, [c629] VARCHAR(255) NULL,	[c630] VARCHAR(255) NULL, [c631] VARCHAR(255) NULL, [c632] VARCHAR(255) NULL, [c633] VARCHAR(255) NULL, [c634] VARCHAR(255) NULL, [c635] VARCHAR(255) NULL, [c636] VARCHAR(255) NULL, [c637] VARCHAR(255) NULL, [c638] VARCHAR(255) NULL, [c639] VARCHAR(255) NULL,	[c640] VARCHAR(255) NULL, [c641] VARCHAR(255) NULL, [c642] VARCHAR(255) NULL, [c643] VARCHAR(255) NULL, [c644] VARCHAR(255) NULL, [c645] VARCHAR(255) NULL, [c646] VARCHAR(255) NULL, [c647] VARCHAR(255) NULL, [c648] VARCHAR(255) NULL, [c649] VARCHAR(255) NULL,	[c650] VARCHAR(255) NULL, [c651] VARCHAR(255) NULL, [c652] VARCHAR(255) NULL, [c653] VARCHAR(255) NULL, [c654] VARCHAR(255) NULL, [c655] VARCHAR(255) NULL, [c656] VARCHAR(255) NULL, [c657] VARCHAR(255) NULL, [c658] VARCHAR(255) NULL, [c659] VARCHAR(255) NULL,	[c660] VARCHAR(255) NULL, [c661] VARCHAR(255) NULL, [c662] VARCHAR(255) NULL, [c663] VARCHAR(255) NULL, [c664] VARCHAR(255) NULL, [c665] VARCHAR(255) NULL, [c666] VARCHAR(255) NULL, [c667] VARCHAR(255) NULL, [c668] VARCHAR(255) NULL, [c669] VARCHAR(255) NULL,	[c670] VARCHAR(255) NULL, [c671] VARCHAR(255) NULL, [c672] VARCHAR(255) NULL, [c673] VARCHAR(255) NULL, [c674] VARCHAR(255) NULL, [c675] VARCHAR(255) NULL, [c676] VARCHAR(255) NULL, [c677] VARCHAR(255) NULL, [c678] VARCHAR(255) NULL, [c679] VARCHAR(255) NULL,	[c680] VARCHAR(255) NULL, [c681] VARCHAR(255) NULL, [c682] VARCHAR(255) NULL, [c683] VARCHAR(255) NULL, [c684] VARCHAR(255) NULL, [c685] VARCHAR(255) NULL, [c686] VARCHAR(255) NULL, [c687] VARCHAR(255) NULL, [c688] VARCHAR(255) NULL, [c689] VARCHAR(255) NULL,	[c690] VARCHAR(255) NULL, [c691] VARCHAR(255) NULL, [c692] VARCHAR(255) NULL, [c693] VARCHAR(255) NULL, [c694] VARCHAR(255) NULL, [c695] VARCHAR(255) NULL, [c696] VARCHAR(255) NULL, [c697] VARCHAR(255) NULL, [c698] VARCHAR(255) NULL, [c699] VARCHAR(255) NULL,
	[c700] VARCHAR(255) NULL, [c701] VARCHAR(255) NULL, [c702] VARCHAR(255) NULL, [c703] VARCHAR(255) NULL, [c704] VARCHAR(255) NULL, [c705] VARCHAR(255) NULL, [c706] VARCHAR(255) NULL, [c707] VARCHAR(255) NULL, [c708] VARCHAR(255) NULL, [c709] VARCHAR(255) NULL,	[c710] VARCHAR(255) NULL, [c711] VARCHAR(255) NULL, [c712] VARCHAR(255) NULL, [c713] VARCHAR(255) NULL, [c714] VARCHAR(255) NULL, [c715] VARCHAR(255) NULL, [c716] VARCHAR(255) NULL, [c717] VARCHAR(255) NULL, [c718] VARCHAR(255) NULL, [c719] VARCHAR(255) NULL,	[c720] VARCHAR(255) NULL, [c721] VARCHAR(255) NULL, [c722] VARCHAR(255) NULL, [c723] VARCHAR(255) NULL, [c724] VARCHAR(255) NULL, [c725] VARCHAR(255) NULL, [c726] VARCHAR(255) NULL, [c727] VARCHAR(255) NULL, [c728] VARCHAR(255) NULL, [c729] VARCHAR(255) NULL,	[c730] VARCHAR(255) NULL, [c731] VARCHAR(255) NULL, [c732] VARCHAR(255) NULL, [c733] VARCHAR(255) NULL, [c734] VARCHAR(255) NULL, [c735] VARCHAR(255) NULL, [c736] VARCHAR(255) NULL, [c737] VARCHAR(255) NULL, [c738] VARCHAR(255) NULL, [c739] VARCHAR(255) NULL,	[c740] VARCHAR(255) NULL, [c741] VARCHAR(255) NULL, [c742] VARCHAR(255) NULL, [c743] VARCHAR(255) NULL, [c744] VARCHAR(255) NULL, [c745] VARCHAR(255) NULL, [c746] VARCHAR(255) NULL, [c747] VARCHAR(255) NULL, [c748] VARCHAR(255) NULL, [c749] VARCHAR(255) NULL,	[c750] VARCHAR(255) NULL, [c751] VARCHAR(255) NULL, [c752] VARCHAR(255) NULL, [c753] VARCHAR(255) NULL, [c754] VARCHAR(255) NULL, [c755] VARCHAR(255) NULL, [c756] VARCHAR(255) NULL, [c757] VARCHAR(255) NULL, [c758] VARCHAR(255) NULL, [c759] VARCHAR(255) NULL,	[c760] VARCHAR(255) NULL, [c761] VARCHAR(255) NULL, [c762] VARCHAR(255) NULL, [c763] VARCHAR(255) NULL, [c764] VARCHAR(255) NULL, [c765] VARCHAR(255) NULL, [c766] VARCHAR(255) NULL, [c767] VARCHAR(255) NULL, [c768] VARCHAR(255) NULL, [c769] VARCHAR(255) NULL,	[c770] VARCHAR(255) NULL, [c771] VARCHAR(255) NULL, [c772] VARCHAR(255) NULL, [c773] VARCHAR(255) NULL, [c774] VARCHAR(255) NULL, [c775] VARCHAR(255) NULL, [c776] VARCHAR(255) NULL, [c777] VARCHAR(255) NULL, [c778] VARCHAR(255) NULL, [c779] VARCHAR(255) NULL,	[c780] VARCHAR(255) NULL, [c781] VARCHAR(255) NULL, [c782] VARCHAR(255) NULL, [c783] VARCHAR(255) NULL, [c784] VARCHAR(255) NULL, [c785] VARCHAR(255) NULL, [c786] VARCHAR(255) NULL, [c787] VARCHAR(255) NULL, [c788] VARCHAR(255) NULL, [c789] VARCHAR(255) NULL,	[c790] VARCHAR(255) NULL, [c791] VARCHAR(255) NULL, [c792] VARCHAR(255) NULL, [c793] VARCHAR(255) NULL, [c794] VARCHAR(255) NULL, [c795] VARCHAR(255) NULL, [c796] VARCHAR(255) NULL, [c797] VARCHAR(255) NULL, [c798] VARCHAR(255) NULL, [c799] VARCHAR(255) NULL,
	[c800] VARCHAR(255) NULL, [c801] VARCHAR(255) NULL, [c802] VARCHAR(255) NULL, [c803] VARCHAR(255) NULL, [c804] VARCHAR(255) NULL, [c805] VARCHAR(255) NULL, [c806] VARCHAR(255) NULL, [c807] VARCHAR(255) NULL, [c808] VARCHAR(255) NULL, [c809] VARCHAR(255) NULL,	[c810] VARCHAR(255) NULL, [c811] VARCHAR(255) NULL, [c812] VARCHAR(255) NULL, [c813] VARCHAR(255) NULL, [c814] VARCHAR(255) NULL, [c815] VARCHAR(255) NULL, [c816] VARCHAR(255) NULL, [c817] VARCHAR(255) NULL, [c818] VARCHAR(255) NULL, [c819] VARCHAR(255) NULL,	[c820] VARCHAR(255) NULL, [c821] VARCHAR(255) NULL, [c822] VARCHAR(255) NULL, [c823] VARCHAR(255) NULL, [c824] VARCHAR(255) NULL, [c825] VARCHAR(255) NULL, [c826] VARCHAR(255) NULL, [c827] VARCHAR(255) NULL, [c828] VARCHAR(255) NULL, [c829] VARCHAR(255) NULL,	[c830] VARCHAR(255) NULL, [c831] VARCHAR(255) NULL, [c832] VARCHAR(255) NULL, [c833] VARCHAR(255) NULL, [c834] VARCHAR(255) NULL, [c835] VARCHAR(255) NULL, [c836] VARCHAR(255) NULL, [c837] VARCHAR(255) NULL, [c838] VARCHAR(255) NULL, [c839] VARCHAR(255) NULL,	[c840] VARCHAR(255) NULL, [c841] VARCHAR(255) NULL, [c842] VARCHAR(255) NULL, [c843] VARCHAR(255) NULL, [c844] VARCHAR(255) NULL, [c845] VARCHAR(255) NULL, [c846] VARCHAR(255) NULL, [c847] VARCHAR(255) NULL, [c848] VARCHAR(255) NULL, [c849] VARCHAR(255) NULL,	[c850] VARCHAR(255) NULL, [c851] VARCHAR(255) NULL, [c852] VARCHAR(255) NULL, [c853] VARCHAR(255) NULL, [c854] VARCHAR(255) NULL, [c855] VARCHAR(255) NULL, [c856] VARCHAR(255) NULL, [c857] VARCHAR(255) NULL, [c858] VARCHAR(255) NULL, [c859] VARCHAR(255) NULL,	[c860] VARCHAR(255) NULL, [c861] VARCHAR(255) NULL, [c862] VARCHAR(255) NULL, [c863] VARCHAR(255) NULL, [c864] VARCHAR(255) NULL, [c865] VARCHAR(255) NULL, [c866] VARCHAR(255) NULL, [c867] VARCHAR(255) NULL, [c868] VARCHAR(255) NULL, [c869] VARCHAR(255) NULL,	[c870] VARCHAR(255) NULL, [c871] VARCHAR(255) NULL, [c872] VARCHAR(255) NULL, [c873] VARCHAR(255) NULL, [c874] VARCHAR(255) NULL, [c875] VARCHAR(255) NULL, [c876] VARCHAR(255) NULL, [c877] VARCHAR(255) NULL, [c878] VARCHAR(255) NULL, [c879] VARCHAR(255) NULL,	[c880] VARCHAR(255) NULL, [c881] VARCHAR(255) NULL, [c882] VARCHAR(255) NULL, [c883] VARCHAR(255) NULL, [c884] VARCHAR(255) NULL, [c885] VARCHAR(255) NULL, [c886] VARCHAR(255) NULL, [c887] VARCHAR(255) NULL, [c888] VARCHAR(255) NULL, [c889] VARCHAR(255) NULL,	[c890] VARCHAR(255) NULL, [c891] VARCHAR(255) NULL, [c892] VARCHAR(255) NULL, [c893] VARCHAR(255) NULL, [c894] VARCHAR(255) NULL, [c895] VARCHAR(255) NULL, [c896] VARCHAR(255) NULL, [c897] VARCHAR(255) NULL, [c898] VARCHAR(255) NULL, [c899] VARCHAR(255) NULL,
	[c900] VARCHAR(255) NULL, [c901] VARCHAR(255) NULL, [c902] VARCHAR(255) NULL, [c903] VARCHAR(255) NULL, [c904] VARCHAR(255) NULL, [c905] VARCHAR(255) NULL, [c906] VARCHAR(255) NULL, [c907] VARCHAR(255) NULL, [c908] VARCHAR(255) NULL, [c909] VARCHAR(255) NULL,	[c910] VARCHAR(255) NULL, [c911] VARCHAR(255) NULL, [c912] VARCHAR(255) NULL, [c913] VARCHAR(255) NULL, [c914] VARCHAR(255) NULL, [c915] VARCHAR(255) NULL, [c916] VARCHAR(255) NULL, [c917] VARCHAR(255) NULL, [c918] VARCHAR(255) NULL, [c919] VARCHAR(255) NULL, 	[c920] VARCHAR(255) NULL, [c921] VARCHAR(255) NULL, [c922] VARCHAR(255) NULL, [c923] VARCHAR(255) NULL, [c924] VARCHAR(255) NULL, [c925] VARCHAR(255) NULL, [c926] VARCHAR(255) NULL, [c927] VARCHAR(255) NULL, [c928] VARCHAR(255) NULL, [c929] VARCHAR(255) NULL,	[c930] VARCHAR(255) NULL, [c931] VARCHAR(255) NULL, [c932] VARCHAR(255) NULL, [c933] VARCHAR(255) NULL, [c934] VARCHAR(255) NULL, [c935] VARCHAR(255) NULL, [c936] VARCHAR(255) NULL, [c937] VARCHAR(255) NULL, [c938] VARCHAR(255) NULL, [c939] VARCHAR(255) NULL,	[c940] VARCHAR(255) NULL, [c941] VARCHAR(255) NULL, [c942] VARCHAR(255) NULL, [c943] VARCHAR(255) NULL, [c944] VARCHAR(255) NULL, [c945] VARCHAR(255) NULL, [c946] VARCHAR(255) NULL, [c947] VARCHAR(255) NULL, [c948] VARCHAR(255) NULL, [c949] VARCHAR(255) NULL,	[c950] VARCHAR(255) NULL, [c951] VARCHAR(255) NULL, [c952] VARCHAR(255) NULL, [c953] VARCHAR(255) NULL, [c954] VARCHAR(255) NULL, [c955] VARCHAR(255) NULL, [c956] VARCHAR(255) NULL, [c957] VARCHAR(255) NULL, [c958] VARCHAR(255) NULL, [c959] VARCHAR(255) NULL,	[c960] VARCHAR(255) NULL, [c961] VARCHAR(255) NULL, [c962] VARCHAR(255) NULL, [c963] VARCHAR(255) NULL, [c964] VARCHAR(255) NULL, [c965] VARCHAR(255) NULL, [c966] VARCHAR(255) NULL, [c967] VARCHAR(255) NULL, [c968] VARCHAR(255) NULL, [c969] VARCHAR(255) NULL,	[c970] VARCHAR(255) NULL, [c971] VARCHAR(255) NULL, [c972] VARCHAR(255) NULL, [c973] VARCHAR(255) NULL, [c974] VARCHAR(255) NULL, [c975] VARCHAR(255) NULL, [c976] VARCHAR(255) NULL, [c977] VARCHAR(255) NULL, [c978] VARCHAR(255) NULL, [c979] VARCHAR(255) NULL,  	[c980] VARCHAR(255) NULL, [c981] VARCHAR(255) NULL, [c982] VARCHAR(255) NULL, [c983] VARCHAR(255) NULL, [c984] VARCHAR(255) NULL, [c985] VARCHAR(255) NULL, [c986] VARCHAR(255) NULL, [c987] VARCHAR(255) NULL, [c988] VARCHAR(255) NULL, [c989] VARCHAR(255) NULL,	[c990] VARCHAR(255) NULL, [c991] VARCHAR(255) NULL, [c992] VARCHAR(255) NULL, [c993] VARCHAR(255) NULL, [c994] VARCHAR(255) NULL, [c995] VARCHAR(255) NULL, [c996] VARCHAR(255) NULL, [c997] VARCHAR(255) NULL, [c998] VARCHAR(255) NULL, [c999] VARCHAR(255) NULL,
	[c1000] VARCHAR(255) NULL);
GO

CREATE CLUSTERED INDEX [NonSparseInsertOne_CL]
	ON [NonSparseInsertOne] ([ID]);
GO


DECLARE @TestID INT;
DECLARE @DBID INT;

DECLARE @RandomValue INT;
DECLARE @Type INT;
DECLARE @NameLength INT;
DECLARE @ColumnStart INT;

DECLARE @RowLoop INT = 1;
DECLARE @ColumnLoop INT;

DECLARE @ExecString VARCHAR (8000);
DECLARE @ExecString2 VARCHAR (8000);
DECLARE @NameString VARCHAR (1000);
SET @NameString = '';
DECLARE @MaxID INT;
DECLARE @col1Name VARCHAR(100);
DECLARE @col1Value VARCHAR(100);

/* Setup test info */

INSERT INTO [SparseTracking].[dbo].[TrackTests] ([TestName]) VALUES ('NonSparseInsertOne');
SELECT @TestID = MAX(TestID) FROM [SparseTracking].[dbo].[TrackTests];
SELECT @DBID = DB_ID();

/* Capture file stats */

IF EXISTS (SELECT * FROM [tempdb].[sys].[objects] WHERE [name] = N'##SQLskillsFileStats1')
  DROP TABLE [##SQLskillsFileStats1];
 
IF EXISTS (SELECT * FROM [tempdb].[sys].[objects] WHERE [name] = N'##SQLskillsFileStats2')
  DROP TABLE [##SQLskillsFileStats2];

SELECT [database_id], [file_id], [sample_ms], [num_of_reads], [num_of_bytes_read], [io_stall_read_ms],
[num_of_writes], [num_of_bytes_written], [io_stall_write_ms], [io_stall]
INTO ##SQLskillsFileStats1
FROM sys.dm_io_virtual_file_stats(@DBID, NULL)


/* Capture wait stats */

IF EXISTS (SELECT * FROM [tempdb].[sys].[objects] WHERE [name] = N'##SQLskillsWaitStats1')
  DROP TABLE [##SQLskillsWaitStats1];
 
IF EXISTS (SELECT * FROM [tempdb].[sys].[objects] WHERE [name] = N'##SQLskillsWaitStats2')
  DROP TABLE [##SQLskillsWaitStats2];

SELECT [wait_type], [waiting_tasks_count], [wait_time_ms],
  [max_wait_time_ms], [signal_wait_time_ms]
INTO ##SQLskillsWaitStats1
FROM sys.dm_os_wait_stats;

/* set start time */
UPDATE [SparseTracking].[dbo].[TrackTests] SET [TestStartTime] = SYSDATETIME() WHERE [TestID] = @TestID;


-- insert all values for [NonSparseInsertOne] table
WHILE (@RowLoop < 10000001) 
BEGIN

	-- Calculate doc name length
	SET @NameLength = CONVERT (INT, RAND () * 100) + 1;
	SET @Type = CONVERT (INT, RAND () * 49) + 1;
	SET @ColumnStart = @Type * 20;
	
		-- Get the random document name
	SELECT @ColumnLoop = 0;
	WHILE (@ColumnLoop < @NameLength)
	BEGIN
		SELECT @NameString = @NameString + CHAR (97 +
			CONVERT (INT, RAND () * 26));
		SELECT @ColumnLoop = @ColumnLoop + 1;
	END;

	SELECT @ExecString2 = 
	'INSERT INTO [NonSparseInsertOne] ([Name], [Type]) VALUES (''' + @NameString + ''', ' + CAST(@Type AS VARCHAR(10)) +')'
	EXEC (@ExecString2)

	-- Add the columns we're inserting into
	SELECT @ColumnLoop = @ColumnStart;
	SELECT @ExecString = ' [c' +
		CAST (@ColumnLoop AS VARCHAR);
	SELECT @ColumnLoop = @ColumnLoop + 1;
	WHILE (@ColumnLoop < (@ColumnStart + 20))
	BEGIN
		SELECT @ExecString = @ExecString + '] = ' + CAST (CONVERT (INT, RAND () * 100000) AS VARCHAR) + ','
		SELECT @ExecString = @ExecString + '[c' + CAST(@ColumnLoop AS VARCHAR);
		SELECT @ColumnLoop = @ColumnLoop + 1;
	END;
	SELECT @ExecString = @ExecString + '] = ' + CAST (CONVERT (INT, RAND () * 100000) AS VARCHAR)

	SELECT @MaxID = MAX(ID) FROM [NonSparseInsertOne]

	SELECT @ExecString2 =
		'UPDATE [NonSparseInsertOne] SET ' + @ExecString + ' WHERE ID = ' + CAST(@MaxID AS VARCHAR(10))
	EXEC (@ExecString2);

	SELECT @RowLoop = @RowLoop + 1;
	SET @NameString = ''
END;

/* set the stop time */
UPDATE [SparseTracking].[dbo].[TrackTests] SET [TestEndTime] = SYSDATETIME() WHERE [TestID] = @TestID;

/* capture wait stats again */
SELECT [wait_type], [waiting_tasks_count], [wait_time_ms],
  [max_wait_time_ms], [signal_wait_time_ms]
INTO ##SQLskillsWaitStats2
FROM sys.dm_os_wait_stats;

/* capture file stats again */
SELECT [database_id], [file_id], [sample_ms], [num_of_reads], [num_of_bytes_read], [io_stall_read_ms],
[num_of_writes], [num_of_bytes_written], [io_stall_write_ms], [io_stall]
INTO ##SQLskillsFileStats2
FROM sys.dm_io_virtual_file_stats(@DBID, NULL)

/* capture index stats */
INSERT INTO [SparseTracking].[dbo].[IndexStats]
           ([TestID]
           ,[database_id]
           ,[object_id]
           ,[index_id]
           ,[partition_number]
           ,[index_type_desc]
           ,[alloc_unit_type_desc]
           ,[index_depth]
           ,[index_level]
           ,[avg_fragmentation_in_percent]
           ,[fragment_count]
           ,[avg_fragment_size_in_pages]
           ,[page_count]
           ,[avg_page_space_used_in_percent]
           ,[record_count]
           ,[ghost_record_count]
           ,[version_ghost_record_count]
           ,[min_record_size_in_bytes]
           ,[max_record_size_in_bytes]
           ,[avg_record_size_in_bytes]
           ,[forwarded_record_count]
           ,[compressed_page_count])
SELECT @TestID, [database_id],[object_id],[index_id],[partition_number],[index_type_desc],
[alloc_unit_type_desc],[index_depth],[index_level],[avg_fragmentation_in_percent],
[fragment_count],[avg_fragment_size_in_pages],[page_count],[avg_page_space_used_in_percent],
[record_count],[ghost_record_count],[version_ghost_record_count],[min_record_size_in_bytes],
[max_record_size_in_bytes],[avg_record_size_in_bytes],[forwarded_record_count],[compressed_page_count]
from sys.dm_db_index_physical_stats(@DBID, OBJECT_ID(N'NonSparseInsertOne'),NULL, NULL, 'Detailed');



/* store wait stats */
WITH [DiffWaits] AS
(
  SELECT   -- Waits that weren't in the first snapshot
      [ts2].[wait_type],
      [ts2].[wait_time_ms],
      [ts2].[signal_wait_time_ms],
      [ts2].[waiting_tasks_count]
    FROM [##SQLskillsWaitStats2] AS [ts2]
    LEFT OUTER JOIN [##SQLskillsWaitStats1] AS [ts1]
    ON [ts2].[wait_type] = [ts1].[wait_type]
    WHERE [ts1].[wait_type] IS NULL
    AND [ts2].[wait_time_ms] > 0
  UNION
  SELECT   -- Diff of waits in both snapshots
      [ts2].[wait_type],
      [ts2].[wait_time_ms] - [ts1].[wait_time_ms] AS [wait_time_ms],
      [ts2].[signal_wait_time_ms] - [ts1].[signal_wait_time_ms] AS [signal_wait_time_ms],
      [ts2].[waiting_tasks_count] - [ts1].[waiting_tasks_count] AS [waiting_tasks_count]
    FROM [##SQLskillsWaitStats2] AS [ts2]
    LEFT OUTER JOIN [##SQLskillsWaitStats1] AS [ts1]
    ON [ts2].[wait_type] = [ts1].[wait_type]
    WHERE [ts1].[wait_type] IS NOT NULL
    AND [ts2].[waiting_tasks_count] - [ts1].[waiting_tasks_count] > 0
    AND [ts2].[wait_time_ms] - [ts1].[wait_time_ms] > 0
),
[Waits] AS
(
  SELECT
    [wait_type],
    [wait_time_ms] / 1000.0 AS [WaitS],
    ([wait_time_ms] - [signal_wait_time_ms]) / 1000.0 AS [ResourceS],
    [signal_wait_time_ms] / 1000.0 AS [SignalS],
    [waiting_tasks_count] AS [WaitCount],
    100.0 * [wait_time_ms] / SUM ([wait_time_ms]) OVER() AS [Percentage],
    ROW_NUMBER() OVER(ORDER BY [wait_time_ms] DESC) AS [RowNum]
  FROM [DiffWaits]
  WHERE [wait_type] NOT IN (SELECT WaitType FROM SparseTracking.dbo.WaitsToIgnore)
)


INSERT INTO [SparseTracking].[dbo].[WaitStats]
(
	[TestID],
  [WaitType] ,
  [Wait_S] ,
  [Resource_S] ,
  [Signal_S] ,
  [WaitCount] ,
  [Percentage] ,
  [AvgWait_S] ,
  [AvgRes_S] ,
  [AvgSig_S]
)
SELECT
	@TestID,
  [W1].[wait_type],
  CAST ([W1].[WaitS] AS DECIMAL (16, 2)) ,
  CAST ([W1].[ResourceS] AS DECIMAL (16, 2)) ,
  CAST ([W1].[SignalS] AS DECIMAL (16, 2)) ,
  [W1].[WaitCount] ,
  CAST ([W1].[Percentage] AS DECIMAL (5, 2)) ,
  CAST (([W1].[WaitS] / [W1].[WaitCount]) AS DECIMAL (16, 4)) ,
  CAST (([W1].[ResourceS] / [W1].[WaitCount]) AS DECIMAL (16, 4)) ,
  CAST (([W1].[SignalS] / [W1].[WaitCount]) AS DECIMAL (16, 4))
FROM [Waits] AS [W1]
INNER JOIN [Waits] AS [W2]
ON [W2].[RowNum] <= [W1].[RowNum]
GROUP BY [W1].[RowNum], [W1].[wait_type], [W1].[WaitS], [W1].[ResourceS], 
  [W1].[SignalS], [W1].[WaitCount], [W1].[Percentage]
HAVING SUM ([W2].[Percentage]) - [W1].[Percentage] < 95; -- percentage threshold


/* store file stats */

INSERT INTO [SparseTracking].[dbo].[FileStats]
           ([TestID]
           ,[database_id]
           ,[file_id]
           ,[sample_ms]
           ,[num_of_reads]
           ,[num_of_bytes_read]
           ,[io_stall_read_ms]
           ,[num_of_writes]
           ,[num_of_bytes_written]
           ,[io_stall_write_ms]
           ,[io_stall])
SELECT
@TestID,
f.database_id, f.file_id, 
(f.sample_ms - i.sample_ms) AS sample_ms, 
(f.num_of_reads - i.num_of_reads) AS num_of_reads,
(f.num_of_bytes_read - i.num_of_bytes_read ) AS num_of_bytes_read,
(f.io_stall_read_ms - i.io_stall_read_ms ) AS io_stall_read_ms,
(f.num_of_writes - i.num_of_writes ) AS num_of_writes,
(f.num_of_bytes_written - i.num_of_bytes_written ) AS num_of_bytes_written,
(f.io_stall_write_ms - i.io_stall_write_ms ) AS io_stall_write_ms,
(f.io_stall - i.io_stall ) AS io_stall
FROM ##SQLskillsFileStats1 i
JOIN ##SQLskillsFileStats2 f on i.database_id = f.database_id and i.file_id = f.file_id


USE [master];
GO

DROP DATABASE [SparseTest];
GO



/*
	START TEST SparseInsertOne
*/
CREATE DATABASE [SparseTest]
 CONTAINMENT = NONE
 ON  PRIMARY 
( NAME = N'SparseTest', FILENAME = N'M:\Data\Sparse\SparseTest.mdf' , SIZE = 102400MB , FILEGROWTH = 524288KB )
 LOG ON 
( NAME = N'SparseTest_log', FILENAME = N'M:\Data\Sparse\SparseTest_log.ldf' , SIZE = 1048576KB , FILEGROWTH = 524288KB )
GO
ALTER DATABASE [SparseTest] SET RECOVERY SIMPLE 
GO

USE [SparseTest];
GO

CREATE TABLE [SparseInsertOne] (
	[ID] INT IDENTITY, [Name] VARCHAR (100), [Type] INT,
	[c4] VARCHAR(255) SPARSE NULL, [c5] VARCHAR(255) SPARSE NULL, [c6] VARCHAR(255) SPARSE NULL, [c7] VARCHAR(255) SPARSE NULL, [c8] VARCHAR(255) SPARSE NULL, [c9] VARCHAR(255) SPARSE NULL,	[c10] VARCHAR(255) SPARSE NULL, [c11] VARCHAR(255) SPARSE NULL, [c12] VARCHAR(255) SPARSE NULL, [c13] VARCHAR(255) SPARSE NULL, [c14] VARCHAR(255) SPARSE NULL, [c15] VARCHAR(255) SPARSE NULL, [c16] VARCHAR(255) SPARSE NULL, [c17] VARCHAR(255) SPARSE NULL, [c18] VARCHAR(255) SPARSE NULL, [c19] VARCHAR(255) SPARSE NULL,	[c20] VARCHAR(255) SPARSE NULL, [c21] VARCHAR(255) SPARSE NULL, [c22] VARCHAR(255) SPARSE NULL, [c23] VARCHAR(255) SPARSE NULL, [c24] VARCHAR(255) SPARSE NULL, [c25] VARCHAR(255) SPARSE NULL, [c26] VARCHAR(255) SPARSE NULL, [c27] VARCHAR(255) SPARSE NULL, [c28] VARCHAR(255) SPARSE NULL, [c29] VARCHAR(255) SPARSE NULL,	[c30] VARCHAR(255) SPARSE NULL, [c31] VARCHAR(255) SPARSE NULL, [c32] VARCHAR(255) SPARSE NULL, [c33] VARCHAR(255) SPARSE NULL, [c34] VARCHAR(255) SPARSE NULL, [c35] VARCHAR(255) SPARSE NULL, [c36] VARCHAR(255) SPARSE NULL, [c37] VARCHAR(255) SPARSE NULL, [c38] VARCHAR(255) SPARSE NULL, [c39] VARCHAR(255) SPARSE NULL,	[c40] VARCHAR(255) SPARSE NULL, [c41] VARCHAR(255) SPARSE NULL, [c42] VARCHAR(255) SPARSE NULL, [c43] VARCHAR(255) SPARSE NULL, [c44] VARCHAR(255) SPARSE NULL, [c45] VARCHAR(255) SPARSE NULL, [c46] VARCHAR(255) SPARSE NULL, [c47] VARCHAR(255) SPARSE NULL, [c48] VARCHAR(255) SPARSE NULL, [c49] VARCHAR(255) SPARSE NULL,	[c50] VARCHAR(255) SPARSE NULL, [c51] VARCHAR(255) SPARSE NULL, [c52] VARCHAR(255) SPARSE NULL, [c53] VARCHAR(255) SPARSE NULL, [c54] VARCHAR(255) SPARSE NULL, [c55] VARCHAR(255) SPARSE NULL, [c56] VARCHAR(255) SPARSE NULL, [c57] VARCHAR(255) SPARSE NULL, [c58] VARCHAR(255) SPARSE NULL, [c59] VARCHAR(255) SPARSE NULL,	[c60] VARCHAR(255) SPARSE NULL, [c61] VARCHAR(255) SPARSE NULL, [c62] VARCHAR(255) SPARSE NULL, [c63] VARCHAR(255) SPARSE NULL, [c64] VARCHAR(255) SPARSE NULL, [c65] VARCHAR(255) SPARSE NULL, [c66] VARCHAR(255) SPARSE NULL, [c67] VARCHAR(255) SPARSE NULL, [c68] VARCHAR(255) SPARSE NULL, [c69] VARCHAR(255) SPARSE NULL,	[c70] VARCHAR(255) SPARSE NULL, [c71] VARCHAR(255) SPARSE NULL, [c72] VARCHAR(255) SPARSE NULL, [c73] VARCHAR(255) SPARSE NULL, [c74] VARCHAR(255) SPARSE NULL, [c75] VARCHAR(255) SPARSE NULL, [c76] VARCHAR(255) SPARSE NULL, [c77] VARCHAR(255) SPARSE NULL, [c78] VARCHAR(255) SPARSE NULL, [c79] VARCHAR(255) SPARSE NULL,	[c80] VARCHAR(255) SPARSE NULL, [c81] VARCHAR(255) SPARSE NULL, [c82] VARCHAR(255) SPARSE NULL, [c83] VARCHAR(255) SPARSE NULL, [c84] VARCHAR(255) SPARSE NULL, [c85] VARCHAR(255) SPARSE NULL, [c86] VARCHAR(255) SPARSE NULL, [c87] VARCHAR(255) SPARSE NULL, [c88] VARCHAR(255) SPARSE NULL, [c89] VARCHAR(255) SPARSE NULL,	[c90] VARCHAR(255) SPARSE NULL, [c91] VARCHAR(255) SPARSE NULL, [c92] VARCHAR(255) SPARSE NULL, [c93] VARCHAR(255) SPARSE NULL, [c94] VARCHAR(255) SPARSE NULL, [c95] VARCHAR(255) SPARSE NULL, [c96] VARCHAR(255) SPARSE NULL, [c97] VARCHAR(255) SPARSE NULL, [c98] VARCHAR(255) SPARSE NULL, [c99] VARCHAR(255) SPARSE NULL,
	[c100] VARCHAR(255) SPARSE NULL, [c101] VARCHAR(255) SPARSE NULL, [c102] VARCHAR(255) SPARSE NULL, [c103] VARCHAR(255) SPARSE NULL, [c104] VARCHAR(255) SPARSE NULL, [c105] VARCHAR(255) SPARSE NULL, [c106] VARCHAR(255) SPARSE NULL, [c107] VARCHAR(255) SPARSE NULL, [c108] VARCHAR(255) SPARSE NULL, [c109] VARCHAR(255) SPARSE NULL,	[c110] VARCHAR(255) SPARSE NULL, [c111] VARCHAR(255) SPARSE NULL, [c112] VARCHAR(255) SPARSE NULL, [c113] VARCHAR(255) SPARSE NULL, [c114] VARCHAR(255) SPARSE NULL, [c115] VARCHAR(255) SPARSE NULL, [c116] VARCHAR(255) SPARSE NULL, [c117] VARCHAR(255) SPARSE NULL, [c118] VARCHAR(255) SPARSE NULL, [c119] VARCHAR(255) SPARSE NULL,	[c120] VARCHAR(255) SPARSE NULL, [c121] VARCHAR(255) SPARSE NULL, [c122] VARCHAR(255) SPARSE NULL, [c123] VARCHAR(255) SPARSE NULL, [c124] VARCHAR(255) SPARSE NULL, [c125] VARCHAR(255) SPARSE NULL, [c126] VARCHAR(255) SPARSE NULL, [c127] VARCHAR(255) SPARSE NULL, [c128] VARCHAR(255) SPARSE NULL, [c129] VARCHAR(255) SPARSE NULL,	[c130] VARCHAR(255) SPARSE NULL, [c131] VARCHAR(255) SPARSE NULL, [c132] VARCHAR(255) SPARSE NULL, [c133] VARCHAR(255) SPARSE NULL, [c134] VARCHAR(255) SPARSE NULL, [c135] VARCHAR(255) SPARSE NULL, [c136] VARCHAR(255) SPARSE NULL, [c137] VARCHAR(255) SPARSE NULL, [c138] VARCHAR(255) SPARSE NULL, [c139] VARCHAR(255) SPARSE NULL,	[c140] VARCHAR(255) SPARSE NULL, [c141] VARCHAR(255) SPARSE NULL, [c142] VARCHAR(255) SPARSE NULL, [c143] VARCHAR(255) SPARSE NULL, [c144] VARCHAR(255) SPARSE NULL, [c145] VARCHAR(255) SPARSE NULL, [c146] VARCHAR(255) SPARSE NULL, [c147] VARCHAR(255) SPARSE NULL, [c148] VARCHAR(255) SPARSE NULL, [c149] VARCHAR(255) SPARSE NULL,	[c150] VARCHAR(255) SPARSE NULL, [c151] VARCHAR(255) SPARSE NULL, [c152] VARCHAR(255) SPARSE NULL, [c153] VARCHAR(255) SPARSE NULL, [c154] VARCHAR(255) SPARSE NULL, [c155] VARCHAR(255) SPARSE NULL, [c156] VARCHAR(255) SPARSE NULL, [c157] VARCHAR(255) SPARSE NULL, [c158] VARCHAR(255) SPARSE NULL, [c159] VARCHAR(255) SPARSE NULL,	[c160] VARCHAR(255) SPARSE NULL, [c161] VARCHAR(255) SPARSE NULL, [c162] VARCHAR(255) SPARSE NULL, [c163] VARCHAR(255) SPARSE NULL, [c164] VARCHAR(255) SPARSE NULL, [c165] VARCHAR(255) SPARSE NULL, [c166] VARCHAR(255) SPARSE NULL, [c167] VARCHAR(255) SPARSE NULL, [c168] VARCHAR(255) SPARSE NULL, [c169] VARCHAR(255) SPARSE NULL,	[c170] VARCHAR(255) SPARSE NULL, [c171] VARCHAR(255) SPARSE NULL, [c172] VARCHAR(255) SPARSE NULL, [c173] VARCHAR(255) SPARSE NULL, [c174] VARCHAR(255) SPARSE NULL, [c175] VARCHAR(255) SPARSE NULL, [c176] VARCHAR(255) SPARSE NULL, [c177] VARCHAR(255) SPARSE NULL, [c178] VARCHAR(255) SPARSE NULL, [c179] VARCHAR(255) SPARSE NULL,	[c180] VARCHAR(255) SPARSE NULL, [c181] VARCHAR(255) SPARSE NULL, [c182] VARCHAR(255) SPARSE NULL, [c183] VARCHAR(255) SPARSE NULL, [c184] VARCHAR(255) SPARSE NULL, [c185] VARCHAR(255) SPARSE NULL, [c186] VARCHAR(255) SPARSE NULL, [c187] VARCHAR(255) SPARSE NULL, [c188] VARCHAR(255) SPARSE NULL, [c189] VARCHAR(255) SPARSE NULL,	[c190] VARCHAR(255) SPARSE NULL, [c191] VARCHAR(255) SPARSE NULL, [c192] VARCHAR(255) SPARSE NULL, [c193] VARCHAR(255) SPARSE NULL, [c194] VARCHAR(255) SPARSE NULL, [c195] VARCHAR(255) SPARSE NULL, [c196] VARCHAR(255) SPARSE NULL, [c197] VARCHAR(255) SPARSE NULL, [c198] VARCHAR(255) SPARSE NULL, [c199] VARCHAR(255) SPARSE NULL,
	[c200] VARCHAR(255) SPARSE NULL, [c201] VARCHAR(255) SPARSE NULL, [c202] VARCHAR(255) SPARSE NULL, [c203] VARCHAR(255) SPARSE NULL, [c204] VARCHAR(255) SPARSE NULL, [c205] VARCHAR(255) SPARSE NULL, [c206] VARCHAR(255) SPARSE NULL, [c207] VARCHAR(255) SPARSE NULL, [c208] VARCHAR(255) SPARSE NULL, [c209] VARCHAR(255) SPARSE NULL,	[c210] VARCHAR(255) SPARSE NULL, [c211] VARCHAR(255) SPARSE NULL, [c212] VARCHAR(255) SPARSE NULL, [c213] VARCHAR(255) SPARSE NULL, [c214] VARCHAR(255) SPARSE NULL, [c215] VARCHAR(255) SPARSE NULL, [c216] VARCHAR(255) SPARSE NULL, [c217] VARCHAR(255) SPARSE NULL, [c218] VARCHAR(255) SPARSE NULL, [c219] VARCHAR(255) SPARSE NULL,	[c220] VARCHAR(255) SPARSE NULL, [c221] VARCHAR(255) SPARSE NULL, [c222] VARCHAR(255) SPARSE NULL, [c223] VARCHAR(255) SPARSE NULL, [c224] VARCHAR(255) SPARSE NULL, [c225] VARCHAR(255) SPARSE NULL, [c226] VARCHAR(255) SPARSE NULL, [c227] VARCHAR(255) SPARSE NULL, [c228] VARCHAR(255) SPARSE NULL, [c229] VARCHAR(255) SPARSE NULL,	[c230] VARCHAR(255) SPARSE NULL, [c231] VARCHAR(255) SPARSE NULL, [c232] VARCHAR(255) SPARSE NULL, [c233] VARCHAR(255) SPARSE NULL, [c234] VARCHAR(255) SPARSE NULL, [c235] VARCHAR(255) SPARSE NULL, [c236] VARCHAR(255) SPARSE NULL, [c237] VARCHAR(255) SPARSE NULL, [c238] VARCHAR(255) SPARSE NULL, [c239] VARCHAR(255) SPARSE NULL,	[c240] VARCHAR(255) SPARSE NULL, [c241] VARCHAR(255) SPARSE NULL, [c242] VARCHAR(255) SPARSE NULL, [c243] VARCHAR(255) SPARSE NULL, [c244] VARCHAR(255) SPARSE NULL, [c245] VARCHAR(255) SPARSE NULL, [c246] VARCHAR(255) SPARSE NULL, [c247] VARCHAR(255) SPARSE NULL, [c248] VARCHAR(255) SPARSE NULL, [c249] VARCHAR(255) SPARSE NULL,	[c250] VARCHAR(255) SPARSE NULL, [c251] VARCHAR(255) SPARSE NULL, [c252] VARCHAR(255) SPARSE NULL, [c253] VARCHAR(255) SPARSE NULL, [c254] VARCHAR(255) SPARSE NULL, [c255] VARCHAR(255) SPARSE NULL, [c256] VARCHAR(255) SPARSE NULL, [c257] VARCHAR(255) SPARSE NULL, [c258] VARCHAR(255) SPARSE NULL, [c259] VARCHAR(255) SPARSE NULL,	[c260] VARCHAR(255) SPARSE NULL, [c261] VARCHAR(255) SPARSE NULL, [c262] VARCHAR(255) SPARSE NULL, [c263] VARCHAR(255) SPARSE NULL, [c264] VARCHAR(255) SPARSE NULL, [c265] VARCHAR(255) SPARSE NULL, [c266] VARCHAR(255) SPARSE NULL, [c267] VARCHAR(255) SPARSE NULL, [c268] VARCHAR(255) SPARSE NULL, [c269] VARCHAR(255) SPARSE NULL,	[c270] VARCHAR(255) SPARSE NULL, [c271] VARCHAR(255) SPARSE NULL, [c272] VARCHAR(255) SPARSE NULL, [c273] VARCHAR(255) SPARSE NULL, [c274] VARCHAR(255) SPARSE NULL, [c275] VARCHAR(255) SPARSE NULL, [c276] VARCHAR(255) SPARSE NULL, [c277] VARCHAR(255) SPARSE NULL, [c278] VARCHAR(255) SPARSE NULL, [c279] VARCHAR(255) SPARSE NULL,	[c280] VARCHAR(255) SPARSE NULL, [c281] VARCHAR(255) SPARSE NULL, [c282] VARCHAR(255) SPARSE NULL, [c283] VARCHAR(255) SPARSE NULL, [c284] VARCHAR(255) SPARSE NULL, [c285] VARCHAR(255) SPARSE NULL, [c286] VARCHAR(255) SPARSE NULL, [c287] VARCHAR(255) SPARSE NULL, [c288] VARCHAR(255) SPARSE NULL, [c289] VARCHAR(255) SPARSE NULL,	[c290] VARCHAR(255) SPARSE NULL, [c291] VARCHAR(255) SPARSE NULL, [c292] VARCHAR(255) SPARSE NULL, [c293] VARCHAR(255) SPARSE NULL, [c294] VARCHAR(255) SPARSE NULL, [c295] VARCHAR(255) SPARSE NULL, [c296] VARCHAR(255) SPARSE NULL, [c297] VARCHAR(255) SPARSE NULL, [c298] VARCHAR(255) SPARSE NULL, [c299] VARCHAR(255) SPARSE NULL,
	[c300] VARCHAR(255) SPARSE NULL, [c301] VARCHAR(255) SPARSE NULL, [c302] VARCHAR(255) SPARSE NULL, [c303] VARCHAR(255) SPARSE NULL, [c304] VARCHAR(255) SPARSE NULL, [c305] VARCHAR(255) SPARSE NULL, [c306] VARCHAR(255) SPARSE NULL, [c307] VARCHAR(255) SPARSE NULL, [c308] VARCHAR(255) SPARSE NULL, [c309] VARCHAR(255) SPARSE NULL,	[c310] VARCHAR(255) SPARSE NULL, [c311] VARCHAR(255) SPARSE NULL, [c312] VARCHAR(255) SPARSE NULL, [c313] VARCHAR(255) SPARSE NULL, [c314] VARCHAR(255) SPARSE NULL, [c315] VARCHAR(255) SPARSE NULL, [c316] VARCHAR(255) SPARSE NULL, [c317] VARCHAR(255) SPARSE NULL, [c318] VARCHAR(255) SPARSE NULL, [c319] VARCHAR(255) SPARSE NULL,	[c320] VARCHAR(255) SPARSE NULL, [c321] VARCHAR(255) SPARSE NULL, [c322] VARCHAR(255) SPARSE NULL, [c323] VARCHAR(255) SPARSE NULL, [c324] VARCHAR(255) SPARSE NULL, [c325] VARCHAR(255) SPARSE NULL, [c326] VARCHAR(255) SPARSE NULL, [c327] VARCHAR(255) SPARSE NULL, [c328] VARCHAR(255) SPARSE NULL, [c329] VARCHAR(255) SPARSE NULL,	[c330] VARCHAR(255) SPARSE NULL, [c331] VARCHAR(255) SPARSE NULL, [c332] VARCHAR(255) SPARSE NULL, [c333] VARCHAR(255) SPARSE NULL, [c334] VARCHAR(255) SPARSE NULL, [c335] VARCHAR(255) SPARSE NULL, [c336] VARCHAR(255) SPARSE NULL, [c337] VARCHAR(255) SPARSE NULL, [c338] VARCHAR(255) SPARSE NULL, [c339] VARCHAR(255) SPARSE NULL,	[c340] VARCHAR(255) SPARSE NULL, [c341] VARCHAR(255) SPARSE NULL, [c342] VARCHAR(255) SPARSE NULL, [c343] VARCHAR(255) SPARSE NULL, [c344] VARCHAR(255) SPARSE NULL, [c345] VARCHAR(255) SPARSE NULL, [c346] VARCHAR(255) SPARSE NULL, [c347] VARCHAR(255) SPARSE NULL, [c348] VARCHAR(255) SPARSE NULL, [c349] VARCHAR(255) SPARSE NULL,	[c350] VARCHAR(255) SPARSE NULL, [c351] VARCHAR(255) SPARSE NULL, [c352] VARCHAR(255) SPARSE NULL, [c353] VARCHAR(255) SPARSE NULL, [c354] VARCHAR(255) SPARSE NULL, [c355] VARCHAR(255) SPARSE NULL, [c356] VARCHAR(255) SPARSE NULL, [c357] VARCHAR(255) SPARSE NULL, [c358] VARCHAR(255) SPARSE NULL, [c359] VARCHAR(255) SPARSE NULL,	[c360] VARCHAR(255) SPARSE NULL, [c361] VARCHAR(255) SPARSE NULL, [c362] VARCHAR(255) SPARSE NULL, [c363] VARCHAR(255) SPARSE NULL, [c364] VARCHAR(255) SPARSE NULL, [c365] VARCHAR(255) SPARSE NULL, [c366] VARCHAR(255) SPARSE NULL, [c367] VARCHAR(255) SPARSE NULL, [c368] VARCHAR(255) SPARSE NULL, [c369] VARCHAR(255) SPARSE NULL,	[c370] VARCHAR(255) SPARSE NULL, [c371] VARCHAR(255) SPARSE NULL, [c372] VARCHAR(255) SPARSE NULL, [c373] VARCHAR(255) SPARSE NULL, [c374] VARCHAR(255) SPARSE NULL, [c375] VARCHAR(255) SPARSE NULL, [c376] VARCHAR(255) SPARSE NULL, [c377] VARCHAR(255) SPARSE NULL, [c378] VARCHAR(255) SPARSE NULL, [c379] VARCHAR(255) SPARSE NULL,	[c380] VARCHAR(255) SPARSE NULL, [c381] VARCHAR(255) SPARSE NULL, [c382] VARCHAR(255) SPARSE NULL, [c383] VARCHAR(255) SPARSE NULL, [c384] VARCHAR(255) SPARSE NULL, [c385] VARCHAR(255) SPARSE NULL, [c386] VARCHAR(255) SPARSE NULL, [c387] VARCHAR(255) SPARSE NULL, [c388] VARCHAR(255) SPARSE NULL, [c389] VARCHAR(255) SPARSE NULL,	[c390] VARCHAR(255) SPARSE NULL, [c391] VARCHAR(255) SPARSE NULL, [c392] VARCHAR(255) SPARSE NULL, [c393] VARCHAR(255) SPARSE NULL, [c394] VARCHAR(255) SPARSE NULL, [c395] VARCHAR(255) SPARSE NULL, [c396] VARCHAR(255) SPARSE NULL, [c397] VARCHAR(255) SPARSE NULL, [c398] VARCHAR(255) SPARSE NULL, [c399] VARCHAR(255) SPARSE NULL,
	[c400] VARCHAR(255) SPARSE NULL, [c401] VARCHAR(255) SPARSE NULL, [c402] VARCHAR(255) SPARSE NULL, [c403] VARCHAR(255) SPARSE NULL, [c404] VARCHAR(255) SPARSE NULL, [c405] VARCHAR(255) SPARSE NULL, [c406] VARCHAR(255) SPARSE NULL, [c407] VARCHAR(255) SPARSE NULL, [c408] VARCHAR(255) SPARSE NULL, [c409] VARCHAR(255) SPARSE NULL,	[c410] VARCHAR(255) SPARSE NULL, [c411] VARCHAR(255) SPARSE NULL, [c412] VARCHAR(255) SPARSE NULL, [c413] VARCHAR(255) SPARSE NULL, [c414] VARCHAR(255) SPARSE NULL, [c415] VARCHAR(255) SPARSE NULL, [c416] VARCHAR(255) SPARSE NULL, [c417] VARCHAR(255) SPARSE NULL, [c418] VARCHAR(255) SPARSE NULL, [c419] VARCHAR(255) SPARSE NULL,	[c420] VARCHAR(255) SPARSE NULL, [c421] VARCHAR(255) SPARSE NULL, [c422] VARCHAR(255) SPARSE NULL, [c423] VARCHAR(255) SPARSE NULL, [c424] VARCHAR(255) SPARSE NULL, [c425] VARCHAR(255) SPARSE NULL, [c426] VARCHAR(255) SPARSE NULL, [c427] VARCHAR(255) SPARSE NULL, [c428] VARCHAR(255) SPARSE NULL, [c429] VARCHAR(255) SPARSE NULL,	[c430] VARCHAR(255) SPARSE NULL, [c431] VARCHAR(255) SPARSE NULL, [c432] VARCHAR(255) SPARSE NULL, [c433] VARCHAR(255) SPARSE NULL, [c434] VARCHAR(255) SPARSE NULL, [c435] VARCHAR(255) SPARSE NULL, [c436] VARCHAR(255) SPARSE NULL, [c437] VARCHAR(255) SPARSE NULL, [c438] VARCHAR(255) SPARSE NULL, [c439] VARCHAR(255) SPARSE NULL,	[c440] VARCHAR(255) SPARSE NULL, [c441] VARCHAR(255) SPARSE NULL, [c442] VARCHAR(255) SPARSE NULL, [c443] VARCHAR(255) SPARSE NULL, [c444] VARCHAR(255) SPARSE NULL, [c445] VARCHAR(255) SPARSE NULL, [c446] VARCHAR(255) SPARSE NULL, [c447] VARCHAR(255) SPARSE NULL, [c448] VARCHAR(255) SPARSE NULL, [c449] VARCHAR(255) SPARSE NULL,	[c450] VARCHAR(255) SPARSE NULL, [c451] VARCHAR(255) SPARSE NULL, [c452] VARCHAR(255) SPARSE NULL, [c453] VARCHAR(255) SPARSE NULL, [c454] VARCHAR(255) SPARSE NULL, [c455] VARCHAR(255) SPARSE NULL, [c456] VARCHAR(255) SPARSE NULL, [c457] VARCHAR(255) SPARSE NULL, [c458] VARCHAR(255) SPARSE NULL, [c459] VARCHAR(255) SPARSE NULL,	[c460] VARCHAR(255) SPARSE NULL, [c461] VARCHAR(255) SPARSE NULL, [c462] VARCHAR(255) SPARSE NULL, [c463] VARCHAR(255) SPARSE NULL, [c464] VARCHAR(255) SPARSE NULL, [c465] VARCHAR(255) SPARSE NULL, [c466] VARCHAR(255) SPARSE NULL, [c467] VARCHAR(255) SPARSE NULL, [c468] VARCHAR(255) SPARSE NULL, [c469] VARCHAR(255) SPARSE NULL,	[c470] VARCHAR(255) SPARSE NULL, [c471] VARCHAR(255) SPARSE NULL, [c472] VARCHAR(255) SPARSE NULL, [c473] VARCHAR(255) SPARSE NULL, [c474] VARCHAR(255) SPARSE NULL, [c475] VARCHAR(255) SPARSE NULL, [c476] VARCHAR(255) SPARSE NULL, [c477] VARCHAR(255) SPARSE NULL, [c478] VARCHAR(255) SPARSE NULL, [c479] VARCHAR(255) SPARSE NULL,	[c480] VARCHAR(255) SPARSE NULL, [c481] VARCHAR(255) SPARSE NULL, [c482] VARCHAR(255) SPARSE NULL, [c483] VARCHAR(255) SPARSE NULL, [c484] VARCHAR(255) SPARSE NULL, [c485] VARCHAR(255) SPARSE NULL, [c486] VARCHAR(255) SPARSE NULL, [c487] VARCHAR(255) SPARSE NULL, [c488] VARCHAR(255) SPARSE NULL, [c489] VARCHAR(255) SPARSE NULL,	[c490] VARCHAR(255) SPARSE NULL, [c491] VARCHAR(255) SPARSE NULL, [c492] VARCHAR(255) SPARSE NULL, [c493] VARCHAR(255) SPARSE NULL, [c494] VARCHAR(255) SPARSE NULL, [c495] VARCHAR(255) SPARSE NULL, [c496] VARCHAR(255) SPARSE NULL, [c497] VARCHAR(255) SPARSE NULL, [c498] VARCHAR(255) SPARSE NULL, [c499] VARCHAR(255) SPARSE NULL,
	[c500] VARCHAR(255) SPARSE NULL, [c501] VARCHAR(255) SPARSE NULL, [c502] VARCHAR(255) SPARSE NULL, [c503] VARCHAR(255) SPARSE NULL, [c504] VARCHAR(255) SPARSE NULL, [c505] VARCHAR(255) SPARSE NULL, [c506] VARCHAR(255) SPARSE NULL, [c507] VARCHAR(255) SPARSE NULL, [c508] VARCHAR(255) SPARSE NULL, [c509] VARCHAR(255) SPARSE NULL,	[c510] VARCHAR(255) SPARSE NULL, [c511] VARCHAR(255) SPARSE NULL, [c512] VARCHAR(255) SPARSE NULL, [c513] VARCHAR(255) SPARSE NULL, [c514] VARCHAR(255) SPARSE NULL, [c515] VARCHAR(255) SPARSE NULL, [c516] VARCHAR(255) SPARSE NULL, [c517] VARCHAR(255) SPARSE NULL, [c518] VARCHAR(255) SPARSE NULL, [c519] VARCHAR(255) SPARSE NULL,	[c520] VARCHAR(255) SPARSE NULL, [c521] VARCHAR(255) SPARSE NULL, [c522] VARCHAR(255) SPARSE NULL, [c523] VARCHAR(255) SPARSE NULL, [c524] VARCHAR(255) SPARSE NULL, [c525] VARCHAR(255) SPARSE NULL, [c526] VARCHAR(255) SPARSE NULL, [c527] VARCHAR(255) SPARSE NULL, [c528] VARCHAR(255) SPARSE NULL, [c529] VARCHAR(255) SPARSE NULL,	[c530] VARCHAR(255) SPARSE NULL, [c531] VARCHAR(255) SPARSE NULL, [c532] VARCHAR(255) SPARSE NULL, [c533] VARCHAR(255) SPARSE NULL, [c534] VARCHAR(255) SPARSE NULL, [c535] VARCHAR(255) SPARSE NULL, [c536] VARCHAR(255) SPARSE NULL, [c537] VARCHAR(255) SPARSE NULL, [c538] VARCHAR(255) SPARSE NULL, [c539] VARCHAR(255) SPARSE NULL,	[c540] VARCHAR(255) SPARSE NULL, [c541] VARCHAR(255) SPARSE NULL, [c542] VARCHAR(255) SPARSE NULL, [c543] VARCHAR(255) SPARSE NULL, [c544] VARCHAR(255) SPARSE NULL, [c545] VARCHAR(255) SPARSE NULL, [c546] VARCHAR(255) SPARSE NULL, [c547] VARCHAR(255) SPARSE NULL, [c548] VARCHAR(255) SPARSE NULL, [c549] VARCHAR(255) SPARSE NULL,	[c550] VARCHAR(255) SPARSE NULL, [c551] VARCHAR(255) SPARSE NULL, [c552] VARCHAR(255) SPARSE NULL, [c553] VARCHAR(255) SPARSE NULL, [c554] VARCHAR(255) SPARSE NULL, [c555] VARCHAR(255) SPARSE NULL, [c556] VARCHAR(255) SPARSE NULL, [c557] VARCHAR(255) SPARSE NULL, [c558] VARCHAR(255) SPARSE NULL, [c559] VARCHAR(255) SPARSE NULL,	[c560] VARCHAR(255) SPARSE NULL, [c561] VARCHAR(255) SPARSE NULL, [c562] VARCHAR(255) SPARSE NULL, [c563] VARCHAR(255) SPARSE NULL, [c564] VARCHAR(255) SPARSE NULL, [c565] VARCHAR(255) SPARSE NULL, [c566] VARCHAR(255) SPARSE NULL, [c567] VARCHAR(255) SPARSE NULL, [c568] VARCHAR(255) SPARSE NULL, [c569] VARCHAR(255) SPARSE NULL,	[c570] VARCHAR(255) SPARSE NULL, [c571] VARCHAR(255) SPARSE NULL, [c572] VARCHAR(255) SPARSE NULL, [c573] VARCHAR(255) SPARSE NULL, [c574] VARCHAR(255) SPARSE NULL, [c575] VARCHAR(255) SPARSE NULL, [c576] VARCHAR(255) SPARSE NULL, [c577] VARCHAR(255) SPARSE NULL, [c578] VARCHAR(255) SPARSE NULL, [c579] VARCHAR(255) SPARSE NULL,	[c580] VARCHAR(255) SPARSE NULL, [c581] VARCHAR(255) SPARSE NULL, [c582] VARCHAR(255) SPARSE NULL, [c583] VARCHAR(255) SPARSE NULL, [c584] VARCHAR(255) SPARSE NULL, [c585] VARCHAR(255) SPARSE NULL, [c586] VARCHAR(255) SPARSE NULL, [c587] VARCHAR(255) SPARSE NULL, [c588] VARCHAR(255) SPARSE NULL, [c589] VARCHAR(255) SPARSE NULL,	[c590] VARCHAR(255) SPARSE NULL, [c591] VARCHAR(255) SPARSE NULL, [c592] VARCHAR(255) SPARSE NULL, [c593] VARCHAR(255) SPARSE NULL, [c594] VARCHAR(255) SPARSE NULL, [c595] VARCHAR(255) SPARSE NULL, [c596] VARCHAR(255) SPARSE NULL, [c597] VARCHAR(255) SPARSE NULL, [c598] VARCHAR(255) SPARSE NULL, [c599] VARCHAR(255) SPARSE NULL,
	[c600] VARCHAR(255) SPARSE NULL, [c601] VARCHAR(255) SPARSE NULL, [c602] VARCHAR(255) SPARSE NULL, [c603] VARCHAR(255) SPARSE NULL, [c604] VARCHAR(255) SPARSE NULL, [c605] VARCHAR(255) SPARSE NULL, [c606] VARCHAR(255) SPARSE NULL, [c607] VARCHAR(255) SPARSE NULL, [c608] VARCHAR(255) SPARSE NULL, [c609] VARCHAR(255) SPARSE NULL,	[c610] VARCHAR(255) SPARSE NULL, [c611] VARCHAR(255) SPARSE NULL, [c612] VARCHAR(255) SPARSE NULL, [c613] VARCHAR(255) SPARSE NULL, [c614] VARCHAR(255) SPARSE NULL, [c615] VARCHAR(255) SPARSE NULL, [c616] VARCHAR(255) SPARSE NULL, [c617] VARCHAR(255) SPARSE NULL, [c618] VARCHAR(255) SPARSE NULL, [c619] VARCHAR(255) SPARSE NULL,	[c620] VARCHAR(255) SPARSE NULL, [c621] VARCHAR(255) SPARSE NULL, [c622] VARCHAR(255) SPARSE NULL, [c623] VARCHAR(255) SPARSE NULL, [c624] VARCHAR(255) SPARSE NULL, [c625] VARCHAR(255) SPARSE NULL, [c626] VARCHAR(255) SPARSE NULL, [c627] VARCHAR(255) SPARSE NULL, [c628] VARCHAR(255) SPARSE NULL, [c629] VARCHAR(255) SPARSE NULL,	[c630] VARCHAR(255) SPARSE NULL, [c631] VARCHAR(255) SPARSE NULL, [c632] VARCHAR(255) SPARSE NULL, [c633] VARCHAR(255) SPARSE NULL, [c634] VARCHAR(255) SPARSE NULL, [c635] VARCHAR(255) SPARSE NULL, [c636] VARCHAR(255) SPARSE NULL, [c637] VARCHAR(255) SPARSE NULL, [c638] VARCHAR(255) SPARSE NULL, [c639] VARCHAR(255) SPARSE NULL,	[c640] VARCHAR(255) SPARSE NULL, [c641] VARCHAR(255) SPARSE NULL, [c642] VARCHAR(255) SPARSE NULL, [c643] VARCHAR(255) SPARSE NULL, [c644] VARCHAR(255) SPARSE NULL, [c645] VARCHAR(255) SPARSE NULL, [c646] VARCHAR(255) SPARSE NULL, [c647] VARCHAR(255) SPARSE NULL, [c648] VARCHAR(255) SPARSE NULL, [c649] VARCHAR(255) SPARSE NULL,	[c650] VARCHAR(255) SPARSE NULL, [c651] VARCHAR(255) SPARSE NULL, [c652] VARCHAR(255) SPARSE NULL, [c653] VARCHAR(255) SPARSE NULL, [c654] VARCHAR(255) SPARSE NULL, [c655] VARCHAR(255) SPARSE NULL, [c656] VARCHAR(255) SPARSE NULL, [c657] VARCHAR(255) SPARSE NULL, [c658] VARCHAR(255) SPARSE NULL, [c659] VARCHAR(255) SPARSE NULL,	[c660] VARCHAR(255) SPARSE NULL, [c661] VARCHAR(255) SPARSE NULL, [c662] VARCHAR(255) SPARSE NULL, [c663] VARCHAR(255) SPARSE NULL, [c664] VARCHAR(255) SPARSE NULL, [c665] VARCHAR(255) SPARSE NULL, [c666] VARCHAR(255) SPARSE NULL, [c667] VARCHAR(255) SPARSE NULL, [c668] VARCHAR(255) SPARSE NULL, [c669] VARCHAR(255) SPARSE NULL,	[c670] VARCHAR(255) SPARSE NULL, [c671] VARCHAR(255) SPARSE NULL, [c672] VARCHAR(255) SPARSE NULL, [c673] VARCHAR(255) SPARSE NULL, [c674] VARCHAR(255) SPARSE NULL, [c675] VARCHAR(255) SPARSE NULL, [c676] VARCHAR(255) SPARSE NULL, [c677] VARCHAR(255) SPARSE NULL, [c678] VARCHAR(255) SPARSE NULL, [c679] VARCHAR(255) SPARSE NULL,	[c680] VARCHAR(255) SPARSE NULL, [c681] VARCHAR(255) SPARSE NULL, [c682] VARCHAR(255) SPARSE NULL, [c683] VARCHAR(255) SPARSE NULL, [c684] VARCHAR(255) SPARSE NULL, [c685] VARCHAR(255) SPARSE NULL, [c686] VARCHAR(255) SPARSE NULL, [c687] VARCHAR(255) SPARSE NULL, [c688] VARCHAR(255) SPARSE NULL, [c689] VARCHAR(255) SPARSE NULL,	[c690] VARCHAR(255) SPARSE NULL, [c691] VARCHAR(255) SPARSE NULL, [c692] VARCHAR(255) SPARSE NULL, [c693] VARCHAR(255) SPARSE NULL, [c694] VARCHAR(255) SPARSE NULL, [c695] VARCHAR(255) SPARSE NULL, [c696] VARCHAR(255) SPARSE NULL, [c697] VARCHAR(255) SPARSE NULL, [c698] VARCHAR(255) SPARSE NULL, [c699] VARCHAR(255) SPARSE NULL,
	[c700] VARCHAR(255) SPARSE NULL, [c701] VARCHAR(255) SPARSE NULL, [c702] VARCHAR(255) SPARSE NULL, [c703] VARCHAR(255) SPARSE NULL, [c704] VARCHAR(255) SPARSE NULL, [c705] VARCHAR(255) SPARSE NULL, [c706] VARCHAR(255) SPARSE NULL, [c707] VARCHAR(255) SPARSE NULL, [c708] VARCHAR(255) SPARSE NULL, [c709] VARCHAR(255) SPARSE NULL,	[c710] VARCHAR(255) SPARSE NULL, [c711] VARCHAR(255) SPARSE NULL, [c712] VARCHAR(255) SPARSE NULL, [c713] VARCHAR(255) SPARSE NULL, [c714] VARCHAR(255) SPARSE NULL, [c715] VARCHAR(255) SPARSE NULL, [c716] VARCHAR(255) SPARSE NULL, [c717] VARCHAR(255) SPARSE NULL, [c718] VARCHAR(255) SPARSE NULL, [c719] VARCHAR(255) SPARSE NULL,	[c720] VARCHAR(255) SPARSE NULL, [c721] VARCHAR(255) SPARSE NULL, [c722] VARCHAR(255) SPARSE NULL, [c723] VARCHAR(255) SPARSE NULL, [c724] VARCHAR(255) SPARSE NULL, [c725] VARCHAR(255) SPARSE NULL, [c726] VARCHAR(255) SPARSE NULL, [c727] VARCHAR(255) SPARSE NULL, [c728] VARCHAR(255) SPARSE NULL, [c729] VARCHAR(255) SPARSE NULL,	[c730] VARCHAR(255) SPARSE NULL, [c731] VARCHAR(255) SPARSE NULL, [c732] VARCHAR(255) SPARSE NULL, [c733] VARCHAR(255) SPARSE NULL, [c734] VARCHAR(255) SPARSE NULL, [c735] VARCHAR(255) SPARSE NULL, [c736] VARCHAR(255) SPARSE NULL, [c737] VARCHAR(255) SPARSE NULL, [c738] VARCHAR(255) SPARSE NULL, [c739] VARCHAR(255) SPARSE NULL,	[c740] VARCHAR(255) SPARSE NULL, [c741] VARCHAR(255) SPARSE NULL, [c742] VARCHAR(255) SPARSE NULL, [c743] VARCHAR(255) SPARSE NULL, [c744] VARCHAR(255) SPARSE NULL, [c745] VARCHAR(255) SPARSE NULL, [c746] VARCHAR(255) SPARSE NULL, [c747] VARCHAR(255) SPARSE NULL, [c748] VARCHAR(255) SPARSE NULL, [c749] VARCHAR(255) SPARSE NULL,	[c750] VARCHAR(255) SPARSE NULL, [c751] VARCHAR(255) SPARSE NULL, [c752] VARCHAR(255) SPARSE NULL, [c753] VARCHAR(255) SPARSE NULL, [c754] VARCHAR(255) SPARSE NULL, [c755] VARCHAR(255) SPARSE NULL, [c756] VARCHAR(255) SPARSE NULL, [c757] VARCHAR(255) SPARSE NULL, [c758] VARCHAR(255) SPARSE NULL, [c759] VARCHAR(255) SPARSE NULL,	[c760] VARCHAR(255) SPARSE NULL, [c761] VARCHAR(255) SPARSE NULL, [c762] VARCHAR(255) SPARSE NULL, [c763] VARCHAR(255) SPARSE NULL, [c764] VARCHAR(255) SPARSE NULL, [c765] VARCHAR(255) SPARSE NULL, [c766] VARCHAR(255) SPARSE NULL, [c767] VARCHAR(255) SPARSE NULL, [c768] VARCHAR(255) SPARSE NULL, [c769] VARCHAR(255) SPARSE NULL,	[c770] VARCHAR(255) SPARSE NULL, [c771] VARCHAR(255) SPARSE NULL, [c772] VARCHAR(255) SPARSE NULL, [c773] VARCHAR(255) SPARSE NULL, [c774] VARCHAR(255) SPARSE NULL, [c775] VARCHAR(255) SPARSE NULL, [c776] VARCHAR(255) SPARSE NULL, [c777] VARCHAR(255) SPARSE NULL, [c778] VARCHAR(255) SPARSE NULL, [c779] VARCHAR(255) SPARSE NULL,	[c780] VARCHAR(255) SPARSE NULL, [c781] VARCHAR(255) SPARSE NULL, [c782] VARCHAR(255) SPARSE NULL, [c783] VARCHAR(255) SPARSE NULL, [c784] VARCHAR(255) SPARSE NULL, [c785] VARCHAR(255) SPARSE NULL, [c786] VARCHAR(255) SPARSE NULL, [c787] VARCHAR(255) SPARSE NULL, [c788] VARCHAR(255) SPARSE NULL, [c789] VARCHAR(255) SPARSE NULL,	[c790] VARCHAR(255) SPARSE NULL, [c791] VARCHAR(255) SPARSE NULL, [c792] VARCHAR(255) SPARSE NULL, [c793] VARCHAR(255) SPARSE NULL, [c794] VARCHAR(255) SPARSE NULL, [c795] VARCHAR(255) SPARSE NULL, [c796] VARCHAR(255) SPARSE NULL, [c797] VARCHAR(255) SPARSE NULL, [c798] VARCHAR(255) SPARSE NULL, [c799] VARCHAR(255) SPARSE NULL,
	[c800] VARCHAR(255) SPARSE NULL, [c801] VARCHAR(255) SPARSE NULL, [c802] VARCHAR(255) SPARSE NULL, [c803] VARCHAR(255) SPARSE NULL, [c804] VARCHAR(255) SPARSE NULL, [c805] VARCHAR(255) SPARSE NULL, [c806] VARCHAR(255) SPARSE NULL, [c807] VARCHAR(255) SPARSE NULL, [c808] VARCHAR(255) SPARSE NULL, [c809] VARCHAR(255) SPARSE NULL,	[c810] VARCHAR(255) SPARSE NULL, [c811] VARCHAR(255) SPARSE NULL, [c812] VARCHAR(255) SPARSE NULL, [c813] VARCHAR(255) SPARSE NULL, [c814] VARCHAR(255) SPARSE NULL, [c815] VARCHAR(255) SPARSE NULL, [c816] VARCHAR(255) SPARSE NULL, [c817] VARCHAR(255) SPARSE NULL, [c818] VARCHAR(255) SPARSE NULL, [c819] VARCHAR(255) SPARSE NULL,	[c820] VARCHAR(255) SPARSE NULL, [c821] VARCHAR(255) SPARSE NULL, [c822] VARCHAR(255) SPARSE NULL, [c823] VARCHAR(255) SPARSE NULL, [c824] VARCHAR(255) SPARSE NULL, [c825] VARCHAR(255) SPARSE NULL, [c826] VARCHAR(255) SPARSE NULL, [c827] VARCHAR(255) SPARSE NULL, [c828] VARCHAR(255) SPARSE NULL, [c829] VARCHAR(255) SPARSE NULL,	[c830] VARCHAR(255) SPARSE NULL, [c831] VARCHAR(255) SPARSE NULL, [c832] VARCHAR(255) SPARSE NULL, [c833] VARCHAR(255) SPARSE NULL, [c834] VARCHAR(255) SPARSE NULL, [c835] VARCHAR(255) SPARSE NULL, [c836] VARCHAR(255) SPARSE NULL, [c837] VARCHAR(255) SPARSE NULL, [c838] VARCHAR(255) SPARSE NULL, [c839] VARCHAR(255) SPARSE NULL,	[c840] VARCHAR(255) SPARSE NULL, [c841] VARCHAR(255) SPARSE NULL, [c842] VARCHAR(255) SPARSE NULL, [c843] VARCHAR(255) SPARSE NULL, [c844] VARCHAR(255) SPARSE NULL, [c845] VARCHAR(255) SPARSE NULL, [c846] VARCHAR(255) SPARSE NULL, [c847] VARCHAR(255) SPARSE NULL, [c848] VARCHAR(255) SPARSE NULL, [c849] VARCHAR(255) SPARSE NULL,	[c850] VARCHAR(255) SPARSE NULL, [c851] VARCHAR(255) SPARSE NULL, [c852] VARCHAR(255) SPARSE NULL, [c853] VARCHAR(255) SPARSE NULL, [c854] VARCHAR(255) SPARSE NULL, [c855] VARCHAR(255) SPARSE NULL, [c856] VARCHAR(255) SPARSE NULL, [c857] VARCHAR(255) SPARSE NULL, [c858] VARCHAR(255) SPARSE NULL, [c859] VARCHAR(255) SPARSE NULL,	[c860] VARCHAR(255) SPARSE NULL, [c861] VARCHAR(255) SPARSE NULL, [c862] VARCHAR(255) SPARSE NULL, [c863] VARCHAR(255) SPARSE NULL, [c864] VARCHAR(255) SPARSE NULL, [c865] VARCHAR(255) SPARSE NULL, [c866] VARCHAR(255) SPARSE NULL, [c867] VARCHAR(255) SPARSE NULL, [c868] VARCHAR(255) SPARSE NULL, [c869] VARCHAR(255) SPARSE NULL,	[c870] VARCHAR(255) SPARSE NULL, [c871] VARCHAR(255) SPARSE NULL, [c872] VARCHAR(255) SPARSE NULL, [c873] VARCHAR(255) SPARSE NULL, [c874] VARCHAR(255) SPARSE NULL, [c875] VARCHAR(255) SPARSE NULL, [c876] VARCHAR(255) SPARSE NULL, [c877] VARCHAR(255) SPARSE NULL, [c878] VARCHAR(255) SPARSE NULL, [c879] VARCHAR(255) SPARSE NULL,	[c880] VARCHAR(255) SPARSE NULL, [c881] VARCHAR(255) SPARSE NULL, [c882] VARCHAR(255) SPARSE NULL, [c883] VARCHAR(255) SPARSE NULL, [c884] VARCHAR(255) SPARSE NULL, [c885] VARCHAR(255) SPARSE NULL, [c886] VARCHAR(255) SPARSE NULL, [c887] VARCHAR(255) SPARSE NULL, [c888] VARCHAR(255) SPARSE NULL, [c889] VARCHAR(255) SPARSE NULL,	[c890] VARCHAR(255) SPARSE NULL, [c891] VARCHAR(255) SPARSE NULL, [c892] VARCHAR(255) SPARSE NULL, [c893] VARCHAR(255) SPARSE NULL, [c894] VARCHAR(255) SPARSE NULL, [c895] VARCHAR(255) SPARSE NULL, [c896] VARCHAR(255) SPARSE NULL, [c897] VARCHAR(255) SPARSE NULL, [c898] VARCHAR(255) SPARSE NULL, [c899] VARCHAR(255) SPARSE NULL,
	[c900] VARCHAR(255) SPARSE NULL, [c901] VARCHAR(255) SPARSE NULL, [c902] VARCHAR(255) SPARSE NULL, [c903] VARCHAR(255) SPARSE NULL, [c904] VARCHAR(255) SPARSE NULL, [c905] VARCHAR(255) SPARSE NULL, [c906] VARCHAR(255) SPARSE NULL, [c907] VARCHAR(255) SPARSE NULL, [c908] VARCHAR(255) SPARSE NULL, [c909] VARCHAR(255) SPARSE NULL,	[c910] VARCHAR(255) SPARSE NULL, [c911] VARCHAR(255) SPARSE NULL, [c912] VARCHAR(255) SPARSE NULL, [c913] VARCHAR(255) SPARSE NULL, [c914] VARCHAR(255) SPARSE NULL, [c915] VARCHAR(255) SPARSE NULL, [c916] VARCHAR(255) SPARSE NULL, [c917] VARCHAR(255) SPARSE NULL, [c918] VARCHAR(255) SPARSE NULL, [c919] VARCHAR(255) SPARSE NULL, 	[c920] VARCHAR(255) SPARSE NULL, [c921] VARCHAR(255) SPARSE NULL, [c922] VARCHAR(255) SPARSE NULL, [c923] VARCHAR(255) SPARSE NULL, [c924] VARCHAR(255) SPARSE NULL, [c925] VARCHAR(255) SPARSE NULL, [c926] VARCHAR(255) SPARSE NULL, [c927] VARCHAR(255) SPARSE NULL, [c928] VARCHAR(255) SPARSE NULL, [c929] VARCHAR(255) SPARSE NULL,	[c930] VARCHAR(255) SPARSE NULL, [c931] VARCHAR(255) SPARSE NULL, [c932] VARCHAR(255) SPARSE NULL, [c933] VARCHAR(255) SPARSE NULL, [c934] VARCHAR(255) SPARSE NULL, [c935] VARCHAR(255) SPARSE NULL, [c936] VARCHAR(255) SPARSE NULL, [c937] VARCHAR(255) SPARSE NULL, [c938] VARCHAR(255) SPARSE NULL, [c939] VARCHAR(255) SPARSE NULL,	[c940] VARCHAR(255) SPARSE NULL, [c941] VARCHAR(255) SPARSE NULL, [c942] VARCHAR(255) SPARSE NULL, [c943] VARCHAR(255) SPARSE NULL, [c944] VARCHAR(255) SPARSE NULL, [c945] VARCHAR(255) SPARSE NULL, [c946] VARCHAR(255) SPARSE NULL, [c947] VARCHAR(255) SPARSE NULL, [c948] VARCHAR(255) SPARSE NULL, [c949] VARCHAR(255) SPARSE NULL,	[c950] VARCHAR(255) SPARSE NULL, [c951] VARCHAR(255) SPARSE NULL, [c952] VARCHAR(255) SPARSE NULL, [c953] VARCHAR(255) SPARSE NULL, [c954] VARCHAR(255) SPARSE NULL, [c955] VARCHAR(255) SPARSE NULL, [c956] VARCHAR(255) SPARSE NULL, [c957] VARCHAR(255) SPARSE NULL, [c958] VARCHAR(255) SPARSE NULL, [c959] VARCHAR(255) SPARSE NULL,	[c960] VARCHAR(255) SPARSE NULL, [c961] VARCHAR(255) SPARSE NULL, [c962] VARCHAR(255) SPARSE NULL, [c963] VARCHAR(255) SPARSE NULL, [c964] VARCHAR(255) SPARSE NULL, [c965] VARCHAR(255) SPARSE NULL, [c966] VARCHAR(255) SPARSE NULL, [c967] VARCHAR(255) SPARSE NULL, [c968] VARCHAR(255) SPARSE NULL, [c969] VARCHAR(255) SPARSE NULL,	[c970] VARCHAR(255) SPARSE NULL, [c971] VARCHAR(255) SPARSE NULL, [c972] VARCHAR(255) SPARSE NULL, [c973] VARCHAR(255) SPARSE NULL, [c974] VARCHAR(255) SPARSE NULL, [c975] VARCHAR(255) SPARSE NULL, [c976] VARCHAR(255) SPARSE NULL, [c977] VARCHAR(255) SPARSE NULL, [c978] VARCHAR(255) SPARSE NULL, [c979] VARCHAR(255) SPARSE NULL,  	[c980] VARCHAR(255) SPARSE NULL, [c981] VARCHAR(255) SPARSE NULL, [c982] VARCHAR(255) SPARSE NULL, [c983] VARCHAR(255) SPARSE NULL, [c984] VARCHAR(255) SPARSE NULL, [c985] VARCHAR(255) SPARSE NULL, [c986] VARCHAR(255) SPARSE NULL, [c987] VARCHAR(255) SPARSE NULL, [c988] VARCHAR(255) SPARSE NULL, [c989] VARCHAR(255) SPARSE NULL,	[c990] VARCHAR(255) SPARSE NULL, [c991] VARCHAR(255) SPARSE NULL, [c992] VARCHAR(255) SPARSE NULL, [c993] VARCHAR(255) SPARSE NULL, [c994] VARCHAR(255) SPARSE NULL, [c995] VARCHAR(255) SPARSE NULL, [c996] VARCHAR(255) SPARSE NULL, [c997] VARCHAR(255) SPARSE NULL, [c998] VARCHAR(255) SPARSE NULL, [c999] VARCHAR(255) SPARSE NULL,
	[c1000] VARCHAR(255) SPARSE NULL);
GO

CREATE CLUSTERED INDEX [SparseInsertOne_CL]
	ON [SparseInsertOne] ([ID]);


DECLARE @TestID INT;
DECLARE @DBID INT;

DECLARE @RandomValue INT;
DECLARE @Type INT;
DECLARE @NameLength INT;
DECLARE @ColumnStart INT;

DECLARE @RowLoop INT = 1;
DECLARE @ColumnLoop INT;

DECLARE @ExecString VARCHAR (8000);
DECLARE @ExecString2 VARCHAR (8000);
DECLARE @NameString VARCHAR (1000);
SET @NameString = '';
DECLARE @MaxID INT;
DECLARE @col1Name VARCHAR(100);
DECLARE @col1Value VARCHAR(100);

/* Setup test info */

INSERT INTO [SparseTracking].[dbo].[TrackTests] ([TestName]) VALUES ('SparseInsertOne');
SELECT @TestID = MAX(TestID) FROM [SparseTracking].[dbo].[TrackTests];
SELECT @DBID = DB_ID();

/* Capture file stats */

IF EXISTS (SELECT * FROM [tempdb].[sys].[objects] WHERE [name] = N'##SQLskillsFileStats1')
  DROP TABLE [##SQLskillsFileStats1];
 
IF EXISTS (SELECT * FROM [tempdb].[sys].[objects] WHERE [name] = N'##SQLskillsFileStats2')
  DROP TABLE [##SQLskillsFileStats2];

SELECT [database_id], [file_id], [sample_ms], [num_of_reads], [num_of_bytes_read], [io_stall_read_ms],
[num_of_writes], [num_of_bytes_written], [io_stall_write_ms], [io_stall]
INTO ##SQLskillsFileStats1
FROM sys.dm_io_virtual_file_stats(@DBID, NULL)


/* Capture wait stats */

IF EXISTS (SELECT * FROM [tempdb].[sys].[objects] WHERE [name] = N'##SQLskillsWaitStats1')
  DROP TABLE [##SQLskillsWaitStats1];
 
IF EXISTS (SELECT * FROM [tempdb].[sys].[objects] WHERE [name] = N'##SQLskillsWaitStats2')
  DROP TABLE [##SQLskillsWaitStats2];

SELECT [wait_type], [waiting_tasks_count], [wait_time_ms],
  [max_wait_time_ms], [signal_wait_time_ms]
INTO ##SQLskillsWaitStats1
FROM sys.dm_os_wait_stats;

/* set start time */
UPDATE [SparseTracking].[dbo].[TrackTests] SET [TestStartTime] = SYSDATETIME() WHERE [TestID] = @TestID;


-- insert all values for [SparseInsertOne] table
WHILE (@RowLoop < 10000001) 
BEGIN

	-- Calculate doc name length
	SET @NameLength = CONVERT (INT, RAND () * 100) + 1;
	SET @Type = CONVERT (INT, RAND () * 49) + 1;
	SET @ColumnStart = @Type * 20;
	
		-- Get the random document name
	SELECT @ColumnLoop = 0;
	WHILE (@ColumnLoop < @NameLength)
	BEGIN
		SELECT @NameString = @NameString + CHAR (97 +
			CONVERT (INT, RAND () * 26));
		SELECT @ColumnLoop = @ColumnLoop + 1;
	END;

	SELECT @ExecString2 = 
	'INSERT INTO [SparseInsertOne] ([Name], [Type]) VALUES (''' + @NameString + ''', ' + CAST(@Type AS VARCHAR(10)) +')'
	EXEC (@ExecString2)

	-- Add the columns we're inserting into
	SELECT @ColumnLoop = @ColumnStart;
	SELECT @ExecString = ' [c' +
		CAST (@ColumnLoop AS VARCHAR);
	SELECT @ColumnLoop = @ColumnLoop + 1;
	WHILE (@ColumnLoop < (@ColumnStart + 20))
	BEGIN
		SELECT @ExecString = @ExecString + '] = ' + CAST (CONVERT (INT, RAND () * 100000) AS VARCHAR) + ','
		SELECT @ExecString = @ExecString + '[c' + CAST(@ColumnLoop AS VARCHAR);
		SELECT @ColumnLoop = @ColumnLoop + 1;
	END;
	SELECT @ExecString = @ExecString + '] = ' + CAST (CONVERT (INT, RAND () * 100000) AS VARCHAR)

	SELECT @MaxID = MAX(ID) FROM [SparseInsertOne]

	SELECT @ExecString2 =
		'UPDATE [SparseInsertOne] SET ' + @ExecString + ' WHERE ID = ' + CAST(@MaxID AS VARCHAR(10))
	EXEC (@ExecString2);

	SELECT @RowLoop = @RowLoop + 1;
	SET @NameString = ''
END;

/* set the stop time */
UPDATE [SparseTracking].[dbo].[TrackTests] SET [TestEndTime] = SYSDATETIME() WHERE [TestID] = @TestID;

/* capture wait stats again */
SELECT [wait_type], [waiting_tasks_count], [wait_time_ms],
  [max_wait_time_ms], [signal_wait_time_ms]
INTO ##SQLskillsWaitStats2
FROM sys.dm_os_wait_stats;

/* capture file stats again */
SELECT [database_id], [file_id], [sample_ms], [num_of_reads], [num_of_bytes_read], [io_stall_read_ms],
[num_of_writes], [num_of_bytes_written], [io_stall_write_ms], [io_stall]
INTO ##SQLskillsFileStats2
FROM sys.dm_io_virtual_file_stats(@DBID, NULL)

/* capture index stats */
INSERT INTO [SparseTracking].[dbo].[IndexStats]
           ([TestID]
           ,[database_id]
           ,[object_id]
           ,[index_id]
           ,[partition_number]
           ,[index_type_desc]
           ,[alloc_unit_type_desc]
           ,[index_depth]
           ,[index_level]
           ,[avg_fragmentation_in_percent]
           ,[fragment_count]
           ,[avg_fragment_size_in_pages]
           ,[page_count]
           ,[avg_page_space_used_in_percent]
           ,[record_count]
           ,[ghost_record_count]
           ,[version_ghost_record_count]
           ,[min_record_size_in_bytes]
           ,[max_record_size_in_bytes]
           ,[avg_record_size_in_bytes]
           ,[forwarded_record_count]
           ,[compressed_page_count])
SELECT @TestID, [database_id],[object_id],[index_id],[partition_number],[index_type_desc],
[alloc_unit_type_desc],[index_depth],[index_level],[avg_fragmentation_in_percent],
[fragment_count],[avg_fragment_size_in_pages],[page_count],[avg_page_space_used_in_percent],
[record_count],[ghost_record_count],[version_ghost_record_count],[min_record_size_in_bytes],
[max_record_size_in_bytes],[avg_record_size_in_bytes],[forwarded_record_count],[compressed_page_count]
from sys.dm_db_index_physical_stats(@DBID, OBJECT_ID(N'SparseInsertOne'),NULL, NULL, 'Detailed');



/* store wait stats */
WITH [DiffWaits] AS
(
  SELECT   -- Waits that weren't in the first snapshot
      [ts2].[wait_type],
      [ts2].[wait_time_ms],
      [ts2].[signal_wait_time_ms],
      [ts2].[waiting_tasks_count]
    FROM [##SQLskillsWaitStats2] AS [ts2]
    LEFT OUTER JOIN [##SQLskillsWaitStats1] AS [ts1]
    ON [ts2].[wait_type] = [ts1].[wait_type]
    WHERE [ts1].[wait_type] IS NULL
    AND [ts2].[wait_time_ms] > 0
  UNION
  SELECT   -- Diff of waits in both snapshots
      [ts2].[wait_type],
      [ts2].[wait_time_ms] - [ts1].[wait_time_ms] AS [wait_time_ms],
      [ts2].[signal_wait_time_ms] - [ts1].[signal_wait_time_ms] AS [signal_wait_time_ms],
      [ts2].[waiting_tasks_count] - [ts1].[waiting_tasks_count] AS [waiting_tasks_count]
    FROM [##SQLskillsWaitStats2] AS [ts2]
    LEFT OUTER JOIN [##SQLskillsWaitStats1] AS [ts1]
    ON [ts2].[wait_type] = [ts1].[wait_type]
    WHERE [ts1].[wait_type] IS NOT NULL
    AND [ts2].[waiting_tasks_count] - [ts1].[waiting_tasks_count] > 0
    AND [ts2].[wait_time_ms] - [ts1].[wait_time_ms] > 0
),
[Waits] AS
(
  SELECT
    [wait_type],
    [wait_time_ms] / 1000.0 AS [WaitS],
    ([wait_time_ms] - [signal_wait_time_ms]) / 1000.0 AS [ResourceS],
    [signal_wait_time_ms] / 1000.0 AS [SignalS],
    [waiting_tasks_count] AS [WaitCount],
    100.0 * [wait_time_ms] / SUM ([wait_time_ms]) OVER() AS [Percentage],
    ROW_NUMBER() OVER(ORDER BY [wait_time_ms] DESC) AS [RowNum]
  FROM [DiffWaits]
  WHERE [wait_type] NOT IN (SELECT WaitType FROM SparseTracking.dbo.WaitsToIgnore)
)


INSERT INTO [SparseTracking].[dbo].[WaitStats]
(
	[TestID],
  [WaitType] ,
  [Wait_S] ,
  [Resource_S] ,
  [Signal_S] ,
  [WaitCount] ,
  [Percentage] ,
  [AvgWait_S] ,
  [AvgRes_S] ,
  [AvgSig_S]
)
SELECT
	@TestID,
  [W1].[wait_type],
  CAST ([W1].[WaitS] AS DECIMAL (16, 2)) ,
  CAST ([W1].[ResourceS] AS DECIMAL (16, 2)) ,
  CAST ([W1].[SignalS] AS DECIMAL (16, 2)) ,
  [W1].[WaitCount] ,
  CAST ([W1].[Percentage] AS DECIMAL (5, 2)) ,
  CAST (([W1].[WaitS] / [W1].[WaitCount]) AS DECIMAL (16, 4)) ,
  CAST (([W1].[ResourceS] / [W1].[WaitCount]) AS DECIMAL (16, 4)) ,
  CAST (([W1].[SignalS] / [W1].[WaitCount]) AS DECIMAL (16, 4))
FROM [Waits] AS [W1]
INNER JOIN [Waits] AS [W2]
ON [W2].[RowNum] <= [W1].[RowNum]
GROUP BY [W1].[RowNum], [W1].[wait_type], [W1].[WaitS], [W1].[ResourceS], 
  [W1].[SignalS], [W1].[WaitCount], [W1].[Percentage]
HAVING SUM ([W2].[Percentage]) - [W1].[Percentage] < 95; -- percentage threshold


/* store file stats */

INSERT INTO [SparseTracking].[dbo].[FileStats]
           ([TestID]
           ,[database_id]
           ,[file_id]
           ,[sample_ms]
           ,[num_of_reads]
           ,[num_of_bytes_read]
           ,[io_stall_read_ms]
           ,[num_of_writes]
           ,[num_of_bytes_written]
           ,[io_stall_write_ms]
           ,[io_stall])
SELECT
@TestID,
f.database_id, f.file_id, 
(f.sample_ms - i.sample_ms) AS sample_ms, 
(f.num_of_reads - i.num_of_reads) AS num_of_reads,
(f.num_of_bytes_read - i.num_of_bytes_read ) AS num_of_bytes_read,
(f.io_stall_read_ms - i.io_stall_read_ms ) AS io_stall_read_ms,
(f.num_of_writes - i.num_of_writes ) AS num_of_writes,
(f.num_of_bytes_written - i.num_of_bytes_written ) AS num_of_bytes_written,
(f.io_stall_write_ms - i.io_stall_write_ms ) AS io_stall_write_ms,
(f.io_stall - i.io_stall ) AS io_stall
FROM ##SQLskillsFileStats1 i
JOIN ##SQLskillsFileStats2 f on i.database_id = f.database_id and i.file_id = f.file_id


USE [master];
GO

DROP DATABASE [SparseTest];
GO
